* FILE "func_17.f" is generated by GRACE System (Minami-Tateya Group)
* Grace Version   1. 1          1996-Apr-04
************************************************************************
      FUNCTION FUNC_17(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8     FUNC_17

      PARAMETER ( MXDIM = 50 )
      COMMON /A17_ LOOP0 / LOOP
      COMMON /A17_ BASE1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON /A17_ BASE2 / ACC1,ACC2,ITMX1,ITMX2
      COMMON /A17_ BASE3 / SI,SI2,SWGT,SCHI,SCALLS,ATACC,NSU,IT,WGT

      REAL*8   X(MXDIM)

      INCLUDE 'incl1_17.f'
      INCLUDE 'inclk_17.f'

      COMMON /A17_AMSPIN/JHS(NEXTRN), JHE(NEXTRN), ASPIN
      REAL*8     ANS0, ANS

*  P : Table of four momenta
* PP : Table of inner products
      REAL*8     XX(MXDIM),P(4,NEXTRN),PP(NEXTRN,NEXTRN)
      COMMON /A17_SP4VEC/ VEC(4,NEXTRN)
*=======================================================================
*          Initialization
*=======================================================================

      ANSUM = 0.0D0

      DO  5 I = 1, NDIM
         XX(I) = X(I)
    5 CONTINUE

      NREG  = 1
      DFT   = 0.D0
*=======================================================================
*          Kinem_17atics
*=======================================================================

      DO 1000 IREG = 1 , MXREG

         IF( IREG .GT. NREG ) GO TO 1000

        CALL KINEM_17(NEXTRN, XX, P, PP, YACOB,NREG,IREG,JUMP)

*-----------------------------------------------------------------------
*          Reset the temporal buffer for the region 1
*-----------------------------------------------------------------------
      IF( IREG .EQ. 1 ) THEN
          DFT = 0.D0
          DO 180 K = 1, NEXTRN
          DO 180 J = 1, 4
             VEC(J,K) = 0.D0
  180     CONTINUE
      ENDIF

         IF( JUMP .NE. 0 ) GO TO 1000

*-----------------------------------------------------------------------
*          For user's cut
*-----------------------------------------------------------------------

C    CALL USRCUT(JUMP)
C    IF( JUMP .NE. 0 ) GOTO 1000

*-----------------------------------------------------------------------
*          Four momenta of external particles
*-----------------------------------------------------------------------

      DO 20 I = 1, 4
*           1:  EL-  INITIAL   LPRTCL  MASS=AMEL
        PE0001(I) = P(I,  1)
*           2:  EL+  INITIAL   LANTIP  MASS=AMEL
        PE0002(I) = P(I,  2)
*           3:  DQ-  FINAL     LPRTCL  MASS=AMDQ
        PE0003(I) = P(I,  3)
*           4:  UQ   FINAL     LANTIP  MASS=AMUQ
        PE0004(I) = P(I,  4)
*           5:  NE   FINAL     LPRTCL  MASS=AMNE
        PE0005(I) = P(I,  5)
*           6:  EL+  FINAL     LANTIP  MASS=AMEL
        PE0006(I) = P(I,  6)
   20 CONTINUE

*-----------------------------------------------------------------------
*          Inner products of momenta of external particles
*-----------------------------------------------------------------------

      DO 30 J = 1, NEXTRN
      DO 30 I = 1, NEXTRN
        PPROD(I, J) = PP(I, J)
   30 CONTINUE

*=======================================================================
*          Amplitude calculation
*=======================================================================
*       =============
        CALL AMPTBL_17
*       =============
*       ===================
        CALL AMPSUM_17(ANS0)
*       ===================

        FKNORM = YACOB*ASPIN
        ANS    = ANS0*FKNORM
        ANSUM  = ANSUM + ANS

*-----------------------------------------------------------------------
      CALL KFILL_17(NEXTRN, NDIM, X, P, PP, ANS) 

*-----------------------------------------------------------------------
*          Save four momenta and probabilities of the region 1
*-----------------------------------------------------------------------
      IF( IREG .EQ. 1 ) THEN
          DFT = ANS
          DO 420 K = 1, NEXTRN
          DO 420 J = 1, 4
             VEC(J,K) = P(J,K)
  420     CONTINUE
      ENDIF

*=======================================================================
*          Update summary table
*=======================================================================

        ANSP(0) = ANSP(0) + WGT*ANS
        DO 60 IGR = 1, JGRAPH
          ANSP(IGR)=ANSP(IGR) + WGT*YACOB*ASPIN*ANCP(IGR)
   60   CONTINUE
        NKCALL = NKCALL + 1
        IF(NKCALL.GT.10000) THEN
          NKCALL = NKCALL - 10000
          FKCALL = FKCALL + 10000
        ENDIF

 1000 CONTINUE

      FUNC_17 = ANSUM

*-----------------------------------------------------------------------
*          Put the final 4 vectors into the arrays VEC()
*-----------------------------------------------------------------------
*     IF( FUNC_17 .GT. 0.D0 ) THEN
*         IF( DFT/FUNC_17 .LT. DRN(DUM)) THEN
*             DO 850 K = 1, NEXTRN
*             DO 850 J = 1, 4
*                VEC(J,K) = P(J,K)
* 850         CONTINUE
*         ENDIF
*     ENDIF

      RETURN
      END
