* FILE "kinem_18.f" is generated by GRACE System (Minami-Tateya Group)
* Grace Version   1. 1          1995-Oct-26
************************************************************************
      SUBROUTINE KINEM_18(NEXTRN, X, PE, PP, YACOB, NREG, IREG, JUMP) 

      IMPLICIT REAL* 8(A-H,O-Z)

************************************************************************
      INTEGER NEXTRN 
      PARAMETER ( MXDIM = 50 )
      REAL*8  X(MXDIM) 
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN) 
      REAL*8  YACOB 
      INTEGER NREG, IREG 
      INTEGER JUMP 

*     This subroutine calculates four momenta of external particles.
*
*     Arguments
*       NEXTRN : input  : The number of external particles.
*       X      : input  : Position in the integration volume.
*       PE     : output : Table of four momenta of external particles.
*       PP     : output : Table of inner products of four momenta
*                         between two external particles.
*       YACOB  : output : Normalization for converting square of
*                         amplitude to cross-section.
*       NREG   : in/out : Maximum number of points in the phase space
*                         which correspond to the integration point.
*                         This value is one for the first call
*                         for the same integration point.
*       IREG   : input  : Counter of calling this subroutine for the
*                         same integration point.
*                         same integration point.
*                         Function FUNC_18 increments this variable,
*                         and call this subroutine while (IREG.LE.NREG)
*       JUMP   : output : If this integration point is rejected,
*                         one should set this variable other than one,
*                         otherwize it should be zero.

      INCLUDE 'inclk_18.f'
*-----------------------------------------------------------------------
      JUMP = 0

*     IF(reject this integration point) THEN
*       JUMP = 1 
*       RETURN 
*     ENDIF 

*     IF(IREG.EQ.1) THEN

*       The first call for this phase space point. 
*       If you want to use this subroutine more than once for the same
*       phase space point, change the value of NREG.
*       This subroutine will be called NREG times.

*     ELSE

*       IREG-th call for this phase space point.

*     ENDIF

*     Table of four momenta.

* PE(I, J) : I = 1 -> X, 2 -> Y, ... 4 -> energy, of J-th particle.
*           1:  EL-  INITIAL   LPRTCL  MASS=AMEL
      PE( 1, 1) = x( 1)
      PE( 2, 1) = x( 2)
      PE( 3, 1) = x( 3)
      PE( 4, 1) = x( 4)
*           2:  EL+  INITIAL   LANTIP  MASS=AMEL
      PE( 1, 2) = x( 5)
      PE( 2, 2) = x( 6)
      PE( 3, 2) = x( 7)
      PE( 4, 2) = x( 8)
*           3:  MU-  FINAL     LPRTCL  MASS=AMMU
      PE( 1, 3) = x(11)
      PE( 2, 3) = x(12)
      PE( 3, 3) = x(13)
      PE( 4, 3) = x(14)
*           4:  NM   FINAL     LANTIP  MASS=AMNM
      PE( 1, 4) = x(21)
      PE( 2, 4) = x(22)
      PE( 3, 4) = x(23)
      PE( 4, 4) = x(24)
*           5:  UQ   FINAL     LPRTCL  MASS=AMUQ
      PE( 1, 5) = x(31)
      PE( 2, 5) = x(32)
      PE( 3, 5) = x(33)
      PE( 4, 5) = x(34)
*           6:  DQ+  FINAL     LANTIP  MASS=AMDQ
      PE( 1, 6) = x(41)
      PE( 2, 6) = x(42)
      PE( 3, 6) = x(43)
      PE( 4, 6) = x(44)

*     Set table of inner products of momenta.
*     This table should be calculated from invariants.
*     When it is constructed from PE,it will not so accurate.
*
*     PP(I,J) = inner product between PE(*,I) and PE(*,J)

      do i=1,6
        do j=1,6
          pp(i,j) = pe(4,i)*pe(4,j) 
     &         -pe(1,i)*pe(1,j) -pe(2,i)*pe(2,j) -pe(3,i)*pe(3,j)
        enddo
      enddo
 
*     Normalization factor

      YACOB = 1d0

      RETURN
      END
