*     (c)copyright           KORAL         Group, Poland
*     (c)copyright           Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
************************************************************************
      SUBROUTINE gr_init(ibackgr,XPAR,NPAR,SIN2W,GPICOB,AMAFIN)
************************************************************************
* ibackgr = 0  - doubly resonant W-pairs
* ibackgr = 1  - complete 4fermion process
************************************************************************
      implicit real*8(a-h,o-z)

******************
      DIMENSION  XPAR (100),NPAR (100)
      DIMENSION  AMAFIN(20)
******************
*=======================================================================
*          parameters for amplitude calculation
*=======================================================================

*         ============= Set global parameters
           call usrprm
*         =============

*=======================================================================
*================== KORALW overrides Mass and Width ====================
*=======================================================================
*         ====================================================
           CALL SM_KORALW(ibackgr,XPAR,NPAR,SIN2W,GPICOB,AMAFIN)
*         ====================================================
*=======================================================================
*=======================================================================
*         ============= select process
           call procdb
*         =============

*         ============= select kinematics
           call kinmdb
*         =============

*         ============= coupling constants
           call amparm
*         =============
      return
      end
*     (c)copyright           KORAL         Group, Poland
*     (c)copyright           Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
************************************************************************
      SUBROUTINE gr_rinit(ib)
************************************************************************
* ib type of the final state 
************************************************************************
      implicit real*8(a-h,o-z)

******************
*=======================================================================
*          parameters for amplitude calculation
*=======================================================================

*         ============= Set global parameters
           call rusrprm(ib)
*         =============

*         ============= select process
           call procdb
*         =============

*         ============= select kinematics
           call kinmdb
*         =============

*         ============= coupling constants
!           call amparm
*         =============
      return
      end

* File usrprm.f generated by  "grc4f"
* 
*          Fortran source code generator
*     (c)copyright 1990-1996 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
************************************************************************
      subroutine rusrprm(i)
      implicit real*8(a-h,o-z)

      include 'incl1.f'
      include 'inclk.f'
      common /chcntl/ jwidth
      common /grc4fs/ nthprc
*-----------------------------------------------------------------------
* 
* Set global parameters.
* 
*     Process No.
      nthprc = i
*     Set quark-mass = 0.(jqmass = 1 )
      jqmass = 1
*     running width (1:fixed / 0:run)
      jwidth = 0

      return
      end






