
      SUBROUTINE AMPINI(XPAR,NPAR)
! ********************************
! Initialization of the external 4fermion matrix el. codes
! XPAR(100),NPAR(100): input parameter matrices of KORALW as explained in
!                      the manual
! For the moment only GRACE is interfaced
! ********************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  XPAR (100),NPAR (100) 
      DIMENSION AMAFIN(20), ig_uni(4), dg_uni(4)

! parameters for 4fermion amplitudes
      COMMON /AM4PAR/ INPAR(100),YXPAR(100),YAMAFIN(20),YSIN2W,YGPICOB

! additional information can be obtained with the help of routine
      CALL MASOW(SIN2W,GPICOB,AMAFIN)
!     where sin2w is a sine of weinberg angle 
!     and   AMAFIN contained masses of W decay products
!     all as printed by the KORALW
!

! filling /AM4PAR/
      do ii=1,100
        inpar(ii) = npar(ii)
        yxpar(ii) = xpar(ii)
      enddo
      do ii=1,20
        yamafin(ii) = amafin(ii)
      enddo
      ygpicob =gpicob
      ysin2w = sin2w
! end  filling /AM4PAR/

      WRITE(6,'(10X,A)')
     $         '*******************************************************'
      WRITE(6,'(10X,A)')
     $         '****** AMPINI: external library initialization ********'
      WRITE(6,'(10X,A)')
     $         '*******************************************************'
      WRITE(6,*) ' '

! here users code should come

      WRITE(6,'(10X,A)') 
     $         '*******************************************************'
      WRITE(6,'(10X,A)') 
     $         '************* AMPINI -- GRACE activation **************'
      WRITE(6,'(10X,A/)') 
     $         '*******************************************************'
      WRITE(*,'(20X,A/)') 'GRACE   Ver.   1. 1'
      WRITE(*,'(10X,A/)')
     .'(c)Copyright 1990-1994 Minami-Tateya Group (KEK, Japan)     '
      WRITE(6,'(10X,A)') 
     $         '*******************************************************'

      KeyPhy = NPAR(2)
      KeyZet = MOD(KeyPhy,1000)/100
      KeyWu  = MOD(KeyPhy,1000000)/100000

      if( keyzet.ne.1 ) then
        write(6,*)'AMPINI==> Sorry, not implemented: KeyZet =',keyzet
!        stop
      endif
      if( keywu.ne.1 ) then
        write(6,*)'AMPINI==> Sorry, not implemented: KeyWu =',keywu
!        stop
      endif

! setups - gauge
!   unitary
      ig_uni(1) = 0
      ig_uni(2) = 0
      ig_uni(3) = 0
      ig_uni(4) = 0

      dg_uni(1) = 1d0
      dg_uni(2) = 1d0
      dg_uni(3) = 1d0
      dg_uni(4) = 1d0

! other setups
      ihiggs = 0
      iweak = 1

      ibac = 100*iweak +10*ihiggs + 1

      call grace_init(ibac,ig_uni,dg_uni,XPAR,NPAR,SIN2W,GPICOB,AMAFIN)
         
      END


