      SUBROUTINE SETMS_KORALW
     %   (KEYALL,IGAUGE,DGAUGE,XPAR,NPAR,SIN2W,GPICOB,AMAFIN)
************************************************************************
! Overwrites GRACE initialisation according to KORALW needs
! KEYALL = 100*IWEAK +10*IHIGGS +IBACKGR
!   ibackgr = 0  - doubly resonant W-pairs
!           = 1  - all 4-fermion
!   ihiggs  = 0  - no higgs
!           = 1  - with higgs (watch out for mass set-up !!)
!   iweak   = 0  - no weak (not sure what that means...)
!           = 1  - with weak
!   gauges
!   - unitary
!       igauge(1,..,4) = 0 
!       dgauge(1,..,4) = anything (re-set to 1d20 anyway)
!   - covariant
!       igauge(1,..,4) = 1,..,4 
!       dgauge(1,..,4) = anything (eg, 1,..,4) 
************************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION  XPAR (100),NPAR (100) 
      DIMENSION  AMAFIN(20), DGAUGE(4), IGAUGE(4)

!************ GRACE stuff ******************
      INCLUDE 'incl1.f'
      INCLUDE 'inclk.f'
      COMMON /AMSPIN/JHS(NEXTRN), JHE(NEXTRN), ASPIN
!************ end GRACE stuff ******************
*-----------------------------------------------------------------------

!************ KORALW stuff ******************
      ALFWIN  = XPAR(3)
      ALPHAW  = 1D0/ ALFWIN
      XAMAZ   = XPAR(4)
      GAMMZ   = XPAR(5)
      XAMAW   = XPAR(6)
      GAMMW   = XPAR(7)
!************ end KORALW stuff ******************

      ibackgr = MOD(KeyAll,10)
      ihiggs  = MOD(KeyAll,100)/10
      iweak   = MOD(KeyAll,1000)/100

* Constants

      GEVPB = GPICOB
      ALPHA = ALPHAW

*
! Signals:  mnBudB 2,3,15 (81)
! Signals:  enBudB 2,3,26 (71)
! Signals:  mnBeBn 40,41,63 (87)
! Signals:  enBeBn 84,85,117 (77)

! Signals:  uBdmBn 2,3,25
! Signals:  uBdeBn 46,47,69
      IF(IBACKGR.EQ.0) THEN
* Graph selection (1) -- W-pairs
        DO NG = 1, NGRAPH
          JSELG(NG) = 0
        ENDDO
