************************************************************************
      SUBROUTINE SMPRPD(APROP, AMOMQ, AMASSQ, AMAG)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 APROP
      REAL*8     AMOMQ, AMASSQ, AMAG
      save
      data init /0/
*
*    Calculate denominator of propagator.
*
*     APROP  : in/out : product of denominator of propagators.
*     AMOMP  : input  : square of mementum.
*     AMASSQ : input  : square of mass.
*     AMAG   : input  : mass * width.
*-----------------------------------------------------------------------
      if(init.eq.0) then
       init=1
       write(*,*) 'warning from grace 1.1; routine chanel/smprpd:'
       write(*,*) 'Fixed non-zero width is set for  AMOMQ .lt.0, where'
       write(*,*) 'AMOMQ  = square of 4-momentum in bosonic propagator.'
       write(*,*) 'This is to preserve gauge inv. for 4-f processes.'
       write(*,*) 'Please contact J. Fujimoto junpei@minami.kek.jp'
       write(*,*) 'if you want details.'
       endif 
      IF (AMOMQ .GT. 0) THEN
        APROP = - APROP*DCMPLX(AMOMQ - AMASSQ, AMAG)
      ELSE
!        APROP = - APROP*DCMPLX(AMOMQ - AMASSQ, 0.0D0)
! for gauge !
        APROP = - APROP*DCMPLX(AMOMQ - AMASSQ, amag)
      ENDIF
 
*     CALL CTIME('SMPRPD')
      RETURN
      END
