      SUBROUTINE AMPINI(XPAR,NPAR)
c **********************
C Initialization of the external 4fermion matrix el. codes
C XPAR(100),NPAR(100): input parameter matrices of KORALW as explained in
C                      the manual
c **********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  XPAR ( *),NPAR ( *) 
      DIMENSION AMAFIN(20) 

C additional information can be obtained with the help of routine
      CALL MASOW(SIN2W,GPICOB,AMAFIN)
C     where sin2w is a sine of weinberg angle 
C     and   AMAFIN contained masses of W decay products
C     all as printed by the KORALW
C
      WRITE(6,*) '*****************************************************'
      WRITE(6,*) '**** AMPINI: external library initialization ********'
      WRITE(6,*) '**** dummy interface: No 4ferm. libray implemented **'
      WRITE(6,*) '**** but look for comments if you plan to do it *****'
      WRITE(6,*) '*****************************************************'
      WRITE(6,*) '*****************************************************'
      WRITE(6,*) '******************** AMPINW *************************'
      WRITE(6,*) '***** Dimension XPAR(100) NPAR(100) is assumed ******'
      WRITE(6,*) '*****************************************************'
      WRITE(6,*) '*****************************************************'

C here user code should come
         
      END

      SUBROUTINE AMP4F( Q1,IFLBM1, Q2,IFLBM2
     $      ,P1,IFLAV1, P2,IFLAV2, P3,IFLAV3, P4,IFLAV4
     $      , WTMOD4F,WT4F )
! *****************************************************
! external 4fermion matrix elements calculations
! INPUTS
!   q1,q2              - beam 4momenta
!   iflbm1,iflbm2      - beam IDs
!   p1..p4             - final state fermions 4momenta
!   iflav1..iflav4     - final state fermions IDs
! OUTPUTS
!   wtmod4f        - principal weight for rejection
!   wt4f(9)        - auxiliary weights wector
! *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      DIMENSION WT4F(9)
      DIMENSION Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)

        DO I4F=1,9
          WT4F(I4F) = 0D0
        ENDDO
        WTMOD4F = 1D0
      END

      subroutine spdetx(ireco)
! empty
      end

