!         *****************************************************
!         *****************************************************
!         *                                                   *
!         *   Simple demonstration program demo2 for KORALW   *
!         *                                                   *
!         *****************************************************
!         *****************************************************
!
      PROGRAM  main
!     *************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON / inout  / ninp,nout
      COMMON / cglib / blibk(50000)
      SAVE

      NINP= 5
      NOUT=16
      OPEN(NOUT,file='pro.output')
! ============================================================
! Initialization of internal histogramming package GLIBK
! ============================================================
      CALL glimit(20000)
      CALL goutpu(NOUT)

!     **********
      CALL demo2
!     **********
      CLOSE(nout)
      END


      SUBROUTINE demo2
!     ****************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
      COMMON / inout  / ninp,nout
      COMMON / ludat1 / mstu,paru,mstj,parj
      REAL paru(200),parj(200)
      INTEGER mstu(200),mstj(200)
      SAVE / inout  /,/ ludat1 /
      DIMENSION  xpar(100),npar(100)
      CHARACTER*5 CHdumy
!----------------------------------------------------------------------!
! Setting up the anomalous couplings as given in the paper:            !
!     K. Hagiwara, R.D. Peccei, D. Zeppenfeld and K. Hikasa,           !
!                 Nucl. Phys. B282 (1987) 253.                         !
! The variables used in this routine correspond to the following       !
! contants defined in the above paper:                                 !
!           constant name     corresponding variable                   !
!                g_1^V                g1(2)                            !
!                kappa_V              kap(2)                           !
!                lambda_V             lam(2)                           !
!                g_4^V                g4(2)                            !
!                g_5^V                g5(2)                            !
!                kappa-tilde_V        kapt(2)                          !
!                lambda-tilde_V       lamt(2)                          !
!----------------------------------------------------------------------!
! Example of wild random anomalous coupling constants (benchmark)
! Must set KeyACC=1 in order to activate them.
!----------------------------------------------------------------------
      DIMENSION  ypar(100)
!   WWgamma vertex Real part:   g1    kap   lam   g4    g5   kapt lamt
      DATA (ypar(i),i=21,27)
     $   /1.191d0, -.306d0, 1.283d0, -3.16d0, -.743d0, -.605d0, 1.53d0/
!   WWgamma vertex Imag. part:  g1    kap   lam   g4    g5   kapt lamt
      DATA (ypar(i),i=31,37)
     $   /-.801d0, .7237d0,-.496d0, .832d0, -1.49d0, .838d0, .0992d0/
!   WWZ vertex Real part:       g1    kap   lam   g4    g5   kapt lamt
      DATA (ypar(i),i=41,47)
     $   /-1.96d0, -.497d0, .638d0, -.998d0, .6410d0, .1638d0, -.595d0/
!   WWZ vertex Imag. part:      g1    kap   lam   g4    g5   kapt lamt
      DATA (ypar(i),i=51,57)
     $   /.5169d0, .6489d0, 1.426d0, -.276d0, 2.986d0, .4021d0, .723d0/
!----------------------------------------------------------------------
! Nota Bene Standard Model looks as follows
!   WWgamma vertex Real part:   g1    kap   lam   g4    g5   kapt lamt
!     DATA (ypar(i),i=21,27)/ 1.00, 1.00, 0.00, 0.00, 0.00, 0.00, 0.00/
!   WWgamma vertex Imag. part:  g1    kap   lam   g4    g5   kapt lamt
!     DATA (ypar(i),i=31,37)/ 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00/
!   WWZ vertex Real part:       g1    kap   lam   g4    g5   kapt lamt
!     DATA (ypar(i),i=41,47)/ 1.00, 1.00, 0.00, 0.00, 0.00, 0.00, 0.00/
!   WWZ vertex Imag. part:      g1    kap   lam   g4    g5   kapt lamt
!     DATA (ypar(i),i=51,57)/ 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00/
!----------------------------------------------------------------------

      WRITE(NOUT,*) '   '
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '==========*********************==============='
      WRITE(NOUT,*) '==========***     DEMO2     ***==============='
      WRITE(NOUT,*) '==========*********************==============='
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '   '

! Read test_name and data_set_name
      READ( NINP,'(A5,1X,A5)') CHdumy
!=====================================================================
      READ(NINP,  '(8I2)')  KAT1,KAT2,KAT3,KAT4,KAT5,KAT6,KAT7,KAT8
      write(6  ,  '(8I2)')  KAT1,KAT2,KAT3,KAT4,KAT5,KAT6,KAT7,KAT8
      READ(NINP,  '(I10)') NEVT
      READ(NINP,  '(I10)') KeyRad,KeyPhy,KeyTek,KeyMis
      READ(NINP,'(F10.0)') CMSENE,GMU,ALFWIN
      READ(NINP,'(F10.0)') AMAZ,GAMMZ,AMAW,GAMMW
      READ(NINP,'(F10.0)') VVMIN,VVMAX
      READ(NINP,  '(I10)') KEYDWM,KEYDWP
      READ(NINP,'(F10.0)') WTMAX
      READ(NINP,  '(I10)') JAK1,JAK2
      READ(NINP,  '(I10)') ITDKRC,IFPHOT
      READ(NINP,  '(I10)') IFHADM,IFHADP
!=====================================================================
      WRITE( 6,*)     NEVT,' REQUESTED EVENTS '
      WRITE(NOUT,*)   NEVT,' REQUESTED EVENTS '
! Control output
      WRITE(NOUT,'(8A6/8I6)')
     $ 'KAT1','KAT2','KAT3','KAT4','KAT5','KAT6','KAT7','KAT8',
     $  KAT1 , KAT2 , KAT3 , KAT4 , KAT5 , KAT6 , KAT7 , KAT8
      WRITE(NOUT,'(A12/I12)')
     $  'nevt',
     $   nevt
      WRITE(NOUT,'(5A12/5F12.6)')
     $ 'cmsene','gmu*1d5','alfwin','amaz','gammz',
     $  cmsene , gmu*1d5 , alfwin , amaz , gammz
      WRITE(NOUT,'(5A12/5F12.6)')
     $ 'AMAW','GAMMW','VVMIN','VVMAX','WTMAX',
     $  AMAW , GAMMW , VVMIN , VVMAX , WTMAX
      WRITE(NOUT,'(6A12/6I12)')
     $  'KeyRad','KeyPhy','Keytek','KeyMis','KeyDWm','KeyDWp',
     $   KeyRad , KeyPhy , Keytek , KeyMis , KEYDWM , KEYDWP
      WRITE(NOUT,'(6A12/6I12)')
     $  'jak1','jak2','itdkrc','ifphot','ifhadm','ifhadp',
     $   jak1,  jak2 , itdkrc , ifphot , ifhadm , ifhadp

      npar(1)=KeyRad
      npar(2)=KeyPhy
      npar(3)=KeyTek
      npar(4)=KeyMis
      npar(5)=KeyDWM
      npar(6)=KeyDWP

      npar(7)=nout

      npar(21)=jak1
      npar(22)=jak2
      npar(23)=itdkrc
      npar(24)=ifphot
      npar(25)=ifhadm
      npar(26)=ifhadp

      xpar(1)=cmsene
      xpar(2)=gmu
      xpar(3)=alfwin
      xpar(4)=amaz
      xpar(5)=gammz
      xpar(6)=amaw
      xpar(7)=gammw
      xpar(8)=vvmin
      xpar(9)=vvmax
      xpar(10)=wtmax
!-------------------------------------------------------!
! Anomalous coupling constants
! They will be acitvated in the matrix element only id KeYACC=1
      DO i=1,7
         xpar(20+i)=ypar(20+i)
         xpar(30+i)=ypar(30+i)
         xpar(40+i)=ypar(40+i)
         xpar(50+i)=ypar(50+i)
      ENDDO
!-------------------------------------------------------!
      KeyISR = MOD(KeyRad,10)


      CALL KORALW(-1,XPAR,NPAR)
!     *************************
      CALL robol (-1,xpar,npar)

!----------------------------------------------------------------------
!----------------------------------------------------------------------
!------------ TIME AND EVENT LIMITS FOR THE MAIN LOOP -----------------
      IEV=0

      DO 100 IJK=1,1000
      DO 110 IJKL=1,1000000
      IEV=IEV+1
      IF(MOD(IEV,20000).EQ.1) WRITE(6,*) '  IEV= ',IEV

      CALL koralw( 0,xpar,npar)
!     *************************
      CALL robol ( 0,xpar,npar)

      mstu(11)=nout
      IF(IEV.LE.10) CALL lulist(2)

!------------------- EXIT FROM THE MAIN LOOP --------------------------
      IF(IEV.GE.NEVT) GOTO 103
  110 CONTINUE
  100 CONTINUE
  103 CONTINUE
!-----------------------------------------------------------------------
!----------------------------------------------------------------------

      WRITE(6,*) ' generation finished '

      CALL koralw( 1,xpar,npar)
!     *************************

!------------------------------------------------
      CALL robol( 1,XPAR,NPAR)
!------------------------------------------------

      END


      SUBROUTINE robol(imod,xpar,npar)
!     **********************************************
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      PARAMETER  (PI=3.141592653589793238462643)

      SAVE
      DIMENSION  xpar(100),npar(100)

!.. I/O units
      COMMON / inout / ninp,nout

!.. weights from KORALW
      COMMON / wgtall / wtcrud,wtmod,wtset(100)

!.. booking library output
      COMMON / cmonit/ averwt,errela,nevtot,nevacc,nevneg,nevove,nevzer
!.. we need maximum weight
      COMMON / WGTGEN /WTMAX,WTMAX4F(20),WTVES,WTYFS,WTSS,WTBWIG,WTBORN
!.. HEPDATA
      PARAMETER (NMXHEP=2000)
      REAL*4 PHEP,VHEP
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      SAVE  /HEPEVT/

      REAL p1(4),p2(4),p3(4),p4(4)
      REAL pout(4),wp(4)

      CHARACTER*80     bxope,bxl1f,bxl2f,bxclo,bxtxt
      PARAMETER(
     $bxope =  '(//1X,15(5H#####)    )',
     $bxl1f =  '(1X,1H#,F17.8,               16X, A20,A12,A7, 1X,1H#)',
     $bxl2f =  '(1X,1H#,F17.8, 4H  +-, F11.8, 1X, A20,A12,A7, 1X,1H#)',
     $bxclo =  '(1X,15(5H#####)/   )',
     $bxtxt =  '(1X,1H*,                  A48,25X,    1H*)'   
     $         )

!

!############################
      IF (IMOD .EQ. -1) THEN
!############################

      cmsene = xpar(1)
      gammw  = xpar(7)
      amaw   = xpar(6)
      vvmax  = xpar(9)
      keyrad = npar(1)
      keytek = npar(3)
      keymis = npar(4)
      KeyISR = MOD(KeyRad,10)
      KeyWgt = MOD(KeyTek,10)
      Key4f  = MOD(KeyMis,100)/10
      NB=50
      SVAR = CMSENE**2
!.. histo id-s
      IDKAR = 0
      IDMU  = 2000
      IDBRE = 1000
      IDB   = 1500

      if(KeyISR.ne.0)then
!.. initialize average energy loss
        CALL GMONIT(-1,IDBRE+82,0D0,1D0,1D0)  ! photon energy best ord exp
        CALL GMONIT(-1,IDBRE+86,0D0,1D0,1D0)  ! norm. -total xsection
!.. initialize energy loss histo
        CALL GBOOK1(IDBRE+30,'dsig/dv best, exp $',NB,  0D0,VVMAX)
      endif
!.. initialize weight histo
      CALL GBOOK1(IDKAR+12,'WTMOD - best wt     $',NB,  0D0,10D0)
!.. angular distribs, LAB
      CALL gbook1(idkar+41,'dsig/dcth1 (e-) in LAB $',nb, -1d0,1d0)
      CALL gbook1(idkar+43,'dsig/dcth2 (-v) in LAB $',nb, -1d0,1d0)
!.. inv mass distr
      CALL gbook1(idkar+35,'dsigma/dsqrt(s1) $', 50, -3*gammw,3*gammw)


!############################
      ELSEIF (imod .EQ. 0) THEN
!############################
      wtm=wtmod
      wtm1=wtmod
      if (KeyWgt.eq.1) wtm=wtmod/wtmax *4
      if (KeyWgt.ne.0.and.key4f.ne.0) wtm=wtm*wtset(40)
      if (KeyWgt.ne.0.and.key4f.ne.0) wtm1=wtm1*wtset(40)
      IF(wtmod.ne.0d0) THEN
    
        DO K=1,4
          wp(k)=phep(k,3)
        ENDDO

        DO ID1=5,NHEP
          IF (IDHEP(ID1).NE.22) THEN
            GOTO 8
          ENDIF
        ENDDO
  8     CONTINUE

        DO  K=1,4
          P1(K)=PHEP(K,ID1)
          P2(K)=PHEP(K,ID1+1)
        ENDDO

        DO ID2=ID1+2,NHEP
          IF (IDHEP(ID2).NE.22) THEN
            goto 18
          ENDIF
        ENDDO
  18    CONTINUE

        DO  K=1,4
          P3(K)=PHEP(K,ID2)
          P4(K)=PHEP(K,ID2+1)
        ENDDO

      DO I=1,4
         pout(i)=p1(i)+p2(i)+p3(i)+p4(i)
      ENDDO

      sprim=pout(4)**2 -pout(3)**2 -pout(2)**2 -pout(1)**2
      vv=1d0-sprim/svar

      s1=wp(4)**2 -wp(3)**2 -wp(2)**2 -wp(1)**2

      cthe1=p3(3)/sqrt(p3(3)**2+p3(2)**2+p3(1)**2)
      cthe2=p4(3)/sqrt(p4(3)**2+p4(2)**2+p4(1)**2)

      ELSE
        cthe1=0d0
        cthe2=0d0
        vv=0d0
        s1=0d0
      ENDIF

      IF(KeyISR .NE. 0) then
!.. phot. energy loss
        CALL gmonit(0,idbre+82,wtm1*vv,  1d0,1d0)
        CALL gf1(idbre+30,vv   ,wtm*vv)
      ENDIF
!.. best weight
      CALL gmonit(0,idbre+86,wtm1,  1d0,1d0)
      CALL gf1(idkar+12,wtm,1d0)
!.. angles
      CALL gf1(idkar+41,cthe1,wtm)
      CALL gf1(idkar+43,cthe2,wtm)
!.. inv mass
      CALL gf1(idkar+35,sqrt(s1)-amaw,wtm)

!############################
      ELSE
!############################

      nevall = npar(10)
      xscrud = xpar(30)

! SemiAnalytical Born
      keypho=0
      keyacc=3
      CALL korwan(svar,0d0,vvmax,keypho,keyacc,Xborn,errabs)
      WRITE(nout,bxope)
      WRITE(   6,bxope)
      WRITE(nout,bxtxt) 'SEMIANALYTICAL calculations'
      WRITE(NOUT,*) 
      WRITE(NOUT,'(A60)') 'WARNING:   SemiAnal results make phys. sense'
      WRITE(NOUT,'(A60)') '           for KeyZon.eq.0 & key4f.eq.0     '
      WRITE(NOUT,'(A60)') 'otherwise: they provide info on crude distr.'
      WRITE(NOUT,*) 
      WRITE(   6,bxtxt) 'SEMIANALYTICAL calculations'
      WRITE(6,*) 
      WRITE(6,'(A60)') 'WARNING:   SemiAnal results make phys. sense'
      WRITE(6,'(A60)') '           for KeyZon.eq.0 & key4f.eq.0     '
      WRITE(6,'(A60)') 'otherwise: they provide info on crude distr.'
      WRITE(6,*) 
      WRITE(   6,bxl2f)
     $     Xborn,errabs, 'Semianalyt.  Born ','KORWAN','<<'
      WRITE(nout,bxl2f)
     $     Xborn,errabs, 'Semianalyt.  Born ','KORWAN','<<'

      IF(KeyISR .NE. 0) THEN
! SemiAnalytical O(alf2)exp.
        keypho=302
        keyacc=1
        CALL korwan(svar,0d0,vvmax,keypho,keyacc,Xtot2e,errabs)
        WRITE(   6,bxl2f)
     $     Xtot2e,errabs, 'SAN O(alf2)exp.LL','KORWAN','<<'
        WRITE(nout,bxl2f)
     $     Xtot2e,errabs, 'SAN O(alf2)exp.LL','KORWAN','<<'
      ENDIF

      WRITE(nout,bxclo)
      WRITE(   6,bxclo)

      CALL gmonit(1,idbre+86,dumm1,dumm2,dumm3)
      XSKB   = xscrud*averwt
      ERKB   = xskb*errela
      WRITE(nout,bxope)
      WRITE(nout,bxl2f)
     $     Xskb,erkb, 'MC Best, WTMOD','KORALW','<<'
      WRITE(nout,bxclo)

      WRITE(nout,bxope)
      WRITE(nout,bxl2f)
     $     Xpar(20),Xpar(21), 'MC Best, XPAR','KORALW','<<'
      WRITE(nout,bxclo)

      IF(KeyWgt .EQ. 0) then

        erel=(1- dble(npar(10))/dble(npar(11)) )/sqrt(dble(npar(11)))
        WRITE(nout,bxope)
        WRITE(nout,bxl2f)
     $     Xscrud, xscrud*erel,'MC Best, XSCRUD','KORALW','<<'
        WRITE(nout,bxclo)

      ENDIF

      IF( KeyISR .NE. 0) THEN

        WRITE(nout,*)
        CALL gmonit(1,idbre+82,dumm1,dumm2,dumm3)
        xskb0  = averwt *sqrt(svar)/2d0
        erkb0  = xskb0* errela
        CALL gmonit(1,idbre+86,dumm1,dumm2,dumm3)
        WRITE(nout,bxope)
        WRITE(nout,bxl2f)
     $     xskb0/averwt,erkb0/averwt, '<E_gamma, exp>','KORALW','<<'
        WRITE(nout,bxclo)
        if (KeyWgt.eq.1) xscrud = xpar(30)*wtmax/4
        CALL normhi(idbre+30,nevall,xscrud,idbre+30)
        CALL gidopt(idbre+30,'ERRO')
        CALL gprint(idbre+30)
      ENDIF


      CALL gprint(idkar+12)

      CALL gprint(idkar+41)
      CALL gprint(idkar+43)
!      xscrud = xpar(30)*wtm
      if (KeyWgt.eq.1) xscrud = xpar(30)*wtmax/4
      CALL normhi(idkar+35,nevall,xscrud,idkar+35)
      CALL gidopt(idkar+35,'ERRO')
      CALL gprint(idkar+35)


      ENDIF
      END


      SUBROUTINE normhi(id1,nevt,xscrud,id2)
!     **************************************
! This routine normalizes to x-section
!     **************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*80 title
      SAVE
      CALL ginbo1(id1,title,nbt,tmin,tmax)
      fact = nbt*xscrud/(nevt*(tmax-tmin))
! Multiply content
      CALL gopera(id1,'+',id1,id2, fact, 0d0)
      END









