
      SUBROUTINE AMPINW(XPAR,NPAR)
c **********************
C Initialization of the external 4fermion matrix el. codes
C For the moment only GRACE will be interfaced
c **********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  XPAR ( *),NPAR ( *)   
      DIMENSION  XPARY(100),NPARY(100)   
      COMMON / INOUT  / NINP,NOUT 
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
! This common can be everywhere, contains various switches
      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      Key4f  = MOD(KeyMis,100)/10
      if (key4f.ne.0) then
        WRITE(NOUT,BXOPE) 
        WRITE(NOUT,BXTXT) '      Window H used only by  Grace 2.0  '
        WRITE(NOUT,BXTXT) '          Higgs  boson parameters       '
        WRITE(NOUT,BXL1F)xpar(11),'xpar(11)= higgs mass ','amh','H1'
        WRITE(NOUT,BXL1F)xpar(12),'xpar(12)= higgs width','agh','H2'
        WRITE(NOUT,BXTXT) '                                        '
        WRITE(NOUT,BXCLO)
      endif
      DO I=1,100
        XPARY(I)=XPAR(I)
        NPARY(I)=NPAR(I)
      ENDDO

      CALL AMPINI(XPARY,NPARY)
      END
C
      SUBROUTINE AMPEXT(WTMOD4F,WT4F )
! *****************************************************
! external 4fermion matrix elements calculations
! BUFFOR routine
! OUTPUTS
!   wtmod4f        - principal weight for rejection
!   wt4f(9)        - auxiliary weights wector
! *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / MOMSET / QEFF1(4),QEFF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      COMMON / MOMDEC / Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)
      COMMON / DECAYS / IFLAV(4), AMDEC(4), BR(2), BREL
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      common / bormom1 / cq1(4),cq2(4),cp1(4),cp2(4),cp3(4),cp4(4)
      save   / bormom1 /   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      SAVE   / WEKIN2 /,/ DECAYS /,/ MOMDEC /,/ KeyKey/
      DIMENSION XQ1(4),XQ2(4),XP1(4),XP2(4),XP3(4),XP4(4)      
      DIMENSION WT4F(9),WT(9)
      I1 = 11
      I2 =-11
      IF1=IFLAV(1)
      IF2=IFLAV(2)
      IF3=IFLAV(3)
      IF4=IFLAV(4)
      DO I=1,4
       XQ1(I)=QEFF1(I)
       XQ2(I)=QEFF2(I)
       XP1(I)=P1(I)
       XP2(I)=P2(I)
       XP3(I)=P3(I)
       XP4(I)=P4(I)
      ENDDO
      if (xp4(4).gt.-1111) goto 7
      DO I=1,4
       XQ1(I)=0D0
       XQ2(I)=0D0
       XP1(I)=cp1(I)
       XP2(I)=cp2(I)
       XP3(I)=cp3(I)
       XP4(I)=cp4(I)
      ENDDO
      xq1(4)=(cp1(4)+cp2(4)+cp3(4)+cp4(4))/2
      xq2(4)=xq1(4)
      xq1(3)= dsqrt(xq1(4)**2-amel**2)      
      xq2(3)=-dsqrt(xq2(4)**2-amel**2)      
 7    continue
        
!         write(*,*) qeff1,sqrt(dmas2(qeff1)),amel
!         write(*,*) xq1,sqrt(dmas2(xq1)),amel
!         stop
!         write(*,*) xp2,sqrt(dmas2(xp2))
!         write(*,*) xp3,sqrt(dmas2(xp3))
!         write(*,*) xp4,sqrt(dmas2(xp4))
!         write(*,*) xq1,sqrt(dmas2(xq1))
!         write(*,*) xq2,sqrt(dmas2(xq2))
 !        stop

!        do k=1,3
!         xq1(k)=xq1(k)*(xq1(4)-0.5*amel**2/xq1(4))/xq1(4)
!         xq2(k)=xq2(k)*(xq2(4)-0.5*amel**2/xq2(4))/xq2(4)
!        enddo

      CALL AMP4F(XQ1,I1,XQ2,I2,XP1,IF1,XP2,IF2,XP3,IF3,XP4,IF4
     $          , WTMOD,WT )
C
        DO I4F=1,9
          WT4F(I4F) = WT(I4F)
        ENDDO

      KeyCul = MOD(KeyRad,10000)/1000

        IF(KEYCUL.EQ.1) THEN
         call spdetx(ireco)
         s1=q1(4)**2-q1(3)**2-q1(2)**2-q1(1)**2
         s2=q2(4)**2-q2(3)**2-q2(2)**2-q2(1)**2
         sprim=(q1(4)+q2(4))**2-(q1(3)+q2(3))**2
     $        -(q1(2)+q2(2))**2-(q1(1)+q2(1))**2
         if (ireco.ne.0) WTMOD=WTMOD/CulMC(sprim,s1,s2)
        ENDIF
        WTMOD4F = WTMOD
      END


      FUNCTION ELMATR(imode)
!     *********************************
!  plain matrix el. as of koralw
!  imode to be introduced if necessary; 
! may be used to give various normalisation schemes
!  imode = 1  : GRACE
! WARNING !!! THIS ROUTINE BREAKS MODULARITY OF THE CODE !!!
      implicit double precision (a-h,o-z)    
      common / weking / ene,amaz,gammz,amel,amfin,xk0,sinw2,ide,idf 
      common / decays / iflav(4), amdec(4), br(2), brel
! to construct invariants
      COMMON / MOMDEC / Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)
      save
      svar=4d0*ene**2
      sprim = dd2(q1,q2)
      s1=dd2(p1,p2)
      s2=dd2(p3,p4)
c rubbish routine necessary, to restore  WWBORN  modularity !!
!      call kinold(amdec,s1,s2,costhe,phi,cosde1,phi1,cosde2,phi2)
      elmatr=wwborn(svar,sprim,s1,s2)/4
      if(abs(iflav(1)).lt.10) then
        wm = 3d0
      else
        wm = 1d0
      endif
      if(abs(iflav(3)).lt.10) then
        wp = 3d0
      else
        wp = 1d0
      endif 
      elmatr = elmatr *wm*wp

      if(imode.eq.0) then
        write(*,*) 'Elmatr: I have norm. destroyed for imode=0'
        elmatr = elmatr * 16d0
      endif
      end
      SUBROUTINE MASOW(SIN2W,GPICB,AMAF)
C     **********************************
C buffor routine: transmits to the external library 
C information from KORALW commons. 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON / PHYPAR / ALFINV,GPICOB  
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON / DECDAT / AMAFIN(20), BR(20), ICOD(20)
      SAVE   / WEKIN2 /,/ DECDAT /
      DIMENSION AMAF(20)
      SIN2W=SINW2
      GPICB = GPICOB
      DO I=1,20
       AMAF(I)=AMAFIN(I)
      ENDDO
      END

      SUBROUTINE 
     $   KWPAR2(XAMAW,XAMAZ,XGAMMW,XGAMMZ,XSINW2)
************************************************************************
! buffor routine, like MASOW
************************************************************************
      IMPLICIT REAL*8(A-H,O-Z)
!************ KORALW stuff ******************
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW
! This common can be everywhere, contains various switches
      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
! TAUOLA, PHOTOS and JETSET overall switches
      COMMON / LIBRA  / JAK1,JAK2,ITDKRC,IFPHOT,IFHADM,IFHADP

      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI                   
      COMMON / WGTGEN /WTMAX,WTMAX4F(20),WTVES,WTYFS,WTSS,WTBWIG,WTBORN      
      COMMON / WGTALL / WTCRUD,WTMOD,WTSET(100)      
      COMMON / DECDAT / AMAFIN(20), BR(20), ICOD(20)
      COMMON / INOUT  / NINP,NOUT     
      COMMON / MATPAR / PI,CEULER     
      COMMON / PHYPAR / ALFINV,GPICOB  

!************ end KORALW stuff ******************

      XAMAW = AMAW
      XAMAZ = AMAZ
      XGAMMW = GAMMW
      XGAMMZ = GAMMZ
      XSINW2 = SINW2

      END
