      SUBROUTINE decay(mode)
      IMPLICIT REAL*8 (a-h,o-z)
! Codes, br ratios and masses for final particles 
      COMMON / decays / iflav(4), amdec(4), brrat(2), brel
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      SAVE / decays /, / WorZ   /
      REAL*8 drvec(1)
      if(mode.eq.-1) then
        call decayw(mode)
        call decayz(mode)
      else
        IF(ifWon*ifZon.eq.1) then
         drvec(1)=0
         CALL varran(drvec,1)
         rr=drvec(1)
         IF (rr.lt.probw) then
          call decayw(mode)
          ifWnow=1
         else
          call decayz(mode) 
          ifWnow=0
         endif
        ELSEIF(ifWon.eq.1) then
          call decayw(mode)
          ifWnow=1
        ELSEIF(ifZon.eq.1) then
          call decayz(mode) 
          ifWnow=0
        ELSE
         write(*,*) 'decay: wrong ifwon,ifzon=',ifwon,ifzon
        ENDIF
      endif
      end  

      SUBROUTINE decayz(mode)
*     ****************************************
c generates type of final states
c mode =-1 : initiates icod, br, amafin
c        0 : generation
c OUTPUT   (in common DECAYS)
c          iflav(4) PDG numbers of decay prods (m,\bar m,p,\bar p)
c          amdec(4) masses of the above
c          brrat(2) br. ratios of the above (m,p) 
c          brel     br. ratio to (e ne) channel
c
c Written by: M.Skrzypek       date: 3/2/95
c Last update:                   by: 
c
      IMPLICIT REAL*8 (a-h,o-z)
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp  
      COMMON / decdat / amafin(20), br(20), icod(20)
      COMMON / decdatz / brz(20), icodz(20)
! Codes, br ratios and masses for final particles 
      COMMON / decays / iflav(4), amdec(4), brrat(2), brel
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      SAVE / decays /,/ keykey /,/ WorZ   /,/ decdatz /,/ decdat /
      SAVE
      

      IF(mode.eq.-1) THEN
! Codes for final state flavors
        icodz(1)=101
        icodz(2)=202
        icodz(3)=303
        icodz(4)=404
        icodz(5)=505
        icodz(6)=1111
        icodz(7)=1313
        icodz(8)=1515
        icodz(9)=1212
        icodz(10)=1414
        icodz(11)=1616
        probaz=probz
!        if(ifwon.eq.0) probaz=1d0
        if (keydwm.ne.0) brrat(1)=brz(keydwm)*sqrt(probaz)
        if (keydwp.ne.0) brrat(2)=brz(keydwp)*sqrt(probaz)
       
      ELSEIF(mode.eq.0) THEN
      if(probaz.le.0d0) then
       write(*,*) 'DECAYW: wrong probaz= ',probaz
       stop
      endif
! Z-decay channels if chosen by the user
        icwm=keydwm
        icwp=keydwp      
! If keydwm[p]=0 decay channel is generated according to br. ratio.
        if (keydwm.eq.0) icwm=icwdec(20,brz)
        if (keydwp.eq.0) icwp=icwdec(20,brz)
! Assigning codes to final particles according to PDG
! coding convention (1992)
        iflav(1)= icodz(icwm)/100
        iflav(2)=-mod(icodz(icwm),100)
        iflav(3)= mod(icodz(icwp),100)
        iflav(4)=-icodz(icwp)/100
        IFCHANG=0
        DO I=1,2
        IA=iflav(2*I-1)
        IB=iflav(5-2*I)

        IF( (IA.eq.11.and.IB.eq.12).or.  ! e   nue
     $      (IA.eq.13.and.IB.eq.14).or.  ! mu  numu
     $      (IA.eq.15.and.IB.eq.16).or.  ! tau nutau
     $      (IA.eq. 1.and.IB.eq. 2).or.  ! u   d
     $      (IA.eq. 3.and.IB.eq. 4)      ! c   s
     $      )  IFCHANG= 2*I-3 
        ENDDO
        IF (IFCHANG.EQ.-1) THEN
         iflav(1)= icodz(icwm)/100
         iflav(4)=-mod(icodz(icwm),100)
         iflav(3)= mod(icodz(icwp),100)
         iflav(2)=-icodz(icwp)/100
        ENDIF
        IF (IFCHANG.EQ. 1) THEN
         iflav(3)= icodz(icwm)/100
         iflav(2)=-mod(icodz(icwm),100)
         iflav(1)= mod(icodz(icwp),100)
         iflav(4)=-icodz(icwp)/100
        ENDIF

        amdec(1) = amafin( iflav(1))
        amdec(2) = amafin(-iflav(2))
        amdec(3) = amafin( iflav(3))
        amdec(4) = amafin(-iflav(4))
        brrat(1)=brz(icwm)*sqrt(probaz)
        brrat(2)=brz(icwp)*sqrt(probaz)
      ENDIF

      END

      SUBROUTINE decayw(mode)
*     ****************************************
c generates type of final states
c mode =-1 : initiates icod, br, amafin
c        0 : generation
c OUTPUT   (in common DECAYS)
c          iflav(4) PDG numbers of decay prods (m,\bar m,p,\bar p)
c          amdec(4) masses of the above
c          brrat(2) br. ratios of the above (m,p) 
c          brel     br. ratio to (e ne) channel
c
c Written by: M.Skrzypek       date: 3/2/95
c Last update:                   by: 
c
      IMPLICIT REAL*8 (a-h,o-z)
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp  
      COMMON / decdat / amafin(20), br(20), icod(20)
! Codes, br ratios and masses for final particles 
      COMMON / decays / iflav(4), amdec(4), brrat(2), brel
      SAVE / decays /,/ keykey /,/ decdat /,/ WorZ   /
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      SAVE


      IF(mode.eq.-1) THEN
! Codes for final state flavors
        icod(1)=102
        icod(2)=104
        icod(3)=302
        icod(4)=304
        icod(5)=502
        icod(6)=504
        icod(7)=1112
        icod(8)=1314
        icod(9)=1516
        probaw=probw
!        if(ifzon.eq.0) probaw=1d0
        brel=br(8)*sqrt(probaw)
!        if(ifzon.eq.1) brel=br(8) 
        if (keydwm.ne.0) brrat(1)=br(keydwm)*sqrt(probaw)
        if (keydwp.ne.0) brrat(2)=br(keydwp)*sqrt(probaw)

      ELSEIF(mode.eq.0) THEN
      if(probaw.le.0d0) then
       write(*,*) 'DECAYW: wrong probaw= ',probaw
       stop
      endif
! W-decay channels if chosen by the user
        icwm=keydwm
        icwp=keydwp      
! If keydwm[p]=0 decay channel is generated according to br. ratio.
        if (keydwm.eq.0) icwm=icwdec(20,br)
        if (keydwp.eq.0) icwp=icwdec(20,br)
! Assigning codes to final particles according to PDG
! coding convention (1992)
        iflav(1)= icod(icwm)/100
        iflav(2)=-mod(icod(icwm),100)
        iflav(3)= mod(icod(icwp),100)
        iflav(4)=-icod(icwp)/100
        amdec(1) = amafin( iflav(1))
        amdec(2) = amafin(-iflav(2))
        amdec(3) = amafin( iflav(3))
        amdec(4) = amafin(-iflav(4))
        brrat(1)=br(icwm)*sqrt(probaw)
        brrat(2)=br(icwp)*sqrt(probaw)
      ENDIF
      END


      FUNCTION icwdec(icmax,br)
*     *************************
c This function provides a number of a decay channel 
c according to the appriopriate branching ratio value.
c Note: Sum over all br(ic) should be equal to 1.
c INPUT: icmax     - max. number of decay channels
c        br(icmax) - array containing branching ratio values
c                    for decay channels
c
c Written by: Wieslaw Placzek            date: 20.07.1994
c Last update: 22.07.1994                by: W.P.
c
      IMPLICIT real*8 (a-h,o-z)
      REAL*8 br(icmax),drvec(100)
      SAVE
!
      CALL varran(drvec,1)
      rr=drvec(1)
      sum=0
      DO 10 i=1,icmax
        ic=i
        sum=sum+br(i)
        if (sum.ge.rr) goto 11
 10   continue
 11   icwdec=ic
      END
 

