      SUBROUTINE karlud(mode,par1,par2,par3)     
!     **************************************     
! low level  monte-carlo generator          
! administrates directly generation of v-variable             
! and indirectly of all other variables.    
!     **************************************              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      PARAMETER (NMAX= 40)   
      COMMON / MATPAR / PI,CEULER     
      COMMON / PHYPAR / ALFINV,GPICOB     
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW   
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
! communicates with vesko/rhosko            
      COMMON / VVREC  / VVMIN,VVMAX,VV,BETI   
      COMMON / VVINT  / VVTRUE  
      COMMON / INOUT  / NINP,NOUT     
! communicates with gmonit                  
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER 
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      COMMON / MOMSET / QEFF1(4),QEFF2(4),SPHUM(4),SPHOT(100,4),NPHOT 
      COMMON / MOMDEC / Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)
      common / bormom / bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      save   / bormom /
      common / bormom1 / cq1(4),cq2(4),cp1(4),cp2(4),cp3(4),cp4(4)
      save   / bormom1 /   
      COMMON / WGTGEN /WTMAX,WTMAX4F(20),WTVES,WTYFS,WTSS,WTBWIG,WTBORN      
      COMMON / WGTALL / WTCRUD,WTMOD,WTSET(100)   
      common /nevik/ nevtru,ifprint
      save nevik   
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      SAVE / VVINT /,/ MOMSET /,/ MOMDEC /
      SAVE / WEKING /,/ VVREC  /,/ INOUT  /
      SAVE / CMONIT /,/ BXFMTS /,/ WEKIN2/,/ WGTGEN /,/WGTALL/
      SAVE SVAR,BETI2,GAMFAP,GAMFAC,GAMFA2,PREC,XDEL,XCVESK
      SAVE
      EXTERNAL RHOSKO,VVDISB
      DIMENSION drvec(1)
      parameter (NRCH=100)
      DIMENSION PROB(NRCH)
      common /kanalarz/ fakI(NRCH),ikan,MRCHAN,NRCHAN
      save  /kanalarz/
      IF(MODE.EQ.-1) THEN                   
!     ==================================================================
!     ===================INITIALIZATION=================================
!     ==================================================================
ccc      WRITE(NOUT,BXOPE)         
ccc      WRITE(NOUT,BXTXT) 'Initialize KARLUD  start'              
      SVAR = 4D0*ENE**2
      IDYFS = 0
!-- initialize control histos for YFSGEN
      CALL GMONIT(-1,IDYFS+51,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+52,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+53,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+54,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+55,0D0,1D0,1D0)  
      CALL GMONIT(-1,IDYFS+56,0D0,1D0,1D0)  
!-- initialize control weight histos
      CALL GMONIT(-1,IDYFS+57,0D0,1D0,1D0)  ! VESKO crude
      CALL GMONIT(-1,IDYFS+58,0D0,1D0,1D0)  ! WTBORN
      CALL GMONIT(-1,IDYFS+59,0D0,1D0,1D0)  ! crude BORN (no Matr.El.)
      CALL GMONIT(-1,IDYFS+60,0D0,1D0,1D0)  ! WTBORN over WTMAX
!-- initialize decays
      CALL DECAY(-1)

      BETI = 2D0/ALFINV/PI*(DLOG(4D0*ENE**2/AMEL**2)-1D0)     
      BETI2= 2D0/ALFINV/PI* DLOG(4D0*ENE**2/AMEL**2)          
      GAMFAP =1D0-PI**2*BETI**2/12D0        
      GAMFAC =EXP(-CEULER*BETI)/DPGAMM(1D0+BETI)               
      GAMFA2 =EXP(-CEULER*BETI2)/DPGAMM(1D0+BETI2)

!-- Initialization of QED part
      KeyISR = MOD(KeyRad,10)
!-- Calculation of CRUDE normalization
      IF( KeyISR.ne.0)THEN
        CALL vesk1w(-1,rhosko,dum1,dum2,xcvesk) 
        CALL gifyfs(svar,amel,fyfs)
        xcrude = xcvesk*fyfs          
!((((((( test            
cccccc        PREC = 1D-14
cccccc        XCGAUS =BREMKF(1,PREC)   
cccccc        XDEL = XCVESK/XCGAUS-1
cccccc        WRITE(NOUT,BXTXT) '  VESKO initialisation REPORT'
cccccc        WRITE(NOUT,BXTXT) '          mode -1            '
cccccc        WRITE(NOUT,BXL1F) XCVESK,'approx xs_crude  VESKO','XCVESK','V1'
cccccc        WRITE(NOUT,BXL1F) XCGAUS,'exact  xs_crude  GAUSS','XCGAUS','V2'
cccccc        WRITE(NOUT,BXL1F) XDEL   ,'XCVESK/XCGAUS-1      ','      ','V3'
cccccc        WRITE(NOUT,BXTXT) 'Initialize KARLUD  end '              
cccccc        WRITE(NOUT,BXCLO)
!))))))) end test
      ELSE
        CALL resspec(svar,svar,amaw,gammw,xcss)
        xcrude=bornsc(svar,2)*xcss
        fyfs=1d0
        xcvesk=0d0
      ENDIF
!-- outputs
      par1=xcrude
      par2=xcvesk
      par3=xcrude
      KeySmp = MOD(KeyTek,1000)/100 
! ==================================================================
! ====================GENERATION====================================
! ==================================================================
      ELSEIF( mode .EQ. 0) THEN
!     *************************
   30 CONTINUE            
      WTVES=1D0
      WTSS=1D0
      WTYFS=1D0
! generate vv             
      IF( KeyISR.ne.0 ) THEN                  
        CALL vesk1w( 0,rhosko,dum1,dum2,wtves)           
! low-level multiphoton generator           
        CALL YFSgen(vv,vvmin,nmax,wt1,wt2,wt3)
                  
!((((((((------TESTS ON INTERNAL WEIGHTS    
!--------------DOES NOT INTERFERE WITH THE EVENT GENERATION !!! 
        REF  = VVRHO(50,SVAR,AMEL,VV,VVMIN)                   
        WTR  = REF/VVRHO(1,SVAR,AMEL,VV,VVMIN)                
        CALL varran(drvec,1)
        CALL GMONIT(0,IDYFS+56,WTR,1D0,drvec(1))          
! pseudorejection in order to introduce reference xsection
!cc        IF(KEYFIX.EQ.0 .AND. drvec(1).GT.WTR) GOTO 110                
        IF(drvec(1).GT.WTR) GOTO 110                
        WF1  = WT1*VVRHO(51,SVAR,AMEL,VV,VVMIN)/REF           
        WF2  = WT2*VVRHO(52,SVAR,AMEL,VV,VVMIN)/REF           
        WF3  = WT3          
        WF13 = WF1*WF3      
        WF123= WF1*WF2*WF3                    
        CALL GMONIT(0,IDYFS+51,WF1,  1D0,1D0)       
        CALL GMONIT(0,IDYFS+52,WF2,  1D0,1D0)       
        CALL GMONIT(0,IDYFS+53,WF3,  1D0,1D0)       
        CALL GMONIT(0,IDYFS+54,WF13, 1D0,1D0)       
        CALL GMONIT(0,IDYFS+55,WF123,1D0,1D0)       
  110   CONTINUE            
!))))))))----------

!-- photons under IR cut treated as 0
        vvtrue=vv
        IF( vv .LT. vvmin) vv=0d0
      ELSE                
        vv=0d0          
        vvtrue=0d0
        wt1=1d0
        wt2=1d0
        wt3=1d0
      ENDIF         
      wtYFS=wt1*wt2*wt3
!! here was a bug A.V. 27.06.96 IF( wtYFS .EQ. 0D0) GOTO 140           
      IF( wtYFS .EQ. 0D0) THEN
       WTKARL=0D0
       GOTO 150 
      ENDIF          

      sprim=svar*(1-vv)      
!-- generate decay channel
      CALL DECAY(0)
!-- make a choice of kinematical branch
      call brancher(sprim,itype,prob)
      ikan=itype
!======================================================
!=========== 4-body phase space begin =================
!======================================================
       call spacegen(0,itype,SVAR,SPRIM,fak)
! transform everything back to CMS (LAB)
! input :  common / bormom /
! output:  COMMON / MOMDEC / and QEFF1(4),QEFF2(4) from / MOMSET /
! ambeam must be corrected in a consistent manner !!! ambeam is set
! in electroweak interfaces now.
      do k=1,4
       cp1(k)=bp1(k)
       cp2(k)=bp2(k)
       cp3(k)=bp3(k)
       cp4(k)=bp4(k)
      enddo
      ambeam=amel
      call from_cms_eff(1,svar,sprim,ambeam,sphum,sphot,nphot,  
     $      bq1,bq2,bp1,bp2,bp3,bp4, 
     $      qeff1,qeff2,q1,q2,p1,p2,p3,p4)
!...        place selecto on some phase space regions to zero them
       call selecto(p1,p2,p3,p4,qeff1,qeff2,fak)
!-- event outside physical phase space?
      if(fak.eq.0d0)  then
         GOTO 140
      endif

! ================================
      faki(itype)=fak
      flak=fak
      fak=0d0
!      DO I=MRCHAN,NRCHAN
      DO I=1,NRCHAN
          if (I.ne.itype.and.prob(i).gt.0d0) 
     $     call spacegen(1,I,SVAR,SPRIM,fakI(I))
!           if (i.eq.itype) write(*,*) 'fakusie(',i,')=', faki(i)/flak
          if (prob(i).gt.0d0) then
           fak=fak+prob(i)/fakI(i)
          else
           faki(i)=0d0
          endif
         if(prob(i).ne.0d0.and.faki(i).eq.0d0) then
          write(*,*) 'karludw: jacobian(I)=0d0  itype=',itype,'I=',i
          write(*,*) 'i from - to',MRCHAN,'  ',NRCHAN,'prob(i)',prob(i)
          write(*,*) 'p1=',p1
          write(*,*) 'p2=',p2
          write(*,*) 'p3=',p3
          write(*,*) 'p4=',p4
         endif
      enddo
      fak=1d0/fak
!...

 140  CONTINUE
!...        statistical factors for identical particles
       call selstfac(fak)
!======================================================
!=========== 4-body phase space end ===================
!======================================================
!-- end generation
!--------------------------------------------------------


!------------------------------------------
! first come weights from vesko, inverse of the dummy
! born used in photon spectrum and yfs.
      call resspec(svar,sprim,amaw,gammw,xcss)
      xcborn=1D0/bornsc(sprim,0)/xcss
      wtkarl=wtves*xcborn*wtyfs
!! here was a bug A.V. 27.06.96: missing line
 150  continue 
!------------------------------------------
!-- weight for phase space  volume
      IF(wtkarl.ne.0d0)THEN
       wtkarl=wtkarl *fak
      else
       wtkarl=0d0
      ENDIF
!--------------------------------------------------------
      IF(wtkarl.ne.0d0)THEN
        wtborn=BORNKD(SVAR,SPRIM)
      ELSE
        WTBORN=0D0
      ENDIF
      if (nevtru.eq. -109856  ) then
      write(*,*) nevtru,wtkarl,fak,itype,faki(itype)
          write(*,*) 'karlud: jacobian(I)=0d0  itype=',itype,'I=',i
          write(*,*) 'p1=',p1
          write(*,*) 'p2=',p2
          write(*,*) 'p3=',p3
          write(*,*) 'p4=',p4
          write(*,*) faki
      endif
      if(wtkarl.lt.0d0) then
          write(*,*) 'ujemna waga itype=',itype
          write(*,*) wtkarl
          Write(*,*) 'aa'
          Write(*,*) faki
          Write(*,*) 'bb'
          write(*,*) p1
          write(*,*) p2
          write(*,*) p3
          write(*,*) p4

      endif
!--------------------------------------------------------
!-- control histogramming of weights
      wttot=wtkarl*wtborn
      CALL gmonit(0,idyfs+59,wtkarl,  1d0,1d0)        
      CALL gmonit(0,idyfs+58,wttot,  1d0,1d0)        
      CALL gmonit(0,idyfs+57,wtves,  1d0,1d0)        
      IF(wttot.lt.wtmax) THEN 
        WTOVR=0D0
      ELSE
        WTOVR=WTTOT
      ENDIF
      CALL gmonit(0,idyfs+60,wtovr,  1d0,1d0)        
!-- end weights histogramming
!--------------------------------------------------------
      par1=xcborn             
      par2=wtkarl
      par3=wtborn 

!     ======================
      ELSEIF(MODE.EQ.1) THEN                
!     ======================

!-- crude xsection XCVESK and YFS formfactor FYFS
      IF( KeyISR.ne.0 )THEN
        CALL vesk1w( 1,rhosko,xsve,erelve,xcvesk)
        CALL gifyfs(svar,amel,fyfs)
        xcrude=xcvesk*fyfs          
!(((((( internal checks on VESKO
        CALL GMONIT(1,IDYFS+57,DUMM1,DUMM2,DUMM3)   
        WTNOSS = AVERWT      
        ERNOSS = ERRELA 
        PREC   = 1D-16
        XSGS   = BREMKF(1,PREC)
        ERGS   = XSGS*PREC
        ERVE   = XSVE*ERELVE       
        DDV    = XSVE/XSGS-1D0
        DDR    = ERELVE + 1D-6
        XDEL   = XCVESK/XSGS-1
        WRITE(NOUT,BXOPE)         
        WRITE(NOUT,BXTXT) '            Window V           '
        WRITE(NOUT,BXTXT) '       VESKO FINAL REPORT      '
        WRITE(NOUT,BXTXT) '             mode  1           '
        WRITE(NOUT,BXL1F)XCVESK,   'approx xs_crude VESKO','XCVESK','V4'
        WRITE(NOUT,BXL2F)XSVE,ERVE,'exact  xs_crude VESKO','XSVE  ','V5'
        WRITE(NOUT,BXL2F)XSGS,ERGS,'exact  xs_crude Gauss','XSGS  ','V6'
        WRITE(NOUT,BXL1F) XDEL    ,'XCVESK_appr/XSGS-1   ','      ','V7'
        WRITE(NOUT,BXL2F)DDV,DDR,  ' XSVE_exact/XSGS-1   ','      ','V8'
        WRITE(NOUT,BXCLO)         
!)))))) end VESKO internal checks 
      ELSE
        CALL resspec(svar,svar,amaw,gammw,xcss)
        xcrude=bornsc(svar,2)*xcss
        fyfs=1d0
        xcvesk=0d0
      ENDIF
!-- outputs
      par1=xcrude
      par2=xcvesk  
      par3=xcrude

!-- crude xs. NO born
      CALL GMONIT(1,IDYFS+59,DUMM1,DUMM2,DUMM3)   
      WTKACR = AVERWT      
      ERKACR = ERRELA 
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '         KARLUD  FINAL  REPORT '
      WRITE(NOUT,BXTXT) '               window A        '
      WRITE(NOUT,BXTXT) '                               '
      WRITE(NOUT,BXTXT) ' CCru Matrix Element reads:                 '
      WRITE(NOUT,BXTXT) ' A) Born Matrix Element for CC03 processes  '
      WRITE(NOUT,BXTXT) ' B) Technical crude M.E. for NC processes or'
      WRITE(NOUT,BXTXT) '    for KeySmp.ne.0                         '
      WRITE(NOUT,BXTXT) '                               '
      WRITE(NOUT,BXTXT) '     Xsect with NO Matrix Element   '
      WRITE(NOUT,BXL1I) NEVTOT,     'total no of events ','NEVTOT','A0'
      WRITE(NOUT,BXL1I) NEVNEG,'WTcrud < 0 evts         ','NEVNEG','A1'
      XSKR   = XCRUDE*WTKACR
      ERKR   = XSKR*ERKACR
      WRITE(NOUT,BXL1F) XCRUDE,' sigma_crude            ','XCRUDE','A2'
      WRITE(NOUT,BXL2G) WTKACR,ERKACR,'<WTcrud> rel err ','WTKACR','A3'
      WRITE(NOUT,BXL2G) XSKR,ERKR,'phsp. vol, no beta-0  ',  'XSKR','A4'
      WRITE(NOUT,BXTXT) ' '         


!-- born xsection, total
      CALL GMONIT(1,IDYFS+58,DUMM1,DUMM2,DUMM3)   
      WTKABO = AVERWT      
      ERKABO = ERRELA 
      XSKB0  = XCRUDE*WTKABO 
      ERKB0  = XSKB0*ERKABO 
      WRITE(NOUT,BXTXT) '                               '
      WRITE(NOUT,BXTXT) ' Xsect with CCru Matrix El. only, NO Betas'
      WRITE(NOUT,BXL1I) NEVTOT,  'total no of events '   ,'NEVTOT','A5'
      WRITE(NOUT,BXL1I) NEVNEG,  'WTcrud*WTborn <0 evts' ,'NEVNEG','A6'
      WRITE(NOUT,BXL2F) 
     $           WTKABO,ERKABO,'<WTcrud*WTborn>, rel err','WTKABO','A7'
      WRITE(NOUT,BXL2F) XSKB0,ERKB0, 'sigma (Born M.El.)', 'XSKA0','A8'

!-- born xsection from above WTMAX
      CALL GMONIT(1,IDYFS+60,DUMM1,DUMM2,DUMM3)   
      WTKABO = AVERWT
      ERKABO = ERRELA
      XSKB   = XCRUDE*WTKABO
      ERKB   = XSKB*ERKABO
      XX=XSKB/XSKB0
      EE=ERKB/XSKB0
      WRITE(NOUT,BXTXT) '                               '
      WRITE(NOUT,BXTXT) '        Xsect OVER Wtmax       '
      WRITE(NOUT,BXTXT) ' CCru Matrix El. only, no Betas'
      WRITE(NOUT,BXL1I) NEVACC,  'no of ev OVER wtmax','NEVACC','A9'
      WRITE(NOUT,BXL2F) XSKB,ERKB,  'sigma OVER wtmax','XSKABO','A10'
      WRITE(NOUT,BXL2F) XX,EE,      'relat sigma OVER','XSKABO','A11'
      WRITE(NOUT,BXCLO)         

! ============
      ELSE  
! ============

      IF( KeyISR.ne.0 ) THEN
      CALL GMONIT(1,IDYFS+51,DUMM1,DUMM2,DUMM3)   
      DEL1   = AVERWT-1D0                   
      DWT1   = ERRELA     
      CALL GMONIT(1,IDYFS+52,DUMM1,DUMM2,DUMM3)   
      AWF2   = AVERWT     
      DWT2   = ERRELA     
      CALL GMONIT(1,IDYFS+53,DUMM1,DUMM2,DUMM3)   
      AWF3   = AVERWT     
      DEL3   = AVERWT-GAMFA2                
      DWT3   = ERRELA     
      CALL GMONIT(1,IDYFS+54,DUMM1,DUMM2,DUMM3)   
      AWF4   = AVERWT     
      DEL4   = AVERWT-GAMFAC                
      DWT4   = ERRELA     
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '     KARLUD  FINAL  REPORT     '
      WRITE(NOUT,BXTXT) '         window B              '
      WRITE(NOUT,BXL2F) DEL1,DWT1,  '<WF1>-1  mass wt   ','DEL1  ','B1'
      WRITE(NOUT,BXL2F) AWF2,DWT2,  '<WF2> dilat. weight','AWF2  ','B2'
      WRITE(NOUT,BXL2F) AWF3,DWT3,  '<WF3> dilat. weight','AWF3  ','B3'
      WRITE(NOUT,BXL2F) DEL3,DWT3,  '<WF3>-YGF(BETI2)   ','DEL3  ','B4'
      WRITE(NOUT,BXL2F) AWF4,DWT4,  '<WF1*WF3>          ','AWF4  ','B5'
      WRITE(NOUT,BXL2F) DEL4,DWT4,  '<WF1*WF3>-YGF(BETI)','DEL4  ','B6'
      WRITE(NOUT,BXCLO)         
!     ==================================================================
      CALL GMONIT(1,IDYFS+59,DUMM1,DUMM2,DUMM3)   
      WTKARL = AVERWT      
      ERKARL = ERRELA 
      CALL VESK1W( 1,RHOSKO,XSVE,ERELVE,XCVESK)
      XSKR=XCVESK*WTKARL
      CALL GMONIT(1,IDYFS+55,DUMM1,DUMM2,DUMM3)   
      AWF5   = AVERWT     
      DEL5   = AVERWT-GAMFAC                
      DWT5   = ERRELA     
      CALL GMONIT(1,IDYFS+56,DUMM1,DUMM2,DUMM3)   
      AWF6   = AVERWT     
      PREC = 1D-6
      XREFER = BREMKF(50,PREC)                   
      DELKAR = XREFER*AWF5/XSKR  -1D0       
      DELREF = XCVESK*AWF6/XREFER-1D0       
      WRITE(NOUT,BXOPE)         
      WRITE(NOUT,BXTXT) '     KARLUD  FINAL  REPORT CONT.   '
      WRITE(NOUT,BXTXT) '         WINDOW C                  '
      WRITE(NOUT,BXTXT) 'BETI= 2*ALFA/PI*(LOG(S/MEL**2)-1)       '
      WRITE(NOUT,BXTXT) 'GAMFAP= 1-PI**2*BETI**2/12              '
      WRITE(NOUT,BXTXT) 'GAMFAC=EXP(-CEULER*BETI)/GAMMA(1+BETI)  '
      WRITE(NOUT,BXTXT) 'GAMFA2=EXP(-CEULER*BETI2)/GAMMA(1+BETI2)'
      WRITE(NOUT,BXL1F)  BETI,        '                =','BETI  ','C1'
      WRITE(NOUT,BXL1F)  GAMFAP,      '                =','GAMFAP','C2'
      WRITE(NOUT,BXL1F)  GAMFAC,      '                =','GAMFAC','C3'
      WRITE(NOUT,BXL1F)  GAMFA2,      '                =','GAMFA2','C4'
      WRITE(NOUT,BXL2F) AWF5,DWT5, ' <WF1*WF3*WF4>      ','AWF5  ','C5'
      WRITE(NOUT,BXL2F) DEL5,DWT5, ' <WF1*WF3>-YGF(BETI)','DEL5  ','C6'
      WRITE(NOUT,BXTXT) 'DELKAR=XREFER*AVER(WF1*WF1*WF3)/XSKARL-1'
      WRITE(NOUT,BXTXT) 'DELREF=XCRUDE*AVER(WTR)/XREFER-1        '
      WRITE(NOUT,BXL1F) XREFER,    'reference x_sect.   ','XREFER','C7'
      WRITE(NOUT,BXL1F) DELKAR,    'XREFER*AWF5/XSKR  -1','DELKAR','C8'
      WRITE(NOUT,BXL1F) DELREF,    'XCVESK*AWF6/XREFER-1','DELREF','C9'
      WRITE(NOUT,BXCLO)         
      ENDIF

!-- born xsection, total, for output purposes only!
      IF( KeyISR.ne.0 ) THEN
        CALL vesk1w( 1,rhosko,xsve,erelve,xcvesk)
        CALL gifyfs(svar,amel,fyfs)          
        xcrude=xcvesk*fyfs          
      ELSE
        CALL resspec(svar,svar,amaw,gammw,xcss)
        xcrude=bornsc(sprim,2)*xcss
        fyfs=1d0
        xcvesk=0d0
      ENDIF
      CALL gmonit(1,idyfs+58,dumm1,dumm2,dumm3)   
      xsborn  = xcrude*averwt 
      erborn  = xsborn*errela 
      par1=0d0
      par2=xsborn
      par3=erborn
! ==========
      ENDIF               
! ==========
      END                 

      SUBROUTINE resspec(svar,sprim,rmas,rgam,prnorm)
!     ***************************************************************
!crude function for spectrum normalization
!prnorm calculates the value of integral
! ds_1d_s2 W(s_1)W(s_2) over theta crude region (see koralw 1.02) manual.
!its results cancels out in final results.  
! this function is arbitrary up to the problems with maximum weight and
! algorithm efficiency.
! note: both resonances have the same mass distribution function
!         svar    - max sprim
!         sprim   - actual s
!         rmas    - central value of a resonance mass distribution
!         rgam    - width of a resonance
!         prnorm  - value of the integral of crude distr. 
!
! Written by: M. Skrzypek            date: 2/16/95
! Last update: 5/07/96                        by: Z.Was 
!
      IMPLICIT real*8 (a-h,o-z)
      COMMON / matpar / pi,ceuler     
      SAVE a,b,winf,wmi,wma,wsqr,wrec,prsqr,prrec
      SAVE uma,umi,uinf,usqr,urec
      SAVE
!
!        write(6,*)'resms2',rmas,rgam
      a=rmas**2
      b=rmas*rgam
! arctg
      winf = 1/b*atan((svar   -a)/b)
      wma  = 1/b*atan((sprim/4d0-a)/b)
      wmi  = 1/b*atan(        -a /b)
! logarithm
      uinf =1/2d0/a*dlog((svar   -a)**2 +b**2)
      uma  =1/2d0/a*dlog((sprim/4d0-a)**2 +b**2)
      umi  =1/2d0/a*dlog(                b**2)
! thetas
      thespr=1d0
      thesvr=1d0
      IF((sprim/4d0).lt.a) thespr=0d0
      IF( svar      .lt.a) thesvr=0d0
      ulo= thespr*uma +(1d0-thespr)*umi
! normalisations
      wsqr=wma-wmi 
      usqr=thespr*(uma-umi)
      prsqr=(wsqr+usqr)**2
      wrec=winf-wma 
      urec=thesvr*(uinf -ulo)
      prrec=(wsqr+usqr)*(wrec+urec)
      prnorm=prsqr+2*prrec
      END

      FUNCTION BORNSC(SVARX,MODE)            
!     ***********************************     
! THIS ROUTINE PROVIDES BORN CRUDE CROSS SECTION 
! mode = 1 : normalized to total(s) (not used i.e. museum ? 
!        2 : not normalized
!        0 : not normalized
!        difference is only in normalization !!!!                      
!     ***********************************     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)     
      COMMON / MATPAR / PI,CEULER     
      COMMON / PHYPAR / ALFINV,GPICOB     
      COMMON / INOUT  / NINP,NOUT       
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF 
      COMMON / WEKIN2 / AMAW,GAMMW,GMU,ALPHAW   
! This common can be everywhere, contains various switches
      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      SAVE / INOUT  /,/ WEKING /,/ WEKIN2 /
      SAVE
! absolutely dirty trick to prevent complete deterioration 
! of overweight in case of
! ini brem and full matrix element.
         itrob=0
         KeySmp = MOD(KeyTek,1000)/100
         if (KeySmp.ne.0) itrob=1
      if (itrob.eq.1) then
! dominant contribution to x-section is QED t-channel etc. i.e. non WW ZZ.
       SVARI=4D0*ENE**2
      else
! dominant contribution to x-section is WW ZZ.
       SVARI=SVARX
      endif
      BSS= PI/ALFINV**2 /2D0 /SINW2**2
      BBWIGN=AMAW**2/ALFINV/PI/SINW2
      THR=1D0/SVARI/4D0
      IF(SVARI.GT.8*AMAW**2) THEN
        BS=1D0/SVARI*(1+4*AMAW**2/SVARI)/2D0*LOG(SVARI/AMAW**2)
      ELSEIF(SVARI.GT.4*AMAW**2) THEN
        BETA=DSQRT(1-4*AMAW**2/SVARI)
        IF(BETA.LT.PI/ALFINV) BETA=PI/ALFINV ! COULOMB!
        BSR=1D0/SVARI*(1+4*AMAW**2/SVARI)/2D0*LOG(SVARI/AMAW**2)
        BS=BSR*(THR/BSR+BETA*(1-THR/BSR))
      ELSE
        BS=THR*SVARI/4/AMAW**2
      ENDIF
      BS=BS*(1+SVARI/SQRT((SVARI-AMAZ**2)**2+(SVARI*GAMMZ/AMAZ)**2))/2D0
      BNORTO=BSS*GPICOB*BBWIGN**2
!      BORNSC=BS*BNORM
!      WRITE(6,*)'NORMALIZ ', BNORDI, BNORTO,4*AMAW**2*BNORDI/BNORTO 
      IF(MODE.EQ.2) BORNSC=BS*4*AMAW**2 *2 
      IF(MODE.EQ.1) BORNSC=BS*4*AMAW**2 *2 *BNORTO
      IF(MODE.EQ.0) BORNSC=BS*4*AMAW**2 *2
! final part of the dirty trick
      if (itrob.eq.1) then
       svar=4d0*ene**2
       svarxx=svarx
       if(svarx.gt.amaz**2+gammz**2) then
         xls =log((svar-amaz**2)/gammz**2)
         xlsi=log((svarX-amaz**2)/gammz**2)
         xlsix=xls*(xlsi/xls)**2
         svarxx=amaz**2+gammz**2*exp(xlsix)
       endif
       xsvarx=1/svarx+SVARX/((SVARXX-AMAZ**2)**2+(SVARX*GAMMZ/AMAZ)**2)
       svarix=svari
       xsvari=1/svari+SVARi/((SVARix-AMAZ**2)**2+(SVARi*GAMMZ/AMAZ)**2)
       bornsc=bornsc*xsvarx/xsvari
      endif

      END




      subroutine from_cms_eff(mode,svar,sprim,ambeam,sphum,sphot,  
     $      nphot, bq1,bq2,bp1,bp2,bp3,bp4, 
     $      qeff1,qeff2,q1,q2,p1,p2,p3,p4)
*     **********************************************************
c This routine transforms 4momenta between CMS (LAB) and 
c      effective CMS (p_final)
c
c mode =  1   from CMS_eff to CMS
c mode = -1   from CMS to CMS_eff
c bq1,bq2,bp1,bp2,bp3,bp4   arbitrary 4momenta to be transformed
c
c OUTPUT
c  q1, q2, p1, p2, p3, p4   transformed 4momenta 
c  qeff1,qeff2              effective beams in CMS (mode=1)
c                                           in CMS_eff (mode=-1)
c
c Written by: M. Skrzypek              date: 7/6/96
c
      implicit real*8 (a-h,o-z)
      dimension qeff1(4),qeff2(4),sphum(4),sphot(100,4)
      dimension bq1(4),bq2(4),bp1(4),bp2(4),bp3(4),bp4(4)
      dimension q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      dimension qsu(4),ef1(4),ef2(4),photd(4),sphotd(100,4)
      dimension def1(4),def2(4)

c to activate dumps KINDMP=1
      KINDMP=0

      do 124, i=1,4
      q1(i)=bq1(i)
      q2(i)=bq2(i)
      p1(i)=bp1(i)
      p2(i)=bp2(i)
      p3(i)=bp3(i)
 124  p4(i)=bp4(i)


      if(nphot.eq.0) then       
c     ===================

c define effective beams (massive) in CMS''

        qeff1(4)= sqrt(svar)/2d0
        qeff1(3)= dsqrt(svar/4d0-ambeam**2)
        qeff1(2)= 0d0
        qeff1(1)= 0d0
        qeff2(4)= sqrt(svar)/2d0
        qeff2(3)=-dsqrt(svar/4d0-ambeam**2)
        qeff2(2)= 0d0
        qeff2(1)= 0d0

      elseif(nphot.ge.1) then       
c     =======================

c effective beams (in LAB)
        ef1(4)= sqrt(svar)/2d0
        ef1(3)= dsqrt(svar/4d0-ambeam**2)
        ef1(2)= 0d0
        ef1(1)= 0d0
        ef2(4)= sqrt(svar)/2d0
        ef2(3)=-dsqrt(svar/4d0-ambeam**2)
        ef2(2)= 0d0
        ef2(1)= 0d0
        do 11 ii=1,nphot
        if(sphot(ii,3).ge.0d0) then
          do 12 jj=1,4
 12       ef1(jj)= ef1(jj)-sphot(ii,jj)
        else
          do 13 jj=1,4
 13       ef2(jj)= ef2(jj)-sphot(ii,jj)
        endif
 11     continue
       
      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'__LAB0, ef1,ef2'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,EF1,EF2,SPHOT,nphot)
      ENDIF

c qsu is 4momentum of decay products (p1-p4) in CMS              
        do 110 k=1,4               
  110 qsu(k)=-sphum(k)          
        qsu(4)=qsu(4)+sqrt(svar)     

c transform ef1,2 to rest frame (CMS')
! CMS' is rotated CMS_eff (z+ NOT along qeff1) !!!
        call boostv(1,qsu,ef1,ef1) 
        call boostv(1,qsu,ef2,ef2) 

      IF(KINDMP.EQ.1)THEN
        WRITE(6,*)'__CMS EF1,2, PHOTS LAB'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,EF1,EF2,SPHOT,NPHOT)
        DO 70 I=1,NPHOT
        DO 71 J=1,4
 71     PHOTD(J)=SPHOT(I,J)
C.. PHOTONS TO CMS'
        CALL boostv( 1,QSU,PHOTD,PHOTD) 
C.. PHOTONS TO CMS''
        CALL rotatv(1,EF1,PHOTD,PHOTD)
        DO 72 J=1,4
 72     SPHOTD(I,J)=PHOTD(J)
 70     CONTINUE
        WRITE(6,*)'CMS EF1,2 PHOTS CMSBIS'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,EF1,EF2,SPHOTD,NPHOT)
C CONTROL
        CALL rotatv(-1,EF1,EF2,DEF2)
        WRITE(6,*)'__CONTROL'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,EF1,DEF2,SPHOT,NPHOT)
        CALL rotatv( 1,EF1,EF2,DEF2)
        WRITE(6,*)'__CONTROL'
        CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,EF1,DEF2,SPHOT,NPHOT)
      ENDIF

!++++++++++++++++++++++++
      if(mode.eq.1) then
!       from CMS_eff to CMS
!++++++++++++++++++++++++

c define effective beams (massive) in CMS'' (CMS_eff, z+ along qeff1)
        qeff1(4)= sqrt(sprim)/2d0
        qeff1(3)= dsqrt(sprim/4d0-ambeam**2)
        qeff1(2)= 0d0
        qeff1(1)= 0d0
        qeff2(4)= sqrt(sprim)/2d0
        qeff2(3)=-dsqrt(sprim/4d0-ambeam**2)
        qeff2(2)= 0d0
        qeff2(1)= 0d0

        IF(KINDMP.EQ.1)THEN
          WRITE(6,*)'___CMSBIS, QEFF1,QEFF2'
          CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOTD,NPHOT)
        ENDIF

c rotate from CMS'' (Z along ef1) to CMS' (Z along e- beam)    
          call rotatv(-1,ef1,qeff1,qeff1)
          call rotatv(-1,ef1,qeff2,qeff2)
          call rotatv(-1,ef1,q1,q1)
          call rotatv(-1,ef1,q2,q2)
          call rotatv(-1,ef1,p1,p1)
          call rotatv(-1,ef1,p2,p2)
          call rotatv(-1,ef1,p3,p3)
          call rotatv(-1,ef1,p4,p4)

        IF(KINDMP.EQ.1)THEN
          WRITE(6,*)'__CMSPRIM'
          CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,NPHOT)
        ENDIF

C transform back to LAB    
          call boostv(-1,qsu,qeff1,qeff1)              
          call boostv(-1,qsu,qeff2,qeff2)              
          call boostv(-1,qsu,q1,q1)              
          call boostv(-1,qsu,q2,q2)              
          call boostv(-1,qsu,p1,p1)              
          call boostv(-1,qsu,p2,p2)              
          call boostv(-1,qsu,p3,p3)              
          call boostv(-1,qsu,p4,p4)              
c.. fine tuning on masses
          qeff1(4)=dsqrt(ambeam**2+qeff1(1)**2+qeff1(2)**2+qeff1(3)**2)
          qeff2(4)=dsqrt(ambeam**2+qeff2(1)**2+qeff2(2)**2+qeff2(3)**2)

        IF(KINDMP.EQ.1)THEN
          WRITE(6,*)'__LAB, QEFF'
          CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,QEFF1,QEFF2,SPHOT,NPHOT)
C TRANSFORM EF1 BACK TO LAB 
          CALL BOOSTV(-1,QSU,EF1,DEF1) 
          CALL BOOSTV(-1,QSU,EF2,DEF2) 
          WRITE(6,*)'__LAB ALL, EF'
          CALL DUMPL(6,Q1,Q2,P1,P2,P3,P4,DEF1,DEF2,SPHOT,NPHOT)
        ENDIF
!++++++++++++++++++++++++
        elseif(mode.eq.-1) then
!       to CMS_eff from CMS
!++++++++++++++++++++++++
          call boostv(1,qsu,q1,q1)              
          call boostv(1,qsu,q2,q2)              
          call boostv(1,qsu,p1,p1)              
          call boostv(1,qsu,p2,p2)              
          call boostv(1,qsu,p3,p3)              
          call boostv(1,qsu,p4,p4)              
          call rotatv(1,ef1,q1,q1)
          call rotatv(1,ef1,q2,q2)
          call rotatv(1,ef1,p1,p1)
          call rotatv(1,ef1,p2,p2)
          call rotatv(1,ef1,p3,p3)
          call rotatv(1,ef1,p4,p4)
!++++++++++++++++++++++++
        else
!++++++++++++++++++++++++
          write(6,*)'from_cms_eff==> wrong mode: ',mode
          stop
!++++++++++++++++++++++++
        endif
!++++++++++++++++++++++++
      else
c     ====
        write(6,*)'from_cms_eff==> wrong no of phots: ',nphot
        stop
      endif     
c     =====
      end


      subroutine selecto(p1,p2,p3,p4,p5,p6,wt)
! ######################################
! mask on phase space region, can be   #
! modified arbitrarily                 #
! ######################################
      implicit real*8 (a-h,o-z)
      common /articut/ arbitr,arbitr1,cosmin
      COMMON / DECAYS / IFLAV(4), AMDEC(4), BR(2), BREL
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
! This common can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      save /articut/,/ DECAYS /,/ WorZ   /,/ KeyKey/
      save
      data init /0/
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),p6(4)
      angarb=1-cosmin**2
      if (wt.eq.0d0) return 
! introduce statistical factor for identical particles whenever necessary.
! this was a bug (but in test versions only) ZW. 1.05.97
!!!!!         if(iflav(1).eq.iflav(3)) wt=wt/4

! to prevent double counting of channels which belong simultaneously 
! to WW and ZZ final states corresponding ZZ statets will be set to zero. 
      if(ifwon.eq.1.and.ifzon.eq.1.and.ifWnow.eq.0) then
         if((iflav(2).eq.-iflav(3)).and.(iflav(1).ne.-iflav(2))) wt=0d0
      endif

! kill double counting in different zz final states.
      if(ifWnow.eq.0.and.KeyDwm+KeyDwp.eq.0.and.icwm.gt.icwp)wt=0d0       
! remove e+e-e+e- final state.  THIS IS DESACTIVATED !!!!!
! it may be useful. will save a lot of cpu time if you do not need
! these states. 
!         if ((iflav(1).eq.11).and.(iflav(3).eq.11)) wt=0d0
!
!
! remove section of e+e-ch+ch- phase space where Grace has numerical
! problem for config. with two nearly massless high p_t photons and electrons
! in final state.
         if ((iflav(2).eq.-11).or.(iflav(3).eq.11))then
      if (qadra(p1,p2)+qadra(p3,p4).le.arbitr1) wt=0d0
         endif
         if ((iflav(2).eq.-11).and.(iflav(3).eq.11))then
      if (qadra(p1,p4)+qadra(p2,p3).le.arbitr1) wt=0d0
         endif
         if ((iflav(2).eq.-11))then
  !    if (qadra(p3,p4).le.arbitr1) wt=0d0
         endif
         if ((iflav(3).eq.11))then
   !   if (qadra(p1,p2).le.arbitr1) wt=0d0
         endif
!         if(iflav(3).eq.11) wt=0d0
      if (wt.eq.0d0) return 

      pt2=0
      if(abs(iflav(1)).ne.12.and.(p1(1)**2+p1(2)**2)/
     $ (p1(1)**2+p1(2)**2+p1(3)**2).gt.angarb) pt2=pt2+p1(1)**2+p1(2)**2

      if(abs(iflav(2)).ne.12.and.(p2(1)**2+p2(2)**2)/
     $ (p2(1)**2+p2(2)**2+p2(3)**2).gt.angarb) pt2=pt2+p2(1)**2+p2(2)**2

      if(abs(iflav(3)).ne.12.and.(p3(1)**2+p3(2)**2)/
     $ (p3(1)**2+p3(2)**2+p3(3)**2).gt.angarb) pt2=pt2+p3(1)**2+p3(2)**2

      if(abs(iflav(4)).ne.12.and.(p4(1)**2+p4(2)**2)/
     $ (p4(1)**2+p4(2)**2+p4(3)**2).gt.angarb) pt2=pt2+p4(1)**2+p4(2)**2
      if(pt2.lt.arbitr) wt=0d0

! this is dirty trick to get rid of events with high p_t photons
! which spoil e+e-xx final states.
! begin ==========================
       pt3=0
      if(abs(iflav(2)).eq.11.or.abs(iflav(3)).eq.11) then
       pt3=pt3+p5(1)**2+p5(2)**2
       pt3=pt3+p6(1)**2+p6(2)**2
       if(pt3.gt.arbitr/2) wt=0d0
      endif
! end   =========================
! this is the end of routine!!
      return


!rubbish kept `in any case'
!
!      if ((abs(iflav(1)).eq.11).and.(abs(iflav(4)).eq.11)) then
!      if (  (    ((p4(3)/p4(4))**2.gt.0.96D0)
!     $       .and.((p1(3)/p1(4))**2.gt.0.96D0) ).or.
!     $ ((p4(1)**2+p4(2)**2+p1(1)**2+p1(2)**2).le.49d0)) wt=0d0
!      endif
!!!!      if (qadra(p1,p2).le.1d0) wt=0d0
!      if (qadra(p1,p3).le.arbitr) wt=0d0
!      if (qadra(p1,p4).le.arbitr) wt=0d0
!      if (qadra(p1,p5).le.arbitr) wt=0d0
!      if (qadra(p1,p6).le.arbitr) wt=0d0
!      if (qadra(p2,p3).le.arbitr) wt=0d0
!      if (qadra(p2,p4).le.arbitr) wt=0d0
!      if (qadra(p2,p5).le.arbitr) wt=0d0
!      if (qadra(p2,p6).le.arbitr) wt=0d0
!      if (qadra(p3,p4).le.arbitr) wt=0d0
!      if (qadra(p3,p5).le.arbitr) wt=0d0
!      if (qadra(p3,p6).le.arbitr) wt=0d0
!      if (qadra(p4,p5).le.arbitr) wt=0d0
!      if (qadra(p4,p6).le.arbitr) wt=0d0
!      if (qadra(p5,p6).le.arbitr) wt=0d0
!       if (wt.eq.0d0) return 
!      if ((p1(1)**2+p1(2)**2).le.arbitr) wt=0d0
!      if ((p2(1)**2+p2(2)**2).le.arbitr) wt=0d0
!      if ((p3(1)**2+p3(2)**2).le.arbitr) wt=0d0
!      if ((p4(1)**2+p4(2)**2).le.arbitr) wt=0d0

!       if (wt.eq.0d0) return 
!      if ((p1(1)**2+p1(2)**2)/p1(4)**2.le.angarb) wt=0d0
!      if ((p2(1)**2+p2(2)**2)/p2(4)**2.le.angarb) wt=0d0
!      if ((p3(1)**2+p3(2)**2)/p3(4)**2.le.angarb) wt=0d0
!      if ((p4(1)**2+p4(2)**2)/p4(4)**2.le.angarb) wt=0d0
!       write(*,*) p1
!       write(*,*) p2
!       write(*,*) p3
!       write(*,*) p4
!       write(*,*) '---------'
!       write(*,*) p5
!       write(*,*) p6
      end
      subroutine selstfac(wt)
! ######################################
! mask on phase space region, can be   #
! modified arbitrarily                 #
! ######################################
      implicit real*8 (a-h,o-z)

      COMMON / DECAYS / IFLAV(4), AMDEC(4), BR(2), BREL
      save / DECAYS /
      save
      data init /0/
      if (wt.eq.0d0) return 

! introduce statistical factor for identical particles whenever necessary.
         if(iflav(1).eq.iflav(3)) wt=wt/4
      end
      function qadra(p1,p2)
!     ***************************************
      implicit real*8 (a-h,o-z)
      dimension p1(4),p2(4),pp(4)
      do k=1,4
        pp(k)=p1(k)+p2(k)
      enddo
      qadra=dmas2(pp)
      end

      subroutine brancher(sprim,itype,prob)
!     ******************************************************    
! ###########################################
! sets probablilities of channels, can be   #
! function of sprim and iflav(4)            #
! ###########################################
      implicit real*8 (a-h,o-z)
      COMMON / DECAYS / IFLAV(4), AMDEC(4), BR(2), BREL
      COMMON / INOUT  / NINP,NOUT 
      COMMON / BXFMTS / BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
      CHARACTER*80      BXOPE,BXCLO,BXTXT,BXL1I,BXL1F,BXL2F,BXL1G,BXL2G
! This common can be everywhere, contains various switches
      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      save / DECAYS /,/ INOUT  /,/ BXFMTS /,/articut/
      common /articut/ arbitr,arbitr1,cosmin   
      DIMENSION drvec(1)
      parameter (NRCH=100)
      DIMENSION PROB(NRCH)
      CHARACTER*5 XI(NRCH)
      common /kanalarz/ fakI(NRCH),ikan,MRCHAN,NRCHAN
      save  /kanalarz/
      COMMON /upspeed/ FACWEL,FACZEL
      SAVE   /upspeed/     
      logical ifnu,ifnnu,ifnel,ifel
      save
      data istart /0/
      ifnu(k)= (abs(k).eq.12). or.(abs(k).eq.14). or.(abs(k).eq.16)
      ifnnu(k)=(abs(k).ne.12).and.(abs(k).ne.14).and.(abs(k).ne.16)
      ifel(k)= (abs(k).eq.11)
      ifnel(k)=(abs(k).ne.11)
! random choice of generation branch as function of sprime, and final state chosen.
! should be emptied from rn. generation to preserve generation series. 
! you can adopt your choice of the presampling type on sprim and iflav.
! may be one should coonect it with placer? For choice of presampling resonances?
       if (istart.eq.0) then
         NRCHAN=69
         nrstor=nrchan 
         
         KeySmp = MOD(KeyTek,1000)/100
         XI(1)='  1  ' 
         XI(2)='  2  ' 
         XI(3)='  3  ' 
         XI(4)='  4  ' 
         XI(5)='  5  '   
         XI(6)='  6  '   
         XI(7)='  7  ' 
         XI(8)='  8  ' 
         XI(9)='  9  ' 
         XI(10)=' 10  ' 
         XI(11)=' 11  ' 
         XI(12)=' 12  ' 
         XI(13)=' 13  ' 
         XI(14)=' 14  ' 
         XI(15)=' 15  ' 
         XI(16)=' 16  ' 
         XI(17)=' 17  ' 
         XI(18)=' 18  ' 
         XI(19)=' 19  ' 
         XI(20)=' 20  '
         XI(21)=' 21  '
         XI(22)=' 22  '
         XI(23)=' 23  '
         XI(24)=' 24  '
         XI(25)=' 25  '
         XI(26)=' 26  '
         XI(27)=' 27  '
         XI(28)=' 28  '
         XI(29)=' 29  '
         XI(30)=' 30  '
         XI(31)=' 31  '
         XI(32)=' 32  '
         XI(33)=' 33  '
         XI(34)=' 34  '
         XI(35)=' 35  '
         XI(36)=' 36  '
         XI(37)=' 37  '
         XI(38)=' 38  '
         XI(39)=' 39  '
         XI(40)=' 40  '
         XI(41)=' 41  '
         XI(42)=' 42  '
         XI(43)=' 43  '
         XI(44)=' 44  '
         XI(45)=' 45  '
         XI(46)=' 46  '
         XI(47)=' 47  '
         XI(48)=' 48  '
         XI(49)=' 49  '
         XI(50)=' 50  '
         XI(51)=' 51  '
         XI(52)=' 52  '
         XI(53)=' 53  '
         XI(54)=' 54  '
         XI(55)=' 55  '
         XI(56)=' 56  '
         XI(57)=' 57  '
         XI(58)=' 58  '
         XI(59)=' 59  '
         XI(60)=' 60  '
         XI(61)=' 61  '
         XI(62)=' 62  '
         XI(63)=' 63  '
         XI(64)=' 64  '
         XI(65)=' 65  '
         XI(66)=' 66  '
         XI(67)=' 67  '
         XI(68)=' 68  '
         XI(69)=' 69  '
       endif   
         if (KeySmp.eq.0) then
          arbitr= 0d0    ! min. sum of all visible particles p_T**2 
          arbitr1= 0d0   ! min. sum of virtual gamma gamma masses**2 
                         ! used only in e+e- ch+ch- final states 
          cosmin=1.d0
          prob(1)= 1d0
          DO k=2,nrstor
           prob(k)=.0d0
          ENDDO
         else
          arbitr= 00600 !min. sum of all visible particles p_T**2 
          arbitr1= 08d0   ! min. sum of virtual gamma gamma masses**2 
                         ! used only in e+e- ch+ch- final states 
 
          cosmin=1.d0! 0.98
c ms
          prob(1)=0.40d0
          prob(2)=0!.20d0     ! zero
          prob(3)=0.80d0    ! (Z+gam)*(Z+gam) + ini pairs ? 
          prob(4)=0!.200d0    ! zero
          prob(5)=0!.20d0    ! zero
          prob(6)=0!.20d0    ! zero
          prob(7)=0.03d0    ! brem 2+3 from 4
          prob(8)=0.03d0    ! brem 2+3 from 1
          prob(9)=0.10d0    ! brem 1+4 from 3
          prob(10)=0.10d0   ! brem 1+4 from 2

          prob(11)=0.20d0  ! multiperif 1 + W-res in 3-4
          prob(12)=0.20d0  ! multiperif 1 + 4  Z-res in 2-3
          prob(13)=0!.050d0 ! out ?
          prob(14)=0.6d0   ! multiperif 1 + 3
          prob(15)=0.1d0   ! multiperif 1 + 4
          prob(16)=0.20d0   ! multiperif 4 + W-res in 3-4
          prob(17)=0.20d0   ! multiperif 4 + 1  Z-res in 3-2
          prob(18)=0!.050d0  ! out ?
          prob(19)=0.6d0    ! multiperif 4 + 2
          prob(20)=0.1d0    ! multiperif 4 + 1
          prob(21)=0.6d0    ! for zz  z(1+2) z(3+4) 
          prob(22)=0.6d0    ! for zz  z(1+4) z(2+3) 

          prob(23)=0.05d0    ! for zz  (1+2)  from 3
          prob(24)=0.05d0    ! for zz  (1+2)  from 4
          prob(25)=0.05d0    ! for zz  (3+4)  from 1 
          prob(26)=0.05d0    ! for zz  (3+4)  from 2 

          prob(27)=0.05d0    ! for zz  (1+4)  from 3
          prob(28)=0.05d0    ! for zz  (1+4)  from 2
          prob(29)=0.05d0    ! for zz  (2+3)  from 1 
          prob(30)=0.05d0    ! for zz  (2+3)  from 4 

          prob(31)=0.1       ! for zz  multiperif 1+3
          prob(32)=0.1       ! for zz  multiperif 1+4
          prob(33)=0.1       ! for zz  multiperif 2+3
          prob(34)=0.1       ! for zz  multiperif 2+4

          prob(35)=0.1       ! for zz  multiperif 3+1
          prob(36)=0.1       ! for zz  multiperif 3+2
          prob(37)=0.1       ! for zz  multiperif 4+1
          prob(38)=0.1       ! for zz  multiperif 4+2

          prob(39)=0.1       ! for zz  rev-multiperif 1+2 + Z (gamma?)
          prob(40)=0.1       ! for zz  rev-multiperif 2+1 + Z (gamma?)
          prob(41)=0.1       ! for zz  rev-multiperif 3+4 + Z (gamma?)
          prob(42)=0.1       ! for zz  rev-multiperif 4+3 + Z (gamma?)

          prob(43)=0.15d0    ! for zz  (1+2)  from 3 (e+
          prob(44)=0.15d0    ! for zz  (1+2)  from 4 (e-
          prob(45)=0.15d0    ! for zz  (3+4)  from 1 (e+
          prob(46)=0.15d0    ! for zz  (3+4)  from 2 (e-

          prob(47)=0.1       ! for zz  multiperif 1+2
          prob(48)=0.1       ! for zz  multiperif 2+1
          prob(49)=0.1       ! for zz  multiperif 3+4
          prob(50)=0.1       ! for zz  multiperif 4+3

          prob(51)=0.35d0    ! for zz  z(3+4) z(1+2) i.e. t at 3 
          prob(52)=0.35d0    ! for zz  z(1+2) z(3+4) i.e. t at 4 
          prob(53)=0.35d0    ! for zz  z(1+2) z(3+4) i.e. t at 1 
          prob(54)=0.35d0    ! for zz  z(3+4) z(1+2) i.e. t at 2 

          prob(55)=0.1       ! for zz  rev-multiperif 1+4 + Z (gamma?)
          prob(56)=0.1       ! for zz  rev-multiperif 4+1 + Z (gamma?)
          prob(57)=0.1       ! for zz  rev-multiperif 3+2 + Z (gamma?)
          prob(58)=0.1       ! for zz  rev-multiperif 2+3 + Z (gamma?)

          prob(59)=0.15d0    ! for zz  (1+4)  from 3 (e+
          prob(60)=0.15d0    ! for zz  (1+4)  from 2 (e-
          prob(61)=0.15d0    ! for zz  (2+3)  from 1 (e+
          prob(62)=0.15d0    ! for zz  (2+3)  from 4 (e-

          prob(63)=0.35d0    ! for zz  z(1+4) z(3+2) i.e. t at 1 
          prob(64)=0.35d0    ! for zz  z(3+2) z(1+4) i.e. t at 4 
          prob(65)=0.35d0    ! for zz  z(3+2) z(1+4) i.e. t at 3 
          prob(66)=0.35d0    ! for zz  z(1+4) z(3+2) i.e. t at 2 

          prob(67)=0.35d0    ! for tests for cc03 ...
          prob(68)=0.35d0    ! for tests for cc03 but zz res...
          prob(69)=0.35d0    ! for tests for cc03 zz flattened...
         endif
!         do k=1,42
!         prob(k)=0
!         enddo
!         do k=55,66
!         prob(k)=0
!         enddo
       if (istart.eq.0) then
         istart=1
        WRITE(NOUT,BXOPE) 
        WRITE(NOUT,BXTXT) '                Window X                '
        WRITE(NOUT,BXTXT) '            Brancher report             '
        if (KeySmp.eq.0)
     $  WRITE(NOUT,BXTXT) ' WARNING: KeySmp =0 Brancher is off !   '
        if (KeySmp.ne.0)
     $  WRITE(NOUT,BXTXT) '          Brancher is on now            '
         DO I=1,NRCHAN       
      WRITE(NOUT,BXL1F) prob(I),' wgt. for branch NR: ',XI(I),'X1'
         ENDDO
        WRITE(NOUT,BXTXT) ' some wgts zeroed in funct of channel   '
        WRITE(NOUT,BXTXT) '                                        '
        WRITE(NOUT,BXL1F)arbitr,' min. vis p_t**2    ','GeV^2','X2'
        WRITE(NOUT,BXL1F)arbitr1,'add. cut for e+e-ch+ch-','GeV^2','X3'
        WRITE(NOUT,BXL1F)facwel,'effic factor for W->e-nu',' ','X4'
        WRITE(NOUT,BXL1F)faczel,'effic factor for Z->e-e ',' ','X5'
        WRITE(NOUT,BXL1F)cosmin,'max cos-th with beam','   ','X6'
        WRITE(NOUT,BXCLO)         
       endif
!#########################################################
!#########################################################
!! here some channels can be switched off as a function of iflav(1..4)
!#########################################################
!#########################################################
!! ---  WW channels
        if (iflav(1)+iflav(2).ne.0) then
         nrchan=20
         mrchan=1
         do k=nrchan+1,nrstor
           prob(k)=0
         enddo
         if (iflav(1)+iflav(4).ne.0)                   prob( 3)=0

         if (ifnu(iflav(2)).or.(iflav(2).ne.-iflav(3))) prob( 7)=0
         if (ifnu(iflav(2)).or.(iflav(2).ne.-iflav(3))) prob( 8)=0
         if (ifnu(iflav(3)).or.(iflav(1).ne.-iflav(4))) prob( 9)=0
         if (ifnu(iflav(2)).or.(iflav(1).ne.-iflav(4))) prob(10)=0

         if (ifnel(iflav(1)))        then
                                      do k=11,15
                                        prob(k)=0
                                      enddo
                                     endif
         if (ifnu(iflav(3)))         prob(14)=0

         if (ifnel(iflav(4)))        then
                                      do k=16,20
                                         prob(k)=0
                                      enddo
                                     endif
         if (ifnu(iflav(2)))         prob(19)=0
!! --- ZZ channels
        else
         nrchan=nrstor
         mrchan=21 ! <<<
         do k=1,20
           prob(k)=0
         enddo
         if (iflav(1)+iflav(4).ne.0) prob(22)=0
         if (ifnu(iflav(2)).or.ifnu(iflav(3))) then
           prob(23)=0
           prob(24)=0
           prob(25)=0
           prob(26)=0

           prob(43)=0
           prob(44)=0
           prob(45)=0
           prob(46)=0
           prob(47)=0
           prob(48)=0
           prob(49)=0
           prob(50)=0
         elseif (ifel(iflav(2)).or.ifel(iflav(3))) then
           prob(23)=0
           prob(24)=0
           prob(25)=0
           prob(26)=0
           if (ifnel(iflav(3))) then
            prob(43)=0
            prob(44)=0
            prob(49)=0
            prob(50)=0
           endif
           if (ifnel(iflav(2))) then
            prob(45)=0
            prob(46)=0
            prob(47)=0
            prob(48)=0
           endif
         else
           prob(43)=0
           prob(44)=0
           prob(45)=0
           prob(46)=0
           prob(47)=0
           prob(48)=0
           prob(49)=0
           prob(50)=0
         endif
         if (ifnu(iflav(1)).or.ifnu(iflav(3)).or.
     $       (iflav(2)+iflav(3).ne.0)            ) then
           prob(27)=0
           prob(28)=0
           prob(29)=0
           prob(30)=0
         endif
         if (ifnel(iflav(1)))then
           prob(31)=0
           prob(32)=0
           prob(33)=0
           prob(34)=0
           prob(53)=0
           prob(54)=0
!  ---         prob(39)=0
!    - --     prob(40)=0
         endif
         if (ifnel(iflav(3)))then
           prob(35)=0
           prob(36)=0
           prob(37)=0
           prob(38)=0
           prob(51)=0
           prob(52)=0
!   --       prob(41)=0
!--         prob(42)=0

         endif

!         if ((ifel(iflav(1))).or.(ifel(iflav(3)))) then
!           prob(21)=0
!           prob(22)=0
!         endif
         if ((ifel(iflav(2))).and.(ifel(iflav(3)))) then 
          do k=27,30
             prob(k)=0
          enddo 
         else
          do k=55,66
             prob(k)=0
          enddo 
         endif
        endif

!#########################################################
!#########################################################
!#########################################################
!#########################################################

         prtot=0d0
         DO I=MRCHAN,NRCHAN
           prtot=prtot+prob(I)
         ENDDO
         DO I=MRCHAN,NRCHAN
           prob(I)=prob(i)/prtot
         ENDDO
!
        if(Keysmp.eq.0) then
!       ====================
         itype=1
!
        else
!       ====================
!
         CALL varran(drvec,1)
         PROBI=0D0
         DO I=MRCHAN,NRCHAN
          PROBI=PROBI+PROB(I)
          if(drvec(1).lt.probI) THEN
           itype=I
           GOTO 10
          ENDIF
         enddo
        write(*,*) 
     $ 'brancher has problem prob=',prtot
 10     continue
!
        endif
!       =====================
      end 

      SUBROUTINE RKINBRE(ift,ple,
     $ SVAR,DGAMT,PN,amnuta,PIM2,AMP1,PIM1,AMP2,PIPL,AMP3)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  PT(4),PN(4),PAA(4),PIM1(4),PIM2(4),PIPL(4)
      DIMENSION  PR(4),PBST(4)
      common /nevik/ nevtru,ifprint
      save nevik
      REAL*4 RRR(7)
      SAVE
      DATA PI /3.141592653589793238462643D0/
      DATA ICONT /0/
      XLAM(X,Y,Z)=SQRT(ABS((X-Y-Z)**2-4.0D0*Y*Z))


C
C FOUR BODY PHASE SPACE NORMALISED AS IN BJORKEN-DRELL
C D**3 P /2E/(2PI)**3 (2PI)**4 DELTA4(SUM P)
      PHSPAC=1.D0/2**17/PI**8
      amtau=sqrt(svar)
      amro=100
      gamro=50
C
      DO K=1,4
        PAA(K)=PIM1(K)+PIM2(K)+PIPL(K)
        PR(K) =PIM1(K)+PIPL(K)
        pt(k) =PIM1(K)-PIM2(K)+PIPL(K)
      ENDDO
C
C.. MASS OF two
        AMS1=(AMP2+AMP3)**2
        AMS2=(AMTAU-AMNUTA-amp1)**2
        AM2SQ=dmas2(PR)
        AM2 =SQRT(AM2SQ)
!       PHSPAC=PHSPAC*(AMS2-AMS1)
        B=LOG(AMS1)
        A=LOG(AMS2)
        AM2 =SQRT(AM2SQ)
!        PHSPAC=PHSPAC*AM2SQ*(A-B)
C.. MASS OF two
        prob1=.3
        prob2=.3
        PROB3=.0
        PROB4=.4
        AMS1=(AMP2+AMP3)**2
        AMS2=(AMTAU-AMNUTA-amp1)**2
        AM2SQ=dmas2(PR)
        AM2 =SQRT(AM2SQ)
        XJ1=(AMS2-AMS1)
C PHASE SPACE WITH SAMPLING FOR RHO RESONANCE
         B=LOG(AMS1)
         A=LOG(AMS2)
        xj2=AM2SQ*(A-B)

      ALP1=ATAN((AMS1-AMRO**2)/AMRO/GAMRO)
      ALP2=ATAN((AMS2-AMRO**2)/AMRO/GAMRO)
      xj3=((AM2SQ-AMRO**2)**2+(AMRO*GAMRO)**2)/(AMRO*GAMRO)
      xj3=xj3*(ALP2-ALP1)

        n=1
        xj4=am2SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
!      write(*,*) 't',phspac,xj1,xj2,xj3,xj4,prob1,prob2,prob3,prob4
        PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)
C.. mass of three
        AMS1=(AMP1+am2)**2
        AMS2=(AMTAU-AMNUTA)**2
        AM3SQ =dmas2(PAA)
        AM3 =SQRT(AM3SQ)
!        PHSPAC=PHSPAC*(AMS2-AMS1)
        B=LOG(AMS1)
        A=LOG(AMS2)
!!        PHSPAC=PHSPAC*AM3SQ*(A-B)
        prbam3=1d0
        AM3SQb =ams2-am3sq+ams1
        PHSPAC=PHSPAC/(prbam3/(AM3SQ*(A-B))+(1-prbam3)/(AM3SQb*(A-B)))
        ENQ1=(AM2SQ-AMP2**2+AMP3**2)/(2*AM2)
        PPPI=SQRT(ABS(ENQ1**2-AMP3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PPPI/AM2)
C
        PR4=1.D0/(2*AM3)*(AM3**2+AM2**2-AMP1**2)
        PR3= SQRT(ABS(PR4**2-AM2**2))
        PHSPAC=PHSPAC*(2*PR3/AM3)

        PAA4=1.D0/(2*AMTAU)*(AMTAU**2-AMNUTA**2+AM3**2)
        PAA3= SQRT(ABS(PAA(4)**2-AM3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PAA3/AMTAU)
        pim24=1.D0/(2*AM3)*(AM3**2-AM2**2+AMP1**2)
!... versor of two in three restframe
      PNPAA=dot(pn,paa)
      DO K=1,4
         pt(k) =( (PIM1(K)-PIM2(K)+PIPL(K))
     $           -PAA(K)*(pr4-pim24)/am3   )/2/PR3
         PBST(K)=PN(K)-PAA(K)*PNPAA/am3**2
      ENDDO
        cost=dot(pt,pbst)/sqrt(-dmas2(pbst))
        if(sqrt(-dmas2(pt)).gt.1d0) cost=cost/sqrt(-dmas2(pt))
        thet=acos(cost)
        costhe=cost
        EPS=(AM2/AM3)**2
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
        etaa=1+eps+cost
        etab=1+eps-cost
        prb=1d0
        PHSPAC=PHSPAC/(prb/(XL1/2*ETAa)+(1d0-prb)/(XL1/2*ETAb))
      PHSPAC=PHSPAC*(4*PI)
!        write(*,*) 'thet inv=',thet,eps,xl1,eta,cost
      cthx=paa(3)/sqrt(paa(1)**2+ paa(2)**2+ paa(3)**2)
      thet=acos(cthx)

        EPS=(AM2/AMtau)**2
        EPS=(AMnuta/Pn(4))**2
        EPS=(AMnuta/AMtau)**2*max((am3/amtau)**2,1d-4)
        EPS=(am3/amtau)**2
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
      eta1=1+eps+cthx
      eta2=1+eps-cthx
      if (ift.eq.0) then
      ff=1d0
      else
      FF=1d0/3d0/1d0+2*ple/3d0/(XL1/2*ETA1)+2*(1d0-ple)/3d0/(XL1/2*ETA2)
      pleft=ple
        prob1=.2
        prob2=Pleft*.4d0
        prob3=(1D0-PLEFT)*.4D0
        prob4=Pleft*.4d0
        prob5=(1D0-PLEFT)*.4D0

      FF=0d0/3d0/1d0+pleft/(XL1/2*ETA1)+(1d0-pleft)/(XL1/2*ETA2)
      beta=sqrt(1d0-eps)
      xx=eps
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      ct=-cthx

      xccos1=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))
      ct=cthx
      xccos2=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))

        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        n=1
        AM2SQX= CT+2D0-sqrt(1d0-eps)
        xj4=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
        n=1
        AM2SQX=-CT+2D0-sqrt(1d0-eps)
        xj5=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2

 !     FF=0d0/3d0/1d0+pleft*xccos1+(1d0-pleft)*xccos2
      FF=PROB1/1d0+PROB2*xccos1+PROB3*xccos2+PROB4/XJ4+PROB5/XJ5
      endif
!      write(*,*) 'inv  ff=',ff,xl1,eta1,eta2,eps,cthx
!      write(*,*) '     thet=',thet,cthx
      PHSPAC=PHSPAC/FF
      DGAMT=PHSPAC
       if (ifprint.eq.1) write(*,*) 'rkinbre dgamt=',dgamt
      END

      SUBROUTINE KINBRE(ift,ple,
     $ SVAR,DGAMT,PN,amnuta,PIM2,AMP1,PIM1,AMP2,PIPL,AMP3)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  PT(4),PN(4),PAA(4),PIM1(4),PIM2(4),PIPL(4)
      DIMENSION  PR(4)
      REAL*4 RRR(14)
      common /nevik/ nevtru,ifprint
      save nevik
      real*4 rrx
      common /erery/ rrx(14)
      save erery
      SAVE
      DATA PI /3.141592653589793238462643D0/
      DATA ICONT /0/
      XLAM(X,Y,Z)=SQRT(ABS((X-Y-Z)**2-4.0D0*Y*Z))

C
C FOUR BODY PHASE SPACE NORMALISED AS IN BJORKEN-DRELL
C D**3 P /2E/(2PI)**3 (2PI)**4 DELTA4(SUM P)
      PHSPAC=1.D0/2**17/PI**8
      amtau=sqrt(svar)
C
!      nn=1000000
!      sum=0
!      sum2=0
!      do ll=1,nn
      CALL RANMAR(RRR,14)
      do k=1,14
      rrx(k)=rrr(k)
      enddo
C
      amro=100
      gamro=50
C.. MASS OF two
        RR2=RRR(2)
        AMS1=(AMP2+AMP3)**2
        AMS2=(AMTAU-AMNUTA-amp1)**2
!        AM2SQ=AMS1+   RR2*(AMS2-AMS1)
!        AM2 =SQRT(AM2SQ)
!        PHSPAC=PHSPAC*(AMS2-AMS1)
        B=LOG(AMS1)
        A=LOG(AMS2)
        AM2SQ=AMS2*EXP((B-A)*RR2)
        AM2 =SQRT(AM2SQ)
        prob1=.3
        prob2=.3
        PROB3=.0
        PROB4=.4
        RR2=RRR(2)
        AMS1=(AMP2+AMP3)**2      
        AMS2=(AMTAU-AMNUTA-amp1)**2
        ALP1=ATAN((AMS1-AMRO**2)/AMRO/GAMRO)
        ALP2=ATAN((AMS2-AMRO**2)/AMRO/GAMRO)
        IF (RRR(12).LT.PROB1) THEN
         AM2SQ=AMS1+   RR2*(AMS2-AMS1)
         AM2 =SQRT(AM2SQ)
        elseIF (RRR(12).LT.(PROB1+PROB2)) THEN  
         B=LOG(AMS1)
         A=LOG(AMS2)
         AM2SQ=AMS2*EXP((B-A)*RR2)
         AM2 =SQRT(AM2SQ)     
        ELSEIF (RRR(12).LT.(PROB1+PROB2+PROB3)) THEN
         ALP=ALP1+RR2*(ALP2-ALP1)
         AM2SQ=AMRO**2+AMRO*GAMRO*TAN(ALP)
         AM2 =SQRT(AM2SQ)
        ELSE
         n=1
          if(n.eq.1) then
         AM2SQ=AMS1/(1D0-RR2*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQ=AMS1/sqrt(1D0-RR2*(1-(ams1/ams2)**n))
          else
         AM2SQ=AMS1*(1D0-RR2*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
         AM2 =SQRT(AM2SQ)
         if (am2sq.gt.ams2) WRITE(*,*) 'am2sq',am2sq,ams1,ams2,rr2
         if (am2sq.gt.ams2) stop
         if (am2sq.lt.ams1) WRITE(*,*) 'am2sq',am2sq,ams1,ams2,rr2
         if (am2sq.lt.ams1) stop

        ENDIF
        XJ1=(AMS2-AMS1)
         B=LOG(AMS1)
         A=LOG(AMS2)
        xj2=AM2SQ*(A-B)
        xj3=((AM2SQ-AMRO**2)**2+(AMRO*GAMRO)**2)/(AMRO*GAMRO)
        xj3=xj3*(ALP2-ALP1)
        n=1
        xj4=am2SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
!        sum=Sum+1d0/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)
!        sum2=Sum2+1d0/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)**2
!        enddo
!        sum=sum/nn
!        sum2=sum2/nn
!        err=sqrt((sum2-sum**2)/nn)
!        write(*,*) sum,'+-',err
!        write(*,*) '28761.2547837270613 +- 0'
!        stop
        PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)

!        PHSPAC=PHSPAC*AM2SQ*(A-B)
C.. mass of three
        RR1=RRR(1)
        AMS1=(AMP1+am2)**2
        AMS2=(AMTAU-AMNUTA)**2
!        AM3SQ =AMS1+   RR1*(AMS2-AMS1)
!        AM3 =SQRT(AM3SQ)
!        PHSPAC=PHSPAC*(AMS2-AMS1)
        B=LOG(AMS1)
        A=LOG(AMS2)
        prbam3=1d0
        if(rrr(10).lt.prbam3) then
         AM3SQ=AMS2*EXP((B-A)*RR1)
         AM3SQb=ams2-am3sq+ams1
        else
         AM3SQ=AMS2*EXP((B-A)*RR1)
         am3sqb=am3sq
         AM3SQ =ams2-am3sq+ams1
        endif
        AM3 =SQRT(AM3SQ)
        PHSPAC=PHSPAC/(prbam3/(AM3SQ*(A-B))+(1-prbam3)/(AM3SQb*(A-B)))
* two RESTFRAME, DEFINE PIPL AND PIM1
        ENQ1=(AM2SQ-AMP2**2+AMP3**2)/(2*AM2)
        ENQ2=(AM2SQ+AMP2**2-AMP3**2)/(2*AM2)
        PPI=         ENQ1**2-AMP3**2
        PPPI=SQRT(ABS(ENQ1**2-AMP3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PPPI/AM2)
* PIPL  MOMENTUM IN TWO REST FRAME,RRR(7),RRR(8)
        THET =ACOS(-1.D0+2*RRR(7))
        PHI = 2*PI*RRR(8)
        PIPL(1)=D0
        PIPL(2)=D0
        PIPL(3)=PPPI
        PIPL(4)=ENQ1
        CALL ROTPOD(THET,PHI,PIPL)
* PIM1 MOMENTUM IN TWO REST FRAME
        DO 30 I=1,3
 30     PIM1(I)=-PIPL(I)
        PIM1(4)=ENQ2
* three REST FRAME, DEFINE momentum of two
*       two  MOMENTUM
        PR(1)=0
        PR(2)=0
        PR(4)=1.D0/(2*AM3)*(AM3**2+AM2**2-AMP1**2)
        PR(3)= SQRT(ABS(PR(4)**2-AM2**2))
        PPI  =          PR(4)**2-AM2**2
*       PIM2 MOMENTUM
        PIM2(1)=0
        PIM2(2)=0
        PIM2(4)=1.D0/(2*AM3)*(AM3**2-AM2**2+AMP1**2)
        PIM2(3)=-PR(3)
        PHSPAC=PHSPAC*(2*PR(3)/AM3)
* PIPL PIM1 BOOSTED FROM two REST FRAME TO three REST FRAME
      EXE=(PR(4)+PR(3))/AM2
      CALL BOSTd3(EXE,PIPL,PIPL)
      CALL BOSTd3(EXE,PIM1,PIM1)
      rr3=rrr(3)
      rr4=rrr(4)
        EPS=(AM2/AM3)**2
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)

        ETA  =EXP(XL1*RR3+XL0)
        prb=1d0
        rrr10=0.1d0 ! branch frozen 
        if (rrr(11).lt.prb) then
         CTHET=-(1+EPS-ETA)
         etaa=eta
         etab=1+eps-CTHET

        else
         CTHET=(1+EPS-ETA)
         etaa=1+eps+CTHET
         etab=eta

        endif
        THET =ACOS(CTHET)
        PHSPAC=PHSPAC/(prb/(XL1/2*ETAa)+(1d0-prb)/(XL1/2*ETAb))

      PHI = 2*PI*RR4
      PHSPAC=PHSPAC*(4*PI)
      CALL ROTPOd(THET,PHI,PIPL)
      CALL ROTPOd(THET,PHI,PIM1)
      CALL ROTPOd(THET,PHI,PIM2)
      CALL ROTPOd(THET,PHI,PR)
!      write(*,*) 'thet gen=',thet,eps,xl1,eta,cthet
C
* NOW TO THE  REST FRAME, DEFINE three AND PN MOMENTA
* three  MOMENTUM
      PAA(1)=0
      PAA(2)=0
      PAA(4)=1.D0/(2*AMTAU)*(AMTAU**2-AMNUTA**2+AM3**2)
      PAA(3)= SQRT(ABS(PAA(4)**2-AM3**2))
      PPI   =          PAA(4)**2-AM3**2
      PHSPAC=PHSPAC*(4*PI)*(2*PAA(3)/AMTAU)
* pn MOMENTUM
      PN(1)=0
      PN(2)=0
      PN(4)=1.D0/(2*AMTAU)*(AMTAU**2+AMNUTA**2-AM3**2)
      PN(3)=-PAA(3)
* Z-AXIS ANTIPARALLEL TO pn MOMENTUM
      EXE=(PAA(4)+PAA(3))/AM3
      CALL BOSTd3(EXE,PIPL,PIPL)
      CALL BOSTd3(EXE,PIM1,PIM1)
      CALL BOSTd3(EXE,PIM2,PIM2)
      CALL BOSTd3(EXE,PR,PR)
      call rotatv(-1,paa,PIPL,PIPL)
      call rotatv(-1,paa,PIM1,PIM1)
      call rotatv(-1,paa,PIM2,PIM2)
      call rotatv(-1,paa,PN,PN)
      call rotatv(-1,paa,pr,pr)
      call rotatv(-1,paa,PAA,PAA)
        EPS=(AM2/AMtau)**2
        EPS=(AMnuta/pn(4))**2
        EPS=(AMnuta/AMtau)**2*max((am3/amtau)**2,1d-4)
        EPS=(am3/amtau)**2
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
      if(ift.eq.0) then
       THET =ACOS(-1.D0+2*RRR(5))
       CTHET=COS(THET)
       PHI = 2*PI*RRR(6)
      else
       IF    (RRR(9).lt.1.d0/3d0) then 
        THET =ACOS(-1.D0+2*RRR(5))
        CTHET=COS(THET)
        PHI = 2*PI*RRR(6)
       elseIF(RRR(9).lt.(1d0+2*ple)/3d0) then
         ETA  =EXP(XL1*RRR(5)+XL0)
         CTHET=-(1+EPS-ETA)
         THET =ACOS(CTHET)
         PHI = 2*PI*RRR(6)
       else
         ETA  =EXP(XL1*RRR(5)+XL0)
         CTHET=(1+EPS-ETA)
         THET =ACOS(CTHET)
         PHI = 2*PI*RRR(6)
       endif
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        pleft=ple
        prob1=.2
        prob2=Pleft*.4d0
        prob3=(1D0-PLEFT)*.4D0
        prob4=Pleft*.4d0
        prob5=(1D0-PLEFT)*.4D0
      IF    (RRR(9).lt.PROB1) then 
       THET =ACOS(-1.D0+2*RRR(5))
       CTHET=COS(THET)
       PHI = 2*PI*RRR(6)
      elseIF(RRR(9).lt.(PROB1+PROB2)) then
        ETA  =EXP(XL1*RRR(5)+XL0)
        CTHET=-(1+EPS-ETA)
         xx=eps
         beta=sqrt(1d0-eps)
         xlog=-log((1+beta)**2/xx)
         xlog1=-log(16D0/xx)
          u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*rrr(5)
         cthet=-1D0/beta*(4D0*EXP(-SQRT(u))-1)
         CTHET=-cthet
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      elseIF    (RRR(9).lt.(PROB1+PROB2+PROB3)) then
        ETA  =EXP(XL1*RRR(5)+XL0)
        CTHET=(1+EPS-ETA)
         xx=eps
         beta=sqrt(1d0-eps)
         xlog=-log((1+beta)**2/xx)
         xlog1=-log(16D0/xx)
          u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*rrr(5)
          cthet=-1D0/beta*(4D0*EXP(-SQRT(u))-1)

        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      elseIF    (RRR(9).lt.(PROB1+PROB2+PROB3+PROB4)) then
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
          n=1
          if(n.eq.1) then
         AM2SQX=AMS1/(1D0-RRr(5)*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQX=AMS1/sqrt(1D0-RRr(5)*(1-(ams1/ams2)**n))
          else
         AM2SQX=AMS1*(1D0-RRr(5)*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
        CTHET=AM2SQX-2D0+sqrt(1d0-eps)
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      else
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
          n=1
          if(n.eq.1) then
         AM2SQX=AMS1/(1D0-RRr(5)*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQX=AMS1/sqrt(1D0-RRr(5)*(1-(ams1/ams2)**n))
          else
         AM2SQX=AMS1*(1D0-RRr(5)*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
        CTHET=-AM2SQX+2D0-sqrt(1d0-eps)
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      endif
      if (cthet**2.gt.1d0) then
       write(*,*) 'station cthet rrr(9); arbit action'
       write(*,*) cthet,rrr(5),rrr(9)
       write(*,*) ams1,ams2,am2sq
       cthet=cthet/cthet**2
        THET =ACOS(CTHET)       
      endif

      endif
      eta1=1+eps+cthet
      eta2=1+eps-cthet
      if (ift.eq.0) then
      ff=1d0
      else
      FF=1d0/3d0/1d0+2*ple/3d0/(XL1/2*ETA1)+2*(1d0-ple)/3d0/(XL1/2*ETA2)
      xx=eps
      beta=sqrt(1d0-eps)
      xx=eps
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      ct=-cthet

      xccos1=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))
      ct=cthet
      xccos2=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))

        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        n=1
        AM2SQX= CTHET+2D0-sqrt(1d0-eps)
        xj4=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
        n=1
        AM2SQX=-CTHET+2D0-sqrt(1d0-eps)
        xj5=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
       
      FF=PROB1/1d0+PROB2*xccos1+PROB3*xccos2+PROB4/XJ4+PROB5/XJ5

      endif
      PHSPAC=PHSPAC/FF
!      write(*,*) 'prod ff=',ff,xl1,eta1,eta2,eps,cthet
!      write(*,*) 'prod thet=',thet,cthet
      CALL ROTPOd(THET,PHI,PIPL)
      CALL ROTPOd(THET,PHI,PIM1)
      CALL ROTPOd(THET,PHI,PIM2)
      CALL ROTPOd(THET,PHI,PR)
      CALL ROTPOd(THET,PHI,PN)
      CALL ROTPOd(THET,PHI,PAA)
      DGAMT=PHSPAC
      if (ifprint.eq.1) write(*,*) 'kinbre dgamt=',dgamt
      END

      SUBROUTINE RKINT(idoub,amro,gamrox,ple,
     $ SVAR,DGAMT,PN,amnuta,PIM2,AMP1,PIM1,AMP2,PIPL,AMP3)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  PT(4),PN(4),PAA(4),PIM1(4),PIM2(4),PIPL(4)
      DIMENSION  PR(4),PBST(4)
      REAL*4 RRR(7)
      common /articut/ arbitr,arbitr1,cosmin
      common /nevik/ nevtru,ifprint
      save nevik,articut
      SAVE
      DATA PI /3.141592653589793238462643D0/
      DATA ICONT /0/
      XLAM(X,Y,Z)=SQRT(ABS((X-Y-Z)**2-4.0D0*Y*Z))

C
C FOUR BODY PHASE SPACE NORMALISED AS IN BJORKEN-DRELL
C D**3 P /2E/(2PI)**3 (2PI)**4 DELTA4(SUM P)
      PHSPAC=1.D0/2**17/PI**8
      amtau=sqrt(svar)
      ift=0
      if(amnuta.eq.amp2) ift=1
      if(   amnuta.eq.amp1 .and.amp2.eq.amp3
     $   .and.amp1.lt.0.001.and.amp3.ge.amp1) ift=1
      gamro=abs(gamrox)
        if (ifprint.eq.1) write(*,*) 'rkint now ..'
C
      DO K=1,4
        PAA(K)=PIM1(K)+PIM2(K)+PIPL(K)
        PR(K) =PIM1(K)+PIPL(K)
        pt(k) =PIM1(K)-PIM2(K)+PIPL(K)
      ENDDO
C
C.. MASS OF two
      if (gamrox.lt.0d0) then 
        prob1=.2
        prob2=.2!.3
        PROB3=.2
        PROB4=.2!.3
        prob5=.20d0 !this branch was tested negatively must be checked before use
      else
        prob1=.4
        prob2=.0
        PROB3=.4
        PROB4=.0
        prob5=.20d0
      endif

        AMS1=(AMP2+AMP3)**2
        AMS2=(AMTAU-AMNUTA-amp1)**2
        AM2SQ=dmas2(PR)
        AM2 =SQRT(AM2SQ)
        XJ1=(AMS2-AMS1)
C PHASE SPACE WITH SAMPLING FOR RHO RESONANCE
         B=LOG(AMS1)
         A=LOG(AMS2)
        xj2=AM2SQ*(A-B)

      ALP1=ATAN((AMS1-AMRO**2)/AMRO/GAMRO)
      ALP2=ATAN((AMS2-AMRO**2)/AMRO/GAMRO)
      xj3=((AM2SQ-AMRO**2)**2+(AMRO*GAMRO)**2)/(AMRO*GAMRO)
      xj3=xj3*(ALP2-ALP1)
        n=1
        xj4=am2SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
        arbix=max(1d0,arbitr)
        am2sqx=am2sq+arbix        
        ams1x=ams1+arbix
        ams2x=ams2+arbix
!        n=1
!        xj5=am2SQx**(n+1)*n*(1D0/ams1x**n-1D0/ams2x**n)
         B=LOG(AMS1x)
         A=LOG(AMS2x)
        xj5=AM2SQx*(A-B)
        amrou=sqrt(max(200d0,arbitr))
        gamrou=amrou/4
        amrou=1.5*amrou
 !       amrou=amro
!        gamrou=gamro
        ALP1u=ATAN((AMS1-AMROu**2)/AMROu/GAMROu)
        ALP2u=ATAN((AMS2-AMROu**2)/AMROu/GAMROu)
        xj5=((AM2SQ-AMROu**2)**2+(AMROu*GAMROu)**2)/(AMROu*GAMROu)
        xj5=xj5*(ALP2u-ALP1u)


       PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4+PROB5/XJ5)


C.. mass of three
        AMS1=(AMP1+am2)**2
        AMS2=(AMTAU-AMNUTA)**2
        AM3SQ =dmas2(PAA)
        AM3 =SQRT(AM3SQ)


      if (idoub.ne.1) then
         PROB1=.8d0
         PROB2=0.0d0
         prob3=0.2d0
      elseif (gamrox.lt.0d0) then 
         PROB1=0.4d0
         PROB2=0.4d0
         prob3=0.2d0
      else
         PROB1=.8d0
         PROB2=0d0
         prob3=0.2D0
      endif

         B=LOG(AMS1)
         A=LOG(AMS2)
        XJ1=AM3SQ*(A-B)
        n=1
        xj2=am3SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
        xj3=ams2-ams1
        PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/xj3)
!        else
!         B=LOG(AMS1)
!         A=LOG(AMS2)
!         PHSPAC=PHSPAC*AM3SQ*(A-B)
!        endif

        ENQ1=(AM2SQ-AMP2**2+AMP3**2)/(2*AM2)
        PPPI=SQRT(ABS(ENQ1**2-AMP3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PPPI/AM2)
C
        PR4=1.D0/(2*AM3)*(AM3**2+AM2**2-AMP1**2)
        PR3= SQRT(ABS(PR4**2-AM2**2))
        PHSPAC=PHSPAC*(2*PR3/AM3)
        if (ifprint.eq.1) write(*,*) 'am2-3',am2,am3
        if (ift.eq.1) then
!...     versor of one in two restframe
         PNPAA=dot(pim2,pr)
         prx3=PPPI
         prx4=(AM2SQ-AMP2**2+AMP3**2)/(2*AM2)
         pim14=(AM2SQ+AMP2**2-AMP3**2)/(2*AM2)
         DO K=1,4
          pt(k) =( (PIM1(K)-PIPL(K))
     $            -Pr(K)*(prx4-pim14)/am2   )/2/PRx3
          PBST(K)=Pim2(K)-Pr(K)*PNPAA/am2**2
         ENDDO
         cost=-dot(pt,pbst)/sqrt(-dmas2(pbst))
         if(sqrt(-dmas2(pt)).gt.1d0) cost=cost/sqrt(-dmas2(pt))
         thet=acos(cost)
         costhe=cost
         cthet=cost
         EPS=(amp3*2*AM2/(AM2**2))**2
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         eta1=1+eps+cthet
         eta2=1+eps-cthet
         prev=0.3
!         write(*,*) thet, 1/(PREV/(XL1/2*ETA)+(1d0-prev)/1D0)
        PHSPAC=PHSPAC/(PREV/( XL1/2*ETA1)+PREV/(XL1/2*ETA2)
     $                       +(1d0-2*prev)/1D0)
       if (ifprint.eq.1 ) then
       write(*,*) 'R ff2=',1/(XL1/2*ETA1),1/(XL1/2*ETA2),prev
       write(*,*) 'R ',cthet,eps,xl1
       endif
      endif
      

      PHSPAC=PHSPAC*(4*PI)
!        write(*,*) 'thet inv=',thet,eps,xl1,eta,cost


      cthx=pn(3)/sqrt(pn(1)**2+ pn(2)**2+ pn(3)**2)
      thet=acos(cthx)

        EPS=(AMnuta/AMtau)**2*max((am3/amtau)**2,1d-4)
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
      eta1=1+eps+cthx
      eta2=1+eps-cthx
      pleft=ple
!      if(gamrox.lt.0.) pleft=0.5
      if(gamro/amro.gt.0.5) pleft=0.5
      if (gamrox.lt.0d0) then 
        prob1=.2
        prob2=Pleft*.4d0
        prob3=(1D0-PLEFT)*.4D0
        prob4=Pleft*.4d0
        prob5=(1D0-PLEFT)*.4D0
      else
        prob1=.2
        prob2=Pleft*.8d0
        prob3=(1D0-PLEFT)*.8D0
        prob4=0
        prob5=0
      endif
      FF=0d0/3d0/1d0+pleft/(XL1/2*ETA1)+(1d0-pleft)/(XL1/2*ETA2)
      beta=sqrt(1d0-eps)
      xx=eps
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      ct=-cthx

      xccos1=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))
      ct=cthx
      xccos2=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))

        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        n=1
        AM2SQX= CTHX+2D0-sqrt(1d0-eps)
        xj4=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
        n=1
        AM2SQX=-CTHX+2D0-sqrt(1d0-eps)
        xj5=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2

 !     FF=0d0/3d0/1d0+pleft*xccos1+(1d0-pleft)*xccos2
      FF=PROB1/1d0+PROB2*xccos1+PROB3*xccos2+PROB4/XJ4+PROB5/XJ5
       if (ifprint.eq.1 ) then
      write(*,*) 'inv  ff4=',prob1,prob2,prob3,prob4,prob5
      write(*,*) '         ',xccos1,xccos2,xj4,xj5
      write(*,*) '         ',cthx,ams1,ams2
        endif
      PHSPAC=PHSPAC/FF

        PAA4=1.D0/(2*AMTAU)*(AMTAU**2-AMNUTA**2+AM3**2)
        PAA3= SQRT(ABS(PAA(4)**2-AM3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PAA3/AMTAU)
        pim24=1.D0/(2*AM3)*(AM3**2-AM2**2+AMP1**2)
!... versor of two in three restframe
      PNPAA=dot(pn,paa)
      DO K=1,4
         pt(k) =( (PIM1(K)-PIM2(K)+PIPL(K))
     $           -PAA(K)*(pr4-pim24)/am3   )/2/PR3
         PBST(K)=PN(K)-PAA(K)*PNPAA/am3**2
      ENDDO
        cost=dot(pt,pbst)/sqrt(-dmas2(pbst))
        if(sqrt(-dmas2(pt)).gt.1d0) cost=cost/sqrt(-dmas2(pt))
        if(abs(cost).gt.1d0) then
        write(*,*) '>>>>>>>>>>>>>>>>>>>>>>>'
        write(*,*) cost
        write(*,*) dot(pt,pbst),sqrt(-dmas2(pbst)),sqrt(-dmas2(pt))
        write(*,*) '<<<<<<<<<<<<<<<<<<<<<<<'
        cost=cost/cost**2
        endif
        if(idoub.eq.5) cost=-cost
        thet=acos(cost)
        costhe=cost
C-- angles for three:
      t=(amtau**2-am3**2)*(1d0-abs(cthx))

!        EPS=(amp1*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
         EPS=((t+amp1)*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
!         EPS=(amp1*2*AM3/(AM3**2+AMP1**2))**2
         if (eps.ge.1d0) eps=.999d0
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
        eta1=1+eps-cost
        eta2=1+eps-cost
         if(idoub.eq.1) eta2=1+eps+cost
        prev=0.4d0
        if(gamro/amro.gt.0.5) prev=0.6d0
        if(gamrox.lt.0.) prev=0.6d0
        if (amp1.lt.0.3d-3) prev=0
!        if (amp1.lt.0.6d-3) prev=0
        uu=1d0/(PREV/2/(XL1/2*ETA1)+PREV/2/(XL1/2*ETA2)+(1d0-PREV)/1D0)
        PHSPAC=PHSPAC*uu
       if (ifprint.eq.1 ) then
       write(*,*) 'r  ff3  '
       write(*,*) 'r  ff3=',1/(XL1/2*ETA1),prev,cost,idoub
       endif

!      xx=eps
!      beta=sqrt(1d0-eps)
!      xlog=-log((1+beta)**2/xx)
!      xlog1=-log(16D0/xx)
!      ct=cthet
!      if(idoub.eq.1) ct=-cthet

!      xccos=beta/(xlog*xlog1
!     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
!     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))
!         PHSPAC=PHSPAC/(PREV*xccos+(1d0-PREV)/1D0)
!        PHSPAC=PHSPAC/(PREV/(XL1/2*ETA)+(1d0-prev)/1D0)
       if (ifprint.eq.1 ) then
!       write(*,*) 'R ff3=',1/(XL1/2*ETA),prev,cost,idoub
       endif

      DGAMT=PHSPAC
      if (phspac.lt.0d0) then
       write(*,*) 'phspac=',phspac,'ff=',ff
      write(*,*) 'inv  ff=',ff,xl1,eta1,eta2,eps,cthx
      write(*,*) '     thet=',thet,cthx
      write(*,*) 'first angular jacobian=',uu,cost
      write(*,*) 'am2 am3',am2,am3
      endif
      END

      SUBROUTINE KINT(idoub,amro,gamrox,ple,
     $ SVAR,DGAMT,PN,amnuta,PIM2,AMP1,PIM1,AMP2,PIPL,AMP3)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  PT(4),PN(4),PAA(4),PIM1(4),PIM2(4),PIPL(4)
      DIMENSION  PR(4)
      REAL*4 RRR(14)
      common /articut/ arbitr,arbitr1,cosmin
      common /nevik/ nevtru,ifprint
      save nevik,articut
      real*4 rrx
      common /erery/ rrx(14)
      save erery
      SAVE
      DATA PI /3.141592653589793238462643D0/
      DATA ICONT /0/
      XLAM(X,Y,Z)=SQRT(ABS((X-Y-Z)**2-4.0D0*Y*Z))
      if (ifprint.eq.1) write(*,*) 'kint now ...'
C
C FOUR BODY PHASE SPACE NORMALISED AS IN BJORKEN-DRELL
C D**3 P /2E/(2PI)**3 (2PI)**4 DELTA4(SUM P)
      PHSPAC=1.D0/2**17/PI**8
      amtau=sqrt(svar)
      ift=0
      if(amnuta.eq.amp2) ift=1
      if(   amnuta.eq.amp1 .and.amp2.eq.amp3
     $   .and.amp1.lt.0.001.and.amp3.ge.amp1) ift=1
      gamro=abs(gamrox)
C
!      sum=0
!      sum2=0
!      nn=1000000
!      do k=1,nn
      CALL RANMAR(RRR,14)
        if (ift.gt.100) then
        RRR( 1 )= 0.9478749037   
        RRR( 2 )= 0.6414651871E-03
        RRR( 3 )= 0.2186722755
        RRR( 4 )= 0.6770371199
        RRR( 5 )= 0.9959959984
        RRR( 6 )= 0.8483608961
        RRR( 7 )= 0.2983032465
        RRR( 8 )= 0.4594436884
        RRR( 9 )= 0.3546591997
        RRR( 10 )= 0.7370334864
        RRR( 11 )= 0.5411399007
        RRR( 12 )= 0.5843002200
        RRR( 13 )= 0.5636240840
        RRR( 14 )= 0.1165237427

        RRR( 1 )= 0.9120953083 +.07 
        RRR( 2 )= 0.6044536829E-01  -.00314
        RRR( 3 )= 0.6973654628
        RRR( 4 )= 0.6249293685
        RRR( 5 )= 0.2043003440
        RRR( 6 )= 0.5548739433
        RRR( 7 )= 0.9244202971
        RRR( 8 )= 0.1170529723
        RRR( 9 )= 0.4773632288
        RRR( 10 )= 0.3393656611
        RRR( 11 )= 0.2608218789
        RRR( 12 )= 0.7097090483
        RRR( 13 )= 0.1676200032
        RRR( 14 )= 0.4811552763


        RRR( 1 )= 0.6470682025
        RRR( 2 )= 0.2057774663
        RRR( 3 )= 0.5201567411
        RRR( 4 )= 0.2157996893
        RRR( 5 )= 0.2812561989
        RRR( 6 )= 0.5039139986
        RRR( 7 )= 0.8193333149
        RRR( 8 )= 0.5267652273
        RRR( 9 )= 0.3422190547
        RRR( 10 )= 0.2896287441
        RRR( 11 )= 0.3918313980E-01
        RRR( 12 )= 0.6622866988
        RRR( 13 )= 0.8352186084
        RRR( 14 )= 0.7802855968E-01

        RRR( 1 )= 0.4865604639E-01
        RRR( 2 )= 0.7470643520E-01
        RRR( 3 )= 0.5707561970E-02
        RRR( 4 )= 0.1091821194
        RRR( 5 )= 0.5938494205
        RRR( 6 )= 0.3438313007
        RRR( 7 )= 0.1558269262
        RRR( 8 )= 0.5537773371
        RRR( 9 )= 0.8776282072
        RRR( 10 )= 0.4459511638 /2
        RRR( 11 )= 0.1935519576
        RRR( 12 )= 0.5576208830
        RRR( 13 )= 0.9880648255
        RRR( 14 )= 0.9081103206

!        RRR( 1 )= 0.2664464116
!        RRR( 2 )= 0.4497187138
!        RRR( 3 )= 0.8510571718E-01
!        RRR( 4 )= 0.7872920632
!        RRR( 5 )= 0.5956429243
!        RRR( 6 )= 0.5650028586
!        RRR( 7 )= 0.7602188587
!        RRR( 8 )= 0.9214590788
!        RRR( 9 )= 0.8335509300
!        RRR( 10 )= 0.9940457344
!        RRR( 11 )= 0.2682380676
!        RRR( 12 )= 0.8510574102
!        RRR( 13 )= 0.1608982682
!        RRR( 14 )= 0.4655991197

        iflak=3
        write(*,*) 'walek',ift
        endif
      do k=1,14
      rrx(k)=rrr(k)
      enddo

      if (ifprint.eq.1) then
         write(*,*) '=====>'
         do k=1,14
            write(*,*) '       RRR(',k,')=',RRR(k)
         enddo
      endif
c --- mass of two
      if (ifprint.eq.100) then
        rrr(2)= .9
c --- mass of three
        rrr(1)=.1
C
C-- angles for three:
        rrr(3)=.2
C-- angles for four:
        rrr(5)=.975 
C-- angles for two:
        rrr(7)=.8 
      endif
C.. MASS OF two
      if (gamrox.lt.0d0) then 
        prob1=.2
        prob2=.2!.3
        PROB3=.2
        PROB4=.2!.3
        prob5=0.2d0
      else
        prob1=.4
        prob2=.0
        PROB3=.4
        PROB4=.0
        prob5=0.2d0
      endif
        if (iflak.eq.5) write(*,*) prob1,prob2,prob3,prob4,prob5

        RR2=RRR(2)
        AMS1=(AMP2+AMP3)**2      
        AMS2=(AMTAU-AMNUTA-amp1)**2
        ALP1=ATAN((AMS1-AMRO**2)/AMRO/GAMRO)
        ALP2=ATAN((AMS2-AMRO**2)/AMRO/GAMRO)
        amrou=sqrt(max(200d0,arbitr))
        gamrou=amrou/4
        amrou=1.5*amrou
!        amrou=amro
!        gamrou=gamro
        ALP1u=ATAN((AMS1-AMROu**2)/AMROu/GAMROu)
        ALP2u=ATAN((AMS2-AMROu**2)/AMROu/GAMROu)
        IF (RRR(10).LT.PROB1) THEN
         AM2SQ=AMS1+   RR2*(AMS2-AMS1)
         AM2 =SQRT(AM2SQ)
        elseIF (RRR(10).LT.(PROB1+PROB2)) THEN  
         B=LOG(AMS1)
         A=LOG(AMS2)
         AM2SQ=AMS2*EXP((B-A)*RR2)
         AM2 =SQRT(AM2SQ)     
        ELSEIF (RRR(10).LT.(PROB1+PROB2+PROB3)) THEN

         ALP=ALP1+RR2*(ALP2-ALP1)
         AM2SQ=AMRO**2+AMRO*GAMRO*TAN(ALP)
         AM2 =SQRT(AM2SQ)
        ELSEIF (RRR(10).LT.(PROB1+PROB2+PROB3+prob4)) THEN
         n=1
          if(n.eq.1) then
         AM2SQ=AMS1/(1D0-RR2*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQ=AMS1/sqrt(1D0-RR2*(1-(ams1/ams2)**n))
          else
         AM2SQ=AMS1*(1D0-RR2*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
         AM2 =SQRT(AM2SQ)
         if (am2sq.gt.ams2) WRITE(*,*) 'am2sqx,err',am2sq,ams1,ams2,rr2
         if (am2sq.gt.ams2) stop
         if (am2sq.lt.ams1) WRITE(*,*) 'am2sqx,err',am2sq,ams1,ams2,rr2
         if (am2sq.lt.ams1) stop

        ELSE
         arbix=max(1d0,arbitr)
         ams1x=ams1+arbix
         ams2x=ams2+arbix
         n=1
          if(n.eq.1) then
         AM2SQx=AMS1x/(1D0-RR2*(1-(ams1x/ams2x)**n))
          elseif(n.eq.2) then
         AM2SQx=AMS1x/sqrt(1D0-RR2*(1-(ams1x/ams2x)**n))
          else
         AM2SQx=AMS1x*(1D0-RR2*(1-(ams1x/ams2x)**n))**(-1d0/n)
          endif
         B=LOG(AMS1x)
         A=LOG(AMS2x)
         AM2SQx=AMS2x*EXP((B-A)*RR2)
         am2sq=am2sqx-arbix
         AM2 =SQRT(AM2SQ)
         if (am2sq.gt.ams2) WRITE(*,*) 'am2sqx,err',am2sq,ams1,ams2,rr2
         if (am2sq.gt.ams2) stop
         if (am2sq.lt.ams1) WRITE(*,*) 'am2sqx,err',am2sq,ams1,ams2,rr2
         if (am2sq.lt.ams1) stop
         ALPu=ALP1u+RR2*(ALP2u-ALP1u)
         AM2SQ=AMROu**2+AMROu*GAMROu*TAN(ALPu)
         AM2 =SQRT(AM2SQ)

        ENDIF
        XJ1=(AMS2-AMS1)
         B=LOG(AMS1)
         A=LOG(AMS2)
        xj2=AM2SQ*(A-B)
        xj3=((AM2SQ-AMRO**2)**2+(AMRO*GAMRO)**2)/(AMRO*GAMRO)
        xj3=xj3*(ALP2-ALP1)
        n=1
        xj4=am2SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
        arbix=max(1d0,arbitr)
        am2sqx=am2sq+arbix        
        ams1x=ams1+arbix
        ams2x=ams2+arbix
!        n=1
!        xj5=am2SQx**(n+1)*n*(1D0/ams1x**n-1D0/ams2x**n)
         B=LOG(AMS1x)
         A=LOG(AMS2x)
        xj5=AM2SQx*(A-B)

        xj5=((AM2SQ-AMROu**2)**2+(AMROu*GAMROu)**2)/(AMROu*GAMROu)
        xj5=xj5*(ALP2u-ALP1u)

      if (ifprint.eq.1) write(*,*) 'a=',ams1,ams2,am2sq
      if (ifprint.eq.1) write(*,*) 'b=',ams1x,ams2x,am2sqx   
      if (ifprint.eq.1) write(*,*) 'amro-gamro',amro,gamro
!        sum=Sum+1d0/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)
!        sum2=Sum2+1d0/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4)**2
!        enddo
!        sum=sum/nn
!        sum2=sum2/nn
!        err=sqrt((sum2-sum**2)/nn)
!        write(*,*) sum,'+-',err
!        write(*,*) '37980.9549446302772 +- 59.65'
!        stop
       PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/XJ3+PROB4/XJ4+PROB5/XJ5)
        if (ifprint.eq.1) write(*,*) 'am2 ',am2,rr2
        if (ifprint.eq.1) write(*,*) 'xj-ts',xj1,xj2,xj3,xj4,xj5
        if (ifprint.eq.1) 
     $     write(*,*) 'probs',prob1,prob2,prob3,prob4,prob5

C.. mass of three
        RR1=RRR(1)
        AMS1=(AMP1+am2)**2
        AMS2=(AMTAU-AMNUTA)**2
         B=LOG(AMS1)
         A=LOG(AMS2)
      if (idoub.ne.1) then
         PROB1=.8d0
         PROB2=0.0d0
         prob3=0.2d0
      elseif (gamrox.lt.0d0) then 
         PROB1=0.4d0
         PROB2=0.4d0
         prob3=0.2d0
      else
         PROB1=.8d0
         PROB2=0d0
         prob3=0.2D0
      endif

         IF (RRR(12).lt.prob1) then
         AM3SQ=AMS2*EXP((B-A)*RR1)
         elseIF (RRR(12).lt.prob1+prob2) then
         n=1
          if(n.eq.1) then
         AM3SQ=AMS1/(1D0-RR1*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM3SQ=AMS1/sqrt(1D0-RR1*(1-(ams1/ams2)**n))
          else
         AM3SQ=AMS1*(1D0-RR1*(1-(ams1/ams2)**n))**(-1d0/n)
          endif

         else
            AM3SQ=AMS1+(ams2-ams1)*rr1
         endif
         AM3 =SQRT(AM3SQ)
!         PHSPAC=PHSPAC*AM3SQ*(A-B)
        XJ1=AM3SQ*(A-B)
        n=1
        xj2=am3SQ**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)
        xj3=ams2-ams1
        PHSPAC=PHSPAC/(PROB1/XJ1+PROB2/XJ2+PROB3/xj3)

      if (ifprint.eq.1) write(*,*) 'am3 ',am3,AM3SQ*(A-B),rr1
!        else
!         B=LOG(AMS1)
!         A=LOG(AMS2)
!         AM3SQ=AMS2*EXP((B-A)*RR1)
!         AM3 =SQRT(AM3SQ)
!         PHSPAC=PHSPAC*AM3SQ*(A-B)
!        endif

C-- angles for four:
!      sum=0
!      sum2=0
!      nn=1000000
!      do k=1,nn
!      CALL RANMAR(RRR,14)

        EPS=(AMnuta/AMtau)**2*max((am3/amtau)**2,1d-4)
        XL1=LOG((2+EPS)/EPS)
        XL0=LOG(EPS)
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        pleft=ple
!        if(gamrox.lt.0.) pleft=0.5
      if(gamro/amro.gt.0.5) pleft=0.5
      if (gamrox.lt.0d0) then 
        prob1=.2
        prob2=Pleft*.4d0
        prob3=(1D0-PLEFT)*.4D0
        prob4=Pleft*.4d0
        prob5=(1D0-PLEFT)*.4D0
      else
        prob1=.2
        prob2=Pleft*.8d0
        prob3=(1D0-PLEFT)*.8D0
        prob4=0
        prob5=0
      endif
      IF    (RRR(9).lt.PROB1) then 
       THET =ACOS(-1.D0+2*RRR(5))
       CTHET=COS(THET)
       PHI = 2*PI*RRR(6)
      elseIF(RRR(9).lt.(PROB1+PROB2)) then
        ETA  =EXP(XL1*RRR(5)+XL0)
        CTHET=-(1+EPS-ETA)
         xx=eps
         beta=sqrt(1d0-eps)
         xlog=-log((1+beta)**2/xx)
         xlog1=-log(16D0/xx)
          u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*rrr(5)
         cthet=-1D0/beta*(4D0*EXP(-SQRT(u))-1)
         CTHET=-cthet
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      elseIF    (RRR(9).lt.(PROB1+PROB2+PROB3)) then
        ETA  =EXP(XL1*RRR(5)+XL0)
        CTHET=(1+EPS-ETA)
         xx=eps
         beta=sqrt(1d0-eps)
         xlog=-log((1+beta)**2/xx)
         xlog1=-log(16D0/xx)
          u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*rrr(5)
          cthet=-1D0/beta*(4D0*EXP(-SQRT(u))-1)

        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      elseIF    (RRR(9).lt.(PROB1+PROB2+PROB3+PROB4)) then
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
          n=1
          if(n.eq.1) then
         AM2SQX=AMS1/(1D0-RRr(5)*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQX=AMS1/sqrt(1D0-RRr(5)*(1-(ams1/ams2)**n))
          else
         AM2SQX=AMS1*(1D0-RRr(5)*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
        CTHET=AM2SQX-2D0+sqrt(1d0-eps)
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      else
        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
          n=1
          if(n.eq.1) then
         AM2SQX=AMS1/(1D0-RRr(5)*(1-(ams1/ams2)**n))
          elseif(n.eq.2) then
         AM2SQX=AMS1/sqrt(1D0-RRr(5)*(1-(ams1/ams2)**n))
          else
         AM2SQX=AMS1*(1D0-RRr(5)*(1-(ams1/ams2)**n))**(-1d0/n)
          endif
        CTHET=-AM2SQX+2D0-sqrt(1d0-eps)
        THET =ACOS(CTHET)
        PHI = 2*PI*RRR(6)
      endif
      if (cthet**2.gt.1d0) then
       cthet=cthet/cthet**2
       write(*,*) 'cthet error -- arbi action'
       write(*,*) cthet,rrr(5),rrr(9)
       write(*,*) ams1,ams2,am2sq
        THET =ACOS(CTHET)
      endif
      eta1=1+eps+cthet
      eta2=1+eps-cthet
      xx=eps
      beta=sqrt(1d0-eps)
      xx=eps
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      ct=-cthet

      xccos1=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))
      ct=cthet
      xccos2=beta/(xlog*xlog1
     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))

        ams1=1-sqrt(1d0-eps)
        ams2=3-sqrt(1d0-eps)
        n=1
        AM2SQX= CTHET+2D0-sqrt(1d0-eps)
        xj4=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
        n=1
        AM2SQX=-CTHET+2D0-sqrt(1d0-eps)
        xj5=am2SQX**(n+1)*n*(1D0/ams1**n-1D0/ams2**n)/2
       
      FF=PROB1/1d0+PROB2*xccos1+PROB3*xccos2+PROB4/XJ4+PROB5/XJ5
!        sum=Sum+1d0/FF
!        sum2=Sum2+1d0/FF**2
!        enddo
!        sum=sum/nn
!        sum2=sum2/nn
!        err=sqrt((sum2-sum**2)/nn)
!        write(*,*) sum,'+-',err
!        write(*,*) '1.00095748299256204 +- 0.14E-01'
!        stop
       if (ifprint.eq.1 ) then

      write(*,*) '     ff4=',prob1,prob2,prob3,prob4,prob5
      write(*,*) '         ',xccos1,xccos2,xj4,xj5
      write(*,*) '         ',cthet,ams1,ams2
       endif

      PHSPAC=PHSPAC/FF 

C-- angles for three:
      t=(amtau**2-am3**2)*(1d0-abs(cthet))
      rr3=rrr(3)
      rr4=rrr(4)
        prev=0.4d0
        if(gamro/amro.gt.0.5) prev=0.6d0
        if(gamrox.lt.0.) prev=0.6d0
        if (amp1.lt.0.3d-3) prev=0
!        if (amp1.lt.0.6d-3) prev=0
        IF(RRR(11).lt.PREV) then
!         EPS=(amp1*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
         EPS=((t+amp1)*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
!         EPS=(amp1*2*AM3/(AM3**2+AMP1**2))**2
         if (eps.ge.1d0) eps=.999d0
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         ETA  =EXP(XL1*RR3+XL0)
         CTHET=(1+EPS-ETA)
         xx=eps
         beta=sqrt(1d0-eps)
         xlog=-log((1+beta)**2/xx)
         xlog1=-log(16D0/xx)
!          u=(log((1D0+beta)/4D0))**2 +xlog*xlog1*rr3
!          cthet=-1D0/beta*(4D0*EXP(-SQRT(u))-1)

         if(idoub.eq.1.and.RRR(11).lt.PREV/2) CTHET=-cthet
         THET3 =ACOS(CTHET)
       if (ifprint.eq.1 ) then
         write(*,*) 'ff3 aaa',eps,eta,cthet
         write(*,*) '      t',t,amp1,am3,am2,amtau
       endif
        else
         CTHET=-1+2*rr3
         THET3 =ACOS(CTHET)
!         EPS=(amp1*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
         EPS=((t+amp1)*2*AM3/(AM3**2-AM2**2+AMP1**2))**2
!         EPS=(amp1*2*AM3/(AM3**2+AMP1**2))**2
         if (eps.ge.1d0) eps=.999d0
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         eta=1+eps-cthet
         if(idoub.eq.1) eta=1+eps+cthet
        endif

      xx=eps
      beta=sqrt(1d0-eps)
      xlog=-log((1+beta)**2/xx)
      xlog1=-log(16D0/xx)
      ct=cthet
      if(idoub.eq.1) ct=-cthet
!      xccos=beta/(xlog*xlog1
!     $     /log(4d0/(xx/(1d0+beta)+beta*(1D0-ct)))
!     $     /(4d0/(xx/(1d0+beta)+beta*(1D0-ct))))!!! +1d0/(1+beta*costhe))      
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         eta1=1+eps-cthet
         eta2=1+eps-cthet
         if(idoub.eq.1) eta2=1+eps+cthet
        xccos1=1D0/(XL1/2*ETA1)
        xccos2=1D0/(XL1/2*ETA2)
        PHSPAC=PHSPAC/(PREV/2*xccos1+PREV/2*xccos2+(1d0-prev)/1D0)
 
!        PHSPAC=PHSPAC/(PREV/(XL1/2*ETA)+(1d0-prev)/1D0)
        PHI3 = 2*PI*RR4
       if (ifprint.eq.1 ) then
       write(*,*) '  ff3,rr3',rr3
       write(*,*) '  ff3=',1/(XL1/2*ETA1),prev,cthet,idoub
       write(*,*) '  3ff=',eps,xccos1,xccos2
       endif

C-- angles for two: 
       if (ift.eq.1) then
        rr3=rrr(7)
        prev=0.3
        IF(RRR(13).lt.PREV) then
         EPS=(amp3*2*AM2/(AM2**2))**2
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         ETA  =EXP(XL1*RR3+XL0)
         CTHET=-(1+EPS-ETA)
         THET2 =ACOS(CTHET)
        elseIF(RRR(13).lt.2*PREV) then
         EPS=(amp3*2*AM2/(AM2**2))**2
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         ETA  =EXP(XL1*RR3+XL0)
         CTHET=(1+EPS-ETA)
         THET2 =ACOS(CTHET)
        else
         CTHET=-1+2*rr3
         THET2 =ACOS(CTHET)
        endif
         EPS=(amp3*2*AM2/(AM2**2))**2
         XL1=LOG((2+EPS)/EPS)
         XL0=LOG(EPS)
         eta1=1+eps+cthet
         eta2=1+eps-cthet
!       write(*,*) thet2, 1/(PREV/(XL1/2*ETA)+(1d0-prev)/1D0)
        PHSPAC=PHSPAC/( PREV/(XL1/2*ETA1)+PREV/(XL1/2*ETA2)
     $                +(1d0-2*prev)/1D0)
        PHI2 = 2*PI*RRR(8)
      if (ifprint.eq.1 ) then
      write(*,*) 'ff2=',1/(XL1/2*ETA1),1/(XL1/2*ETA2),prev
      write(*,*) '  ',cos(thet2),rr3,'<== rrr(7)'
      endif
        else
         THET2 =ACOS(-1.D0+2*RRR(7))
         PHI2 = 2*PI*RRR(8)
        PHSPAC=PHSPAC
        endif
C-- construction:
* two RESTFRAME, DEFINE PIPL AND PIM1
        ENQ1=(AM2SQ-AMP2**2+AMP3**2)/(2*AM2)
        ENQ2=(AM2SQ+AMP2**2-AMP3**2)/(2*AM2)
        PPI=         ENQ1**2-AMP3**2
        PPPI=SQRT(ABS(ENQ1**2-AMP3**2))
        PHSPAC=PHSPAC*(4*PI)*(2*PPPI/AM2)
* PIPL  MOMENTUM IN TWO REST FRAME,RRR(7),RRR(8)
        PIPL(1)=D0
        PIPL(2)=D0
        PIPL(3)=PPPI
        PIPL(4)=ENQ1
        CALL ROTPOD(THET2,PHI2,PIPL)
* PIM1 MOMENTUM IN TWO REST FRAME
        DO 30 I=1,3
 30     PIM1(I)=-PIPL(I)
        PIM1(4)=ENQ2
* three REST FRAME, DEFINE momentum of two
*       two  MOMENTUM
        PR(1)=0
        PR(2)=0
        PR(4)=1.D0/(2*AM3)*(AM3**2+AM2**2-AMP1**2)
        PR(3)= SQRT(ABS(PR(4)**2-AM2**2))
        PPI  =          PR(4)**2-AM2**2
*       PIM2 MOMENTUM
        PIM2(1)=0
        PIM2(2)=0
        PIM2(4)=1.D0/(2*AM3)*(AM3**2-AM2**2+AMP1**2)
        PIM2(3)=-PR(3)
        PHSPAC=PHSPAC*(2*PR(3)/AM3)
* PIPL PIM1 BOOSTED FROM two REST FRAME TO three REST FRAME
      EXE=(PR(4)+PR(3))/AM2
      CALL BOSTd3(EXE,PIPL,PIPL)
      CALL BOSTd3(EXE,PIM1,PIM1)

      PHSPAC=PHSPAC*(4*PI)
      CALL ROTPOd(THET3,PHI3,PIPL)
      CALL ROTPOd(THET3,PHI3,PIM1)
      CALL ROTPOd(THET3,PHI3,PIM2)
      CALL ROTPOd(THET3,PHI3,PR)
!      write(*,*) 'thet gen=',thet,eps,xl1,eta,cthet
C
* NOW TO THE  REST FRAME, DEFINE three AND PN MOMENTA
* three  MOMENTUM
      PAA(1)=0
      PAA(2)=0
      PAA(4)=1.D0/(2*AMTAU)*(AMTAU**2-AMNUTA**2+AM3**2)
      PAA(3)= SQRT(ABS(PAA(4)**2-AM3**2))
      PPI   =          PAA(4)**2-AM3**2
      PHSPAC=PHSPAC*(4*PI)*(2*PAA(3)/AMTAU)
* pn MOMENTUM
      PN(1)=0
      PN(2)=0
      PN(4)=1.D0/(2*AMTAU)*(AMTAU**2+AMNUTA**2-AM3**2)
      PN(3)=-PAA(3)
* Z-AXIS ANTIPARALLEL TO pn MOMENTUM
      EXE=(PAA(4)+PAA(3))/AM3
      CALL BOSTd3(EXE,PIPL,PIPL)
      CALL BOSTd3(EXE,PIM1,PIM1)
      CALL BOSTd3(EXE,PIM2,PIM2)
      CALL BOSTd3(EXE,PR,PR)
      call rotatv(-1,pn,PIPL,PIPL)
      call rotatv(-1,pn,PIM1,PIM1)
      call rotatv(-1,pn,PIM2,PIM2)
      call rotatv(-1,pn,PAA,PAA)
      call rotatv(-1,pn,pr,pr)
      call rotatv(-1,pn,PN,PN)
!      write(*,*) 'prod ff=',ff,xl1,eta1,eta2,eps,cthet
!      write(*,*) 'prod thet=',thet,cthet
      CALL ROTPOd(THET,PHI,PIPL)
      CALL ROTPOd(THET,PHI,PIM1)
      CALL ROTPOd(THET,PHI,PIM2)
      CALL ROTPOd(THET,PHI,PR)
      CALL ROTPOd(THET,PHI,PN)
      CALL ROTPOd(THET,PHI,PAA)
      DGAMT=PHSPAC
      END

      SUBROUTINE ROTPOd(THET,PHI,PP)
      IMPLICIT REAL*8 (A-H,O-Z)
C ----------------------------------------------------------------------
C
C ----------------------------------------------------------------------
      DIMENSION PP(4)
C
      CALL ROTOD2(THET,PP,PP)
      CALL ROTOD3( PHI,PP,PP)
      RETURN
      END
