c================= SEMIANALYTICAL FORMULAS ===========

      Function e1wan(e)
c **********************
C this function calculates  mass spectrum GeV**-1 of the
C single W. For initialization korwan should be called first.
c **********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      s1=e**2
      e1wan=s1wan(s1)*2*e
      END


      Function s1wan(s1)
c **********************
C this function calculates invariant mass**2 spectrum of the
C single W. For initialization korwan should be called first.
c **********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! The next 4 commons are input data for KORWAN
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / WEKIN2 / AMAW,GAMMW,DELTAR,ALPHAW    
      COMMON / DECDAT / amdumm(20), br(20), icdumm(20)
! This coomon can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      COMMON / decdatz / brz(20), icodz(20)
! This common sends rtesults back to KORWAN from its subprograms
      COMMON / GOUP / totfac,beti,xsmut0,dels,db
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT /
     $ XAMEL,XSVAR,XAMAZ,XGAMMZ,XAMAW,XGAMMW,XSINW2,XALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This PHOTONIC common sends internal parameters from KORWAN 
! to its subprograms
      COMMON / KORINT / vmin,vmax
      SAVE
! This common sends down stuff necessary for KORSAN extensions
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre

      EXTERNAL yfspho
      KEYMOD=KEYPHO
      KeyPre= KeyAcc
      IF (KMODE.NE.-2.AND.KMODE.NE.-1.AND.KMODE.NE.5) THEN
      WRITE(6,*) 'KORWAN not initialized lets stop in S1WAN'
      STOP
      ENDIF 
      kmode=-1
      sx1=s1
      KeyZet = MOD(KeyPhy,1000)/100
      KeyNLL = MOD(KeyRad,1000)/100

      brel=br(8)*sqrt(probw) 
      IF ( keydwm .EQ. 0) THEN
        dfwm=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwm=br (keydwm)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwm=brz(keydwm)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      ENDIF

      IF ( keydwp .EQ. 0 ) THEN
        dfwp=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwp=br (keydwp)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwp=brz(keydwp)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      
      ENDIF

      IF(KEYMOD.LT.0) THEN   ! diff. distrib.
        xsmut0=xsmuta(xsvar)
        akor = yfspho(vmin)
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSEIF(KEYMOD.EQ.0) THEN   ! born
        akor = xsmuta(xsvar)
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSE  
        IF(KEYPRE.EQ.1) THEN
          eeps= 1d-5*dfwm*dfwp   ! test    (time:    1.0)
          eeps= 1d-5*dfwm*dfwp   ! test    (time:    1.0)
          errabs= 3d-4*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.2) THEN
          eeps= 5d-6*dfwm*dfwp   ! normal  (time: *  4.5) 
          errabs= 1d-5*dfwm*dfwp   
        ELSEIF(KEYPRE.EQ.3) THEN
          eeps= 1d-6*dfwm*dfwp   ! high    (time: * 40.0)
          errabs= 1d-6*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.4) THEN
          eeps= 1d-7*dfwm*dfwp   ! super-high    (time: * 200)
          errabs= 1d-7*dfwm*dfwp 
        ENDIF

        vmiorg=vmin
        vmaorg=vmax

        ndiv=4
        dv=(vmaorg-vmiorg)/dble(ndiv)
        akor=0d0
        vvma=vmiorg

        DO 100 ncurr=1,ndiv

        vvmi=vvma
        vvma=vvmi+dv
        if(vvma.ge.vmaorg) vvma=vmaorg
cc        xsmut1=xsmuta(xsvar)
cc        xsmut0=xsmut1
        vmin=vvmi
        vmax=vvma

cc        CALL gausjd(yfspho,vvmi,vvma,eeps,res)
cc        CALL dgada3(vvmi,vvma,yfspho,eeps,res)
        res = gaus3(yfspho,vvmi,vvma,eeps)  
cc        xcr=res +totfac/beti*(vvma**beti-vvmi**beti)*xsmut1*(db+dels)
        xcr=res +totfac/beti*(vvma**beti-vvmi**beti)*xsmut0*(db+dels)
        akor=akor+xcr

        if(vvma.ge.vmaorg) goto 200
 100    continue
 200    continue
      ENDIF
      vmax=vmaorg
      vmin=vmiorg
      xsect=akor
      s1wan= xsect
      end

      Function testna(s1)
c ***********************
C this is temporary routine to be erased
c ***********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      common /glupi/ ss1
      COMMON / WEKING / ENE,AMAx,GAMMx,AMEx,AMFIN,XK0,SINxW2,IDE,IDF
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
  
      external testpod
      ss1=s1
      umi=0D0
      uma=4D0*ENE**2
      aa=0d0
      bb=4D0*ENE**2

      gm =amaw*gammw
      am2=amaw**2
      umi=1d0/gm* ( ATAN((aa-am2)/gm) )
      uma=1d0/gm* ( ATAN((bb-am2)/gm) ) 
      eeps=1d-8
      call dgadap(umi,uma,testpod,eeps,res)
      testna=res
      end

      function testpod(s2)
c ************************
C this is temporary routine to be erased
c ************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL

      common /glupi/ ss1 

      gmwm=gammw*amaw
      gmwm2=gmwm**2
      amw2=amaw**2
 
      ss2=GMWM*TAN(GMWM*s2)+AMW2
      gm =amaw*gammw
      am2=amaw**2
      testpod=s1s2wan(ss1,ss2)
     $       *((ss2-am2)**2+gm**2)
      end

      Function s1s2wan(s1,s2)
c **********************
C this function calculates invariant mass**2 double spectrum of the
C two W-s. For initialization korwan should be called first.
c **********************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! The next 4 commons are input data for KORWAN
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / WEKIN2 / AMAW,GAMMW,DELTAR,ALPHAW    
      COMMON / DECDAT / amdumm(20), br(20), icdumm(20)
! This coomon can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      COMMON / decdatz / brz(20), icodz(20)
! This common sends rtesults back to KORWAN from its subprograms
      COMMON / GOUP / totfac,beti,xsmut0,dels,db
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $ XAMEL,XSVAR,XAMAZ,XGAMMZ,XAMAW,XGAMMW,XSINW2,XALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This PHOTONIC common sends internal parameters from KORWAN 
! to its subprograms
      COMMON / KORINT / vmin,vmax
! This common sends down stuff necessary for KORSAN extensions
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre
      SAVE
      EXTERNAL yfspho
      KEYMOD=KEYPHO
      KeyPre= KeyAcc
      IF (KMODE.NE.-2.AND.KMODE.NE.-1.AND.KMODE.NE.5) THEN
      WRITE(6,*) 'KORWAN not initialized lets stop in S1S2WAN'
      STOP
      ENDIF 
      kmode=-2
      sx1=s1
      sx2=s2
      KeyZet = MOD(KeyPhy,1000)/100
      KeyNLL = MOD(KeyRad,1000)/100
      brel=br(8)*sqrt(probw) 
      IF ( keydwm .EQ. 0) THEN
        dfwm=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwm=br (keydwm)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwm=brz(keydwm)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      ENDIF

      IF ( keydwp .EQ. 0 ) THEN
        dfwp=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwp=br (keydwp)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwp=brz(keydwp)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      
      ENDIF

      IF(KEYMOD.LT.0) THEN   ! diff. distrib.
        xsmut0=xsmuta(xsvar)
        akor = yfspho(vmin)
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSEIF(KEYMOD.EQ.0) THEN   ! born
        akor = xsmuta(xsvar)
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSE  
        IF(KEYPRE.EQ.1) THEN
          eeps= 1d-5*dfwm*dfwp   ! test    (time:    1.0)
          eeps= 1d-5*dfwm*dfwp   ! test    (time:    1.0)
          errabs= 3d-4*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.2) THEN
          eeps= 5d-6*dfwm*dfwp   ! normal  (time: *  4.5) 
          errabs= 1d-5*dfwm*dfwp   
        ELSEIF(KEYPRE.EQ.3) THEN
          eeps= 1d-6*dfwm*dfwp   ! high    (time: * 40.0)
          errabs= 1d-6*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.4) THEN
          eeps= 1d-7*dfwm*dfwp   ! super-high    (time: * 200)
          errabs= 1d-7*dfwm*dfwp 
        ENDIF

        vmiorg=vmin
        vmaorg=vmax

        ndiv=4
        dv=(vmaorg-vmiorg)/dble(ndiv)
        akor=0d0
        vvma=vmiorg

        DO 100 ncurr=1,ndiv

        vvmi=vvma
        vvma=vvmi+dv
        if(vvma.ge.vmaorg) vvma=vmaorg
cc        xsmut1=xsmuta(xsvar)
cc        xsmut0=xsmut1
        vmin=vvmi
        vmax=vvma

cc        CALL gausjd(yfspho,vvmi,vvma,eeps,res)
cc        CALL dgada3(vvmi,vvma,yfspho,eeps,res)
        res = gaus3(yfspho,vvmi,vvma,eeps)  
cc        xcr=res +totfac/beti*(vvma**beti-vvmi**beti)*xsmut1*(db+dels)
        xcr=res +totfac/beti*(vvma**beti-vvmi**beti)*xsmut0*(db+dels)
        akor=akor+xcr

        if(vvma.ge.vmaorg) goto 200
 100    continue
 200    continue
      ENDIF
      vmax=vmaorg
      vmin=vmiorg
      xsect=akor

      s1s2wan= xsect
      end


c================= SEMIANALYTICAL FORMULAS ===========
c================= SEMIANALYTICAL FORMULAS ===========
      SUBROUTINE korwan(svar,vvmin,vvmax,keymod,keypre,xsect,errabs)
C     **************************************************************
! KORWAN is a semianalytical routine calculating total xsection 
! with and without bremsstrahlung. Based on formula by Muta et.al. 
! and LL third order exponentiated structure functions.
!---------------------------------------------------------------
!  INPUTS:
!    svar   = CMS energy squared [GeV]
!    vvmin  = minimal photon energy (in most cases should be set to 0d0)
!    vvmax  = maximal photon energy
!    keymod = type of ISR corrections requested
!      general
!          0 ....Born               
!        300 ....Zero   Order, YFS style
!        301 ....First  Order, YFS style
!        302 ....Second Order, YFS style
!        303 ....Third  Order, YFS style
!        502 ....Second Order, Gribov-Kuraev-Fadin style
!      technical tests on various components of KORALW matr. el.
!        310 ....First  Order Beta0
!        311 ....First  Order Beta1
!        320 ....Second Order Beta0
!        321 ....Second Order Beta1
!        322 ....Second Order Beta2
!    keypre = precision key
!        1,2,3   ..for Born
!        1,2,3,4 ..for bremsstrahlung
!    other inputs are sent from KORALW input routine via commons
!    see KORALW for further explanations
!      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
!      COMMON / WEKIN2 / AMAW,GAMMW,DELTAR,ALPHAW    
!      COMMON / DECDAT / amdumm(20), br(20), icdumm(20)
!      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
!      COMMON / MATPAR / pi,ceuler     
!      COMMON / PHYPAR / alfinv,gpicob     
!---------------------------------------------------------------
!  OUTPUT:
!    xsect  = cross-section in picobarns
!    errabs = absolute error in pbarns
!---------------------------------------------------------------

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! The next 4 commons are input data for KORWAN
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF  
      COMMON / WEKIN2 / AMAW,GAMMW,DELTAR,ALPHAW    
      COMMON / DECDAT / amdumm(20), br(20), icdumm(20)
! This coomon can be everywhere, contains various switches
      COMMON / KeyKey/  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      COMMON / WorZ   / probw,probz,ifwon,ifzon,ifWnow,icwm,icwp
      COMMON / decdatz / brz(20), icodz(20)
! This common sends rtesults back to KORWAN from its subprograms
      COMMON / GOUP / totfac,beti,xsmut0,dels,db
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $ XAMEL,XSVAR,XAMAZ,XGAMMZ,XAMAW,XGAMMW,XSINW2,XALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This PHOTONIC common sends internal parameters from KORWAN 
! to its subprograms
      COMMON / KORINT / vmin,vmax
! This common sends down stuff necessary for KORSAN extensions 
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre
 
      SAVE
      EXTERNAL yfspho

      KeyAcc = MOD(KeyMis,1000)/100
      IF(KeyAcc.NE.0) THEN
        WRITE(6,*)
     $     'KORWAN==> Sorry, no anomalous couplings today...'
        xsect=0d0 
        errabs=0d0
        RETURN  
      ENDIF

      kmode  = 5
      initre = 1

! mass average if requested
      IF(SVAR.LT.0D0) THEN
        kmode = 11
        SVAR =-SVAR
        WRITE(6,*)'KORWAN WARNING ::'
        WRITE(6,*)'KORWAN WARNING :: MASS AVERAGE BEING CALCULATED'
        WRITE(6,*)'KORWAN WARNING ::      it takes for ever,'
        WRITE(6,*)'KORWAN WARNING ::  have a cup of tea and relax'
        WRITE(6,*)'KORWAN WARNING ::'
      ENDIF

      XAMEL=AMEL
      XSVAR=SVAR
      XAMAZ=AMAZ
      XGAMMZ=GAMMZ
      XAMAW=AMAW
      XGAMMW=GAMMW
      XSINW2=SINW2
      XALPHAW=ALPHAW

      VMIN=VVMIN
      VMAX=VVMAX

      KeyAcc = KeyPre
      KeyZet = MOD(KeyPhy,1000)/100
      KeyNLL = MOD(KeyRad,1000)/100
      KeyCul = MOD(KeyRad,10000)/1000

      KeyPho = mod(KeyMod,10000)
      brel=br(8)*sqrt(probw) 
      IF ( keydwm .EQ. 0) THEN
        dfwm=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwm=br (keydwm)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwm=brz(keydwm)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      ENDIF

      IF ( keydwp .EQ. 0 ) THEN
        dfwp=sqrt(probw*ifwon+probz*ifzon)/brel
      ELSE
        if (ifWon.eq.1.and.ifZon.eq.0) then
         dfwp=br (keydwp)*sqrt(probw)/brel
        elseif(ifWon.eq.0.and.ifZon.eq.1) then  
         dfwp=brz(keydwp)*sqrt(probz)/brel
        else
         write(*,*) 'korwan: wrong ifWon,ifZon keydwm' 
        endif
      
      ENDIF

      IF(KEYpho.LT.0) THEN   ! diff. distrib.
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSEIF(KEYpho.EQ.0) THEN   ! born
        IF(KEYPRE.EQ.1) THEN
          errabs= 1d-5*dfwm*dfwp     ! test    (time:   1.0)  
        ELSEIF(KEYPRE.EQ.2) THEN
          errabs= 1d-6*dfwm*dfwp     ! normal  (time: * 2.5)  
        ELSEIF(KEYPRE.EQ.3) THEN
          errabs= 1d-7*dfwm*dfwp     ! high    (time: * 5.5)   
        ENDIF
      ELSE  
        IF(KEYPRE.EQ.1) THEN
          eeps= 1d-5*dfwm*dfwp   ! test    (time:    1.0)
          errabs= 3d-5*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.2) THEN
          eeps= 5d-6*dfwm*dfwp   ! normal  (time: *  4.5) 
          errabs= 1d-5*dfwm*dfwp   
        ELSEIF(KEYPRE.EQ.3) THEN
          eeps= 1d-6*dfwm*dfwp   ! high    (time: * 40.0)
          errabs= 1d-6*dfwm*dfwp    
        ELSEIF(KEYPRE.EQ.4) THEN
          eeps= 1d-7*dfwm*dfwp   ! super-high    (time: * 200)
          errabs= 1d-7*dfwm*dfwp 
        ENDIF
      ENDIF

      if(iabs(keymod).gt.10000) then   ! initialization only
        return     
      endif

      IF(KEYpho.LT.0) THEN   ! diff. distrib.
        akor = yfspho(vmin)
      ELSEIF(KEYpho.EQ.0) THEN   ! born
        akor = xsmuta(svar)
      ELSE  
        ndiv=4
        dv=(vvmax-vvmin)/dble(ndiv)
        akor=0d0
        vvma=vvmin

        DO 100 ncurr=1,ndiv

        vvmi=vvma
        vvma=vvmi+dv
        if(vvma.ge.vvmax) vvma=vvmax

        VMIN=VVMI
        VMAX=VVMA

c        CALL gausjd(yfspho,vvmi,vvma,eeps,res)
        CALL dgada3(vvmi,vvma,yfspho,eeps,res)
c        res = gaus3(yfspho,vvmi,vvma,eeps)  
        xcr=res +totfac/beti*(vvma**beti-vvmi**beti)*xsmut0*(db+dels)
        akor=akor+xcr

        if(vvma.ge.vvmax) goto 200
 100    continue
 200    continue

        vmin=vvmin
        vmax=vvmax

      ENDIF
      vmin=vvmin
      vmax=vvmax
 5    xsect=akor
      END


      function vvyfs(vvar)
C     *******************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends down stuff necessary for KORSAN extensions
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre
      xsect = yfspho(vvar)
      if(kmode.eq.21)then
        xsect = xsect
      elseif(kmode.eq.22)then
        xsect = xsect*vvar
      elseif(kmode.eq.23)then
        xsect = xsect*vvar**2
      elseif(kmode.eq.24)then
        xsect = xsect*vvar**3
      else
        write(6,*)'vvyfs==> Wrong mode:',kmode
        stop
      endif
      vvyfs=xsect
      end

      FUNCTION xsmuta(ssact)
!     **********************
! integrated total xsect from Muta et.al.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This common sends internal parameters from XSMUTA to its subprograms
      COMMON / XMUINT / ssvar
! This common sends down stuff necessary for KORSAN extensions
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre
      EXTERNAL d1muta
      SAVE

      ssvar=ssact
      aa=0d0
      bb=ssact

! change of vars
      gm =amaw*gammw
      am2=amaw**2
      umi=1d0/gm* ( ATAN((aa-am2)/gm) )
      uma=1d0/gm* ( ATAN((bb-am2)/gm) ) 

      IF(KEYACC.EQ.1) THEN
        eeps= 1d-6*dfwm*dfwp   ! test  
      ELSEIF(KEYACC.EQ.2) THEN
        eeps= 1d-8*dfwm*dfwp   ! normal
      ELSEIF(KEYACC.EQ.3.or.KEYACC.EQ.4) THEN
        eeps= 1d-9*dfwm*dfwp   ! high
      ENDIF
       IF (KMODE.EQ.-2) THEN
         xsmuta=f2muta(sx1,sx2) 
       ELSEIF (KMODE.EQ.-1) THEN
         xsmuta=f1muta(sx1)
       ELSE
c         xsmuta=gaus(d1muta,umi,uma,eeps)  
         CALL dgada2(umi,uma,d1muta,eeps,xsmuta)
       ENDIF
      END

      FUNCTION f2muta(xs1,xs2)
!     *******************
! one dimensional diff. xsect from muta et.al.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends internal parameters from XSMUTA to its subprograms
      COMMON / XMUINT / ssvar
! This common sends internal parameters from D1MUTA to its subprograms
      COMMON / D1MUIN / s1
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
      EXTERNAL D2MUTA
      SAVE

      IF (XS1.LT.SVAR) THEN
      GM =AMAW*GAMMW
      AM2=AMAW**2
      S1=xs1
      s2=xs2
! change of vars
      U=1D0/GM* ( ATAN((s2-AM2)/GM) )

      result=d2muta(u)
      ELSE
      result=0d0
      ENDIF

      f2muta =result
     $          /((s2-am2)**2+gm**2)  ! JACOBIAN

      END

      FUNCTION f1muta(xs1)
!     *******************
! one dimensional diff. xsect from muta et.al.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends internal parameters from XSMUTA to its subprograms
      COMMON / XMUINT / ssvar
! This common sends internal parameters from D1MUTA to its subprograms
      COMMON / D1MUIN / s1
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
      EXTERNAL D2MUTA
      SAVE

      IF (XS1.LT.SSVAR) THEN
      GM =AMAW*GAMMW
      AM2=AMAW**2
      S1=xs1
      AA=0D0
      BB=(SQRT(SSVAR)-SQRT(S1))**2
! change of vars
      UMI=1D0/GM* ( ATAN((AA-AM2)/GM) )
      UMA=1D0/GM* ( ATAN((BB-AM2)/GM) ) 
! change of vars

      IF(KEYACC.EQ.1) THEN
        eeps= 1d-9*dfwm*dfwp   ! test  
      ELSEIF(KEYACC.EQ.2) THEN
        eeps= 1d-11*dfwm*dfwp   ! normal 
      ELSEIF(KEYACC.EQ.3.or.KEYACC.EQ.4) THEN
        eeps= 1d-13*dfwm*dfwp   ! high, long run
      ENDIF

      call dgadap(umi,uma,d2muta,eeps,result)
      ELSE
      result=0d0
      ENDIF

      f1muta =result
     $          *((s1-am2)**2+gm**2)  ! JACOBIAN
      f1muta =result
      END

      FUNCTION d1muta(u)
!     *******************
! one dimensional diff. xsect from muta et.al.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends internal parameters from XSMUTA to its subprograms
      COMMON / XMUINT / ssvar
! This common sends internal parameters from D1MUTA to its subprograms
      COMMON / D1MUIN / s1
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
      EXTERNAL D2MUTA
      SAVE


      GM =AMAW*GAMMW
      AM2=AMAW**2
      S1=GM*TAN(GM*U)+AM2
      AA=0D0
      BB=(SQRT(SSVAR)-SQRT(S1))**2
! change of vars
      UMI=1D0/GM* ( ATAN((AA-AM2)/GM) )
      UMA=1D0/GM* ( ATAN((BB-AM2)/GM) ) 
! change of vars

      IF(KEYACC.EQ.1) THEN
        eeps= 1d-9*dfwm*dfwp   ! test  
      ELSEIF(KEYACC.EQ.2) THEN
        eeps= 1d-11*dfwm*dfwp   ! normal 
      ELSEIF(KEYACC.EQ.3.or.KEYACC.EQ.4) THEN
        eeps= 1d-13*dfwm*dfwp   ! high, long run
      ENDIF

      call dgadap(umi,uma,d2muta,eeps,result)
c      result=gaus(d2muta,umi,uma,eeps)  

      d1muta =result
     $          *((s1-am2)**2+gm**2)  ! JACOBIAN

      END


      FUNCTION d2muta(u)
C     *******************
C TWO DIMENSIONAL DIFF. XSECT FROM MUTA et.al.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / MATPAR / pi,ceuler     
      COMMON / PHYPAR / alfinv,gpicob     
! This common sends internal parameters from XSMUTA to its subprograms
      COMMON / XMUINT / ssvar
! This common sends internal parameters from D1MUTA to its subprograms
      COMMON / D1MUIN / s1
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This common sends down stuff necessary for KORSAN extensions
! and reinitialisation of KORWAN 
      Common /wansan/ sx1,sx2,kmode,initre

      SAVE
      data init / 1 /

      IF( init.eq.1 .or. ssvar.ne.sold .or. initre.eq.1) THEN
        sold   = ssvar
        init   = 0
        initre = 0

        e2 = 4*pi*alphaw
        g2 = e2/sinw2
        g2e2=g2*e2/2d0
        g4=g2**2/8d0
        a=1-4*sinw2
        b=-1
        a2b2=a**2+b**2
        amb=a-b

        gmw =gammw/amaw
        gmwm=gammw*amaw
        gmwm2=gmwm**2
        amw2=amaw**2

        gennor=(g2/(4*pi)/12d0)**2*gpicob/pi**2/(64*pi)
     $            *(-2d0)/ssvar**2*dfwm*dfwp

        IF( keyzet .eq. 0) THEN
          bwz=(ssvar-amaz**2)**2 +(ssvar/amaz*gammz)**2
        ELSEIF( keyzet .EQ. 1) THEN
          bwz=(ssvar-amaz**2)**2 +(amaz*gammz)**2
        ELSEIF( keyzet .EQ. 2) THEN
          bwz=(ssvar-amaz**2)**2 
        ELSE
          write(6,*)'d2muta==> wrong keyzet:',keyzet
        ENDIF
        bwzre=(ssvar-amaz**2)

        gaa = e2**2/ssvar**2
        gzz=g4/2d0 *a2b2/bwz
        gaz=g2e2   *a*bwzre/bwz/ssvar 
        gnn=g4 
        gnz=-g4     *amb*bwzre/bwz
        gna=-g2e2   /ssvar

        cngg1=(gaa+gzz+gaz)*gennor
        cngg2=(gnn)*gennor
        cngg3=(gnz+gna)*gennor
      ENDIF

C.. change of vars
      S2=GMWM*TAN(GMWM*U)+AMW2
C.. change of vars

      S1S2=S1*S2      
      S1pS2=S1+S2       
      SmS=ssvar-S1pS2

! Ad hoc correction S.J.
      IF(s2 .LT. 0d0 ) THEN
        d2muta=0d0
c[[[[[
c        write(6,*) 'd2muta <2> u,s2=',u,s2
c        write(6,*) 'd2muta <2> GMWM,AMW2=',GMWM,AMW2
c]]]]]
        RETURN
      ENDIF


      IF( (sqrt(ssvar)-sqrt(s1)-sqrt(s2)).le.0d0) THEN
        d2muta=0d0
        RETURN
c        wlambd=0d0
c        sqrwla=0d0
c        flog=0d0
      ELSE
!        WLAMBD=(SmS)**2 -4*S1S2
        WLAMBD=MAX(0d0,(SmS)**2 -4*S1S2)
c        IF(WLAMBD.LT.0D0) WRITE(6,*)'WLAMBD=',WLAMBD
c        IF(WLAMBD.LT.0D0) WRITE(6,*)sqrt(s2),sqrt(ssvar)-sqrt(s1)
        SQRWLA=DSQRT(WLAMBD)
        IF(s1s2.gt.0d0.and.SmS.GT.SQRWLA) THEN
          FLOG= S1S2*DLOG ((SmS-SQRWLA) / (SmS+SQRWLA)) 
        ELSE
          FLOG= 0D0
        ENDIF
      ENDIF

      GG1= -WLAMBD*SQRWLA* ( WLAMBD/6D0 +2*(ssvar*(S1pS2)+  S1S2) )
      GG2= -SQRWLA* ( WLAMBD/6D0 +2*(ssvar*(S1pS2)-4*S1S2) )
     &     +4*(SmS)*FLOG
      GG3= -SQRWLA* ( 
     &               WLAMBD/6D0*(ssvar+11*S1pS2)
     &         +2*(S1**2 +3*S1S2 +S2**2)*ssvar -2*(S1**3 +S2**3) 
     &               )
     &    -4*(ssvar*(S1pS2)+S1S2)*FLOG


c from Manel Martinez
c      GG3MM= -SQRWLA*(ssvar-S1-S2)* ( WLAMBD/6D0
c     &              +2*(S1*S2+ssvar*S1+ssvar*S2)
c     &                           )
c     &    -4*S1*S2*(ssvar*(S1+S2)+S1*S2)*FLOG

      D2MUTA=( CNGG1*GG1 +CNGG2*GG2 +CNGG3*GG3) 
     &        /((S1-AMW2)**2+(S1*GMW)**2)  ! breit-wigner
     &        /((S2-AMW2)**2+(S2*GMW)**2)  ! breit-wigner
     &        *((S2-AMW2)**2+GMWM2)     ! JACOBIAN
      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!  average mass   
      if(kmode.eq.11) then
        d2muta=d2muta*( sqrt(s1)+sqrt(s2)-2*amaw )
      elseif(kmode.eq.12) then
        d2muta=d2muta*( sqrt(s1)+sqrt(s2)-2*amaw )**2
      elseif(kmode.eq.13) then
        d2muta=d2muta*( sqrt(s1)+sqrt(s2)-2*amaw )**3
      elseif(kmode.eq.14) then
        d2muta=d2muta*( sqrt(s1)+sqrt(s2)-2*amaw )**4
      endif
!!!!!!!  average mass   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Coulomb on top 
      cul1=culsan(ssvar,s1,s2)
      d2muta = d2muta*cul1

      END


      FUNCTION xsbrem(svar)
c     ccccccccccccccccccccccc
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / PHODIS / keypho
      SAVE

      KEYMOD=KEYPHO
      KEYPRE=2
      
      VVMI=0D0
      XSTOT=0D0
      DO vvma=0.25d0,1.001d0,.25d0
         call korwan(svar,vvmi,vvma,keymod,keypre,res,errabs)
         VVMI=VVMA
         xstot=xstot+res
      ENDDO
      xsbrem=xstot
      END

      FUNCTION yfspho(vv)
!     ************************************************
! for negative KEYPHO vv*D\otimes D*xsmuta is returned
! = differential distribution d sigma/ d log v
!     ************************************************
!          0 ....Born               
!        300 ....Zero   Order, YFS style
!        301 ....First  Order, YFS style
!        302 ....Second Order, YFS style
!        303 ....Third  Order, YFS style
!        502 ....Second Order, Gribov-Kuraev-Fadin style
!      technical tests on various components of KORALW matr. el.
!        310 ....First  Order Beta0
!        311 ....First  Order Beta1
!        320 ....Second Order Beta0
!        321 ....Second Order Beta1
!        322 ....Second Order Beta2
!     ************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  

      COMMON / GOUP / totfac,beti,xsmut0,dels,db
      COMMON / MATPAR / pi,ceuler     
      COMMON / PHYPAR / alfinv,gpicob     
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL
! This PHOTONIC common sends internal parameters from KORWAN 
! to its subprograms
      COMMON / KORINT / vmin,vmax
      Common /wansan/ sx1,sx2,kmode,initre
      SAVE
      data init / 1 /

      IF( init.eq.1 .or. svar.ne.sold .or. vmin.ne.vmiold 
     &   .or. keyNLL.ne.knlold .or. initre.eq.1) THEN
        init=0
        sold=svar
        vmiold=vmin
        knlold=keyNLL
        alf1   = 1d0/pi/alfinv
        bilg   = dlog(svar/amel**2)
        beti   = 2d0*alf1*(bilg-1d0)
        IF(    KeyNLL .EQ. 0) THEN
           delb = 1/4d0*beti  
        ELSEIF(KeyNLL .EQ. 1) THEN
           delb = 1/4d0*beti  +alf1*(-0.5d0  +pi**2/3d0)        
        ELSE
           WRITE(6,*) '++++ STOP in yfspho, KeyNLL= ',KeyNLL
           STOP
        ENDIF
        gamfac = exp(-ceuler*beti)/dpgamm(1d0+beti)          
        totfac = beti*gamfac*exp(delb)
        xsmut0 = xsmuta(svar*(1-vmin))
      ENDIF

      sprim=svar*(1-vv)
      IF( vv .GT. 1d0) THEN
        write(6,*)'WARNING YFSPHO==> 1-vv<0 ',1-vv,', vv set to 1'
        yfspho=0d0
        RETURN
!        vv=1d0
!        sprim=0d0
      ENDIF
      IF( vv .LT. 0d0) THEN
        write(6,*)'WARNING YFSPHO==> 1-vv>1 ',1-vv,', vv set to 0'
        yfspho=0d0
        RETURN
!        vv=0d0
!        sprim=svar
      ENDIF
      born = xsmuta(sprim)


      IF(KEYPHO.GE.0) THEN     
        keypht = keypho
        yfs  = totfac*vv**(beti-1d0) 
      ELSE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! WATCH OUT:  1/VV removed for negative KEYPHO !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        yfs  = totfac*vv**beti 
        xsmut0 = 0d0
        keypht = -keypho
      ENDIF
!---------------------------------------------------------------
! ....Zero   Order               
      IF(KEYPHT  .EQ.300)  THEN 
        db = 1d0        
        dels = 0d0           
        delh = -beti/4d0 *log(1-vv)          
!---------------------------------------------------------------
! ....First  Order               
      ELSEIF(KEYPHT  .EQ.301)  THEN           
        db = 1d0        
        dels = beti/2d0        
        delh = vv*(-1 +vv/2d0)            
     $      -beti/2d0*vv**2 - beti/4d0*(1-vv)**2*log(1-vv)           
!---------------------------------------------------------------
!-- Second COMPLETE, YFS style (from yfs3mod.f)
      ELSEIF(KEYPHT  .EQ.302)  THEN           
        db = 1d0
        dels = beti/2d0  +1/8d0*beti**2
        delh = vv*(-1 +vv/2d0) 
     $   +0.5d0*beti*(-0.25d0*(4d0-6d0*vv+3d0*vv**2)*dlog(1d0-vv) -vv)
!---------------------------------------------------------------
!-- Third COMPLETE, YFS style 
      ELSEIF(KEYPHT  .EQ.303)  THEN           
        db = 1d0
        ds1= beti/2d0 
        ds2=            1/8d0*beti**2 
        ds3=                           1/48d0*beti**3

        dh0=   vv*(-1 +vv/2d0)
        dh1= beti*( -(1d0+3d0*(1d0-vv)**2)/8d0*dlog(1d0-vv)
     @                 -.25d0*vv**2   )
        dh2= beti**2*( 0
     @                 +(3d0*vv-2d0)*vv/16*dlog(1d0-vv)
     @                 +(8d0-14d0*vv+7d0*vv**2)/96*dlog(1d0-vv)**2
     @                 +vv**2/8d0
     @                 +(2d0-vv)*vv/8*dilogy(vv)  
     @               )
        dels = ds1 +ds2 +ds3 
        delh = dh0*(1+ds1+ds2) +dh1*(1+ds1) +dh2
!---------------------------------------------------------------
!-- First  Order Beta0 
      ELSEIF(KEYPHT  .EQ.310)  THEN 
        db = 1d0        
        dels = beti/2d0        
        delh = -beti/4d0 *log(1-vv)   
!---------------------------------------------------------------
!-- First  Order Beta1
      ELSEIF(KEYPHT  .EQ.311)  THEN           
        db = 0d0        
        dels = 0d0        
        delh =    
     $        vv*(-1d0+vv/2d0/(1+beti))*(1-0.5*beti*log(1-vv))
!---------------------------------------------------------------
!-- Second Beta0 
      ELSEIF( KEYPHT .EQ. 320) THEN       
         db = 1d0        
         dels = beti/2d0  +beti**2/8d0             
         delh = -beti/4d0 *log(1-vv)   
!---------------------------------------------------------------
!-- Second  Order Beta1
      ELSEIF(KEYPHT  .EQ.321)  THEN           
        db = 0d0        
        dels = 0d0        
        delh = vv*(-1+vv/2d0)         
     $      -beti*vv/2 -beti*vv**2/4 +beti/8*(-2+6*vv-3*vv**2)*log(1-vv)
!---------------------------------------------------------------
!-- Second  Beta2 
      ELSEIF( KEYPHT .EQ. 322)  THEN     
        db = 0d0        
        dels = 0d0        
        delh =    beti*  vv**2/4d0  
!---------------------------------------------------------------
!-- First COMPLETE, Gribov-Kuraev-Fadin style
!---This is added in artificial manner but numerically should be OK
      ELSEIF(KEYPHT  .EQ.501)  THEN
        totfac = beti
        dels   = 0d0
        db = gamfac*exp( 3/4d0 *beti)
        z=1-vv
        delh= -1/2d0*(1d0+z)
        delh=delh/vv**(beti-1d0)
!---------------------------------------------------------------
!-- Second COMPLETE, Gribov-Kuraev-Fadin style
!---This is added in artificial manner but numerically should be OK
      ELSEIF(KEYPHT  .EQ.502)  THEN
        totfac = beti
        dels   = 0d0
        db = gamfac*exp( 3/4d0 *beti)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!       DELH=  -ALF1*(1D0+Z)*(BILG-1D0)    
!    $      +ALF1**2*( -(1D0+Z*Z)/VV     *DLOG(Z)                
!    $              +(1D0+Z)*(0.5D0*DLOG(Z)-2D0*DLOG(VV))        
!    $              -2.5D0-0.5D0*Z)*BILG**2    
!       DISTR=  BETI*VV**(BETI-1D0)*( 1D0+DELVS) +DELH          
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        z=1-vv
        delh= -1/2d0*(1d0+z)
     $        +1/4d0*beti*( -(1d0+z*z)/vv     *dlog(z)                
     $                +(1d0+z)*(0.5d0*dlog(z)-2d0*dlog(vv))        
     $                 -2.5d0-0.5d0*z)
        delh=delh/vv**(beti-1d0)
      ELSE
        write(6,* ) '+++++ STOP in YFSPHO, wrong KEYPHO=',KEYPHT
      ENDIF        

      yfspho= yfs*(  (db+dels+delh)*born -(db+dels)*xsmut0  )
!----------------------------------------------------------------   
      END

      FUNCTION culsan2(s,s1,s2)
!     **************************
! Coulomb effect from Fadin, Khoze, Martin, Stirling, dtp/95/64
! first order, eq. 9

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / MATPAR / pi,ceuler     
      COMMON / PHYPAR / alfinv,gpicob     
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL

      p=sqrt( 1/(4*s)*( s**2 -2*s*(s1+s2) +(s1-s2)**2 ) )
      e=(s-4*amaw**2)/(4*amaw)
      sqeg= sqrt(e**2+gammw**2)

      rek =sqrt( amaw/2*( sqeg -e ) )
      abk2 =amaw*sqeg

      culsan2=1+sqrt(s)/alfinv/4/p *(pi-
     $          2*datan( (abk2 -p**2)/2/p/rek ) )
      end

      FUNCTION culsan(s,s1,s2)
!     **************************
! Coulomb effect from Fadin, Khoze, Martin, Stirling, dtp/95/64
! first order, eq. 9

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  

      COMMON / MATPAR / pi,ceuler     
      COMMON / PHYPAR / alfinv,gpicob     
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KEYPHO,KEYCUL

      if(keycul.eq.0) then
        culsan = 1d0
      elseif(keycul.eq.1) then
        pp = 1/(4*s) *( s**2 -2*s*(s1+s2) +(s1-s2)**2 )
        p  = dsqrt(pp)
        en = (s-4*amaw**2)/(4*amaw)
        ddee = dsqrt(en**2+gammw**2)
        p1 = dsqrt( amaw/2d0 *( ddee -en ) )
        p2 = dsqrt( amaw/2d0 *( ddee +en ) )
        dabskap2 = amaw *ddee
        drekap  =  p1
        dimkap  = -p2

        ff = 1 +sqrt(s)/(4*p*alfinv) 
     $           *( pi -2*datan( (dabskap2 -pp)/(2*p*drekap) ) )   

        culsan = ff -1  ! <========!!!!!!!!!
        culsan = ff
      else
        write(6,*) ' culSAN==> wrong keycul=',keycul
        stop
      endif
      end

c================= END SEMIANALYTICAL FORMULAS ===========
c================= END SEMIANALYTICAL FORMULAS ===========
c================= END SEMIANALYTICAL FORMULAS ===========


      SUBROUTINE MAVRG(SVAR,KEYPHO,kaccbre,dmavrg,dmerr)
C     *************************************************
! does average mass calculation, ie
! < sqrt(s1)+sqrt(s2) -2amaw > / sigma_tot
C     *************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
! This common sends external parameters from KORWAN to its subprograms
      COMMON / KOREXT / 
     $   AMEL,SsVAR,AMAZ,GAMMZ,AMAW,GAMMW,SINW2,ALPHAW,DFWM,DFWP
     $ ,KEYZET,KEYACC,KEYNLL,KkEYPHO,KEYCUL
      SAVE

      CALL KORWAN(SVAR,0D0,1D0, KEYPHO,KACCBRE,XSECT,ERRABS)

      CALL KORWAN(-SVAR,0D0,1D0, KEYPHO,KACCBRE,dmSECT,Eps)
      dmavrg = dmSECT/XSECT/sqrt(svar)
      dmerr  = ( (eps*xsect) +(errabs*dmsect) )
     $                             /xsect**2 / sqrt(svar)
      END

      SUBROUTINE MLOSS(SVAR,KEYPHO,eeps,VVLOSS,VVERR)
C     *************************************************
! does average mass loss calculation, ie.
! sqrt(s)/2 < v > / sigma_tot
C     *************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      SAVE
c .. communicates with vvyfs
      common / vlos / ssvar,keyph,kaccborn
      external vxyfs
      ssvar = svar
      keyph = keypho
      kaccborn = 3

      kaccbre = 4
      CALL KORWAN(SVAR,0D0,1D0, KEYPHO,KACCBRE,XSECT,ERRABS)

      eps=eeps*2/sqrt(svar)*xsect
      CALL KORWAN(SVAR,0D0,1D0, 0,kaccborn,XS,ER)
      if(eps.lt.0.1d0*er) eps=0.1d0*er

      call dgada3(0d0,1d0,vxyfs,eps,vvsect)
      VVLOSS = SQRT(SVAR)/2D0 *VVSECT/XSECT
      VVERR  = SQRT(SVAR)/2D0 *sqrt( (eps*xsect)**2 
     $                     +(errabs*vvsect)**2 
     $                             )/xsect**2
      END


      function vxyfs(vvar)
C     *******************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      common / vlos / svar,keypho,keyacc
      save
      CALL KORWAN(SVAR,VVAR,VVDUM,-KEYPHO,KEYACC,XSECT,ERRABS)
      vxyfs = xsect
      end

